create or replace PROCEDURE CONSUMO_PLANEJADO_PME
  (P_CDFILCENTPME IN VARCHAR2,
   P_CDTIPOCARD   IN VARCHAR2,
   P_CDFILIAL     IN VARCHAR2,
   P_CDSERVFILI   IN VARCHAR2,
   P_DTINICIAL    IN DATE,
   P_DTFINAL      IN DATE,
   P_IDARQUIVO    IN VARCHAR2,
   P_IDPRODUTOS   IN VARCHAR2,
   P_IDSEPPRATO   IN VARCHAR2,
   P_PEACRESCIMO  IN NUMBER,
   P_IDARREDOND   IN VARCHAR2,
   P_NRCONSPLAN   IN VARCHAR2,
   P_CDPRODUTOINI IN VARCHAR2,
   P_CDPRODUTOFIN IN VARCHAR2,
   P_CDOPERADOR   IN VARCHAR2)
IS
   V_ARRED         NUMBER;
   V_IDCARDAPIO    VARCHAR2(1);
   V_IDCONSFIXO    VARCHAR2(1);
   V_IDCONSPERC    VARCHAR2(1);
   V_CDFAPRATCPLA  CONSPLAN.CDFAPRATCPLA%TYPE;
   V_CDPRATCONSPL  CONSPLAN.CDPRATCONSPL%TYPE;
   V_CDSETOCONSPL  CONSPLAN.CDSETOCONSPL%TYPE;
   V_CDTPPRATCPLA  CONSPLAN.CDTPPRATCPLA%TYPE;
   V_QTCOMESTICAR  CARDADIA.QTCOMESTICAR%TYPE;
   V_QTPRATO       NUMBER;
   V_FERIADO       NUMBER;
   V_QTPREV        NUMBER;
   V_QTPREV1       NUMBER;
   V_QTPREV2       NUMBER;
   V_QTPREV3       NUMBER;
   V_QTPREV4       NUMBER;
   V_CDTCACONSPER  VARCHAR2(10);
   V_CDTCACONSFIX  VARCHAR2(10);
   V_TPCARDCONSFIX VARCHAR2(10);
   V_IDPRODNAREQPREV VARCHAR2(1);
   V_PERCACRES     NUMBER;
   V_CDPRODUTO_ATUAL    CONSPLAN.CDPRODCPLA%TYPE;
   V_CDPRATO_ATUAL      CONSPLAN.CDPRATCONSPL%TYPE;
   V_CDFILAUXPRAT_ATUAL CONSPLAN.CDFAPRATCPLA%TYPE;
   V_QTPRODUTO          CONSPLAN.QTCONSPLAN%TYPE;
   V_QTPRODUTO_ARRED CONSPLAN.QTCONSPLAN%TYPE;
   V_CDAPRERECE_ATUAL   CONSPLAN.CDAPRECONSPL%TYPE;
   V_VRPECONSCPME_ATUAL   CONSPLAN.VRPECONSPLAN%TYPE;
   V_VRARREDREQ         PRODUTO.VRARREDREQ%TYPE;
   V_VRARREDCMP         PRODUTO.VRARREDCMP%TYPE;
   V_NRCARDIAPME VARCHAR2(20);
   V_IDTIPOCONPME NUMBER;
   QT_DIA_SEM_CONSUMO NUMBER;
   CONSUMO_F VARCHAR2(1);
   CONSUMO_P VARCHAR2(1);
   V_EXISTE_TIPOCARD NUMBER;
BEGIN
   /* --------------- IDENTIFICADORES DE CLCULO ------------------- */
   V_IDCARDAPIO := SUBSTR(P_IDPRODUTOS, 1, 1);  /* CARDPIO          */
   V_IDCONSFIXO := SUBSTR(P_IDPRODUTOS, 2, 1);  /* CONSUMO FIXO      */
   V_IDCONSPERC := SUBSTR(P_IDPRODUTOS, 3, 1);  /* CONSUMO PERCAPITA */
   /* -- CALCULO DOS PRODUTOS DOS CARDAPIOS -- */
   IF (V_IDCARDAPIO = 'C') THEN
      FOR C_CARDAPIO IN (
         SELECT CD.CDFILCENTPME, CD.NRCARDPME,   CD.NRCARDIAPME,  CD.CDSERVFILI,
                CD.CDFILIAL,     CD.DTCARDIAPME, CD.QTCOMESTCPME, CD.IDCARDESPEC,
                C.CDTIPOCARD
           FROM CARDAPIOPME C, CARDIAPME CD, FILIAL F, FILITIPOCARD TC, SERVTIPOCARD ST
          WHERE (C.CDFILCENTPME = P_CDFILCENTPME)                            AND
                (INSTR(NVL(P_CDTIPOCARD, C.CDTIPOCARD), C.CDTIPOCARD) > 0)   AND
                (INSTR(NVL(P_CDFILIAL, CD.CDFILIAL), CD.CDFILIAL) > 0)       AND
                (C.CDFILCENTPME = CD.CDFILCENTPME)                           AND
                (C.NRCARDPME    = CD.NRCARDPME)                              AND
                (CD.CDFILIAL    <> CD.CDFILCENTPME)                          AND
                (INSTR(NVL(P_CDSERVFILI, CD.CDSERVFILI), CD.CDSERVFILI) > 0) AND
                (F.CDFILCENTPME = C.CDFILCENTPME)                            AND
                (F.CDFILIAL     = CD.CDFILIAL   )                            AND
                (CD.DTCARDIAPME BETWEEN P_DTINICIAL AND P_DTFINAL)           AND
                (TC.CDFILCENTPME = C.CDFILCENTPME)                           AND
                (TC.CDTIPOCARD   = C.CDTIPOCARD)                             AND
                (TC.CDFILIAL     = CD.CDFILIAL)                              AND
                (ST.CDFILCENTPME = C.CDFILCENTPME)                           AND
                (ST.CDTIPOCARD = C.CDTIPOCARD)                               AND
                (ST.CDSERVFILI = CD.CDSERVFILI)                              AND
                (TC.IDTCARATFILI = 'S')
         ORDER BY CD.CDFILIAL, CD.CDSERVFILI, CD.DTCARDIAPME)
      LOOP
         V_NRCARDIAPME := C_CARDAPIO.NRCARDIAPME; /*O CURSOR ACIMA TRAS O NUMERO DO CARDAPIO DO DIA DA FILIAL POR PADRAO, CASO O CARDAPIO NAO SEJA ESPECIFICO, BUSCA NA QUERY ABAIXO O NUMERO DO CARDAPIO DA CENTRAL PARA BUSCAR OS PRATOS*/
         IF C_CARDAPIO.IDCARDESPEC = 'N' THEN 
            BEGIN
               SELECT MAX(NRCARDIAPME) AS NRCARDIAPME
                 INTO V_NRCARDIAPME
                 FROM CARDIAPME  
                WHERE CDFILCENTPME = C_CARDAPIO.CDFILCENTPME AND
                      NRCARDPME = C_CARDAPIO.NRCARDPME AND
                      DTCARDIAPME = C_CARDAPIO.DTCARDIAPME AND
                      CDSERVFILI = C_CARDAPIO.CDSERVFILI AND
                      CDFILIAL = CDFILCENTPME;
            EXCEPTION
            WHEN NO_DATA_FOUND THEN V_NRCARDIAPME := C_CARDAPIO.NRCARDIAPME;
            END;       
         END IF;

         /* ---- LOOP PARA CALCULO DOS CARDAPIOS ---- */
         IF (C_CARDAPIO.QTCOMESTCPME <> 0) THEN  /* NAO CALCULA PRATOS PARA COMENSAIS IGUAL A ZERO */

            V_CDPRODUTO_ATUAL := '_'; /*ACUMULADOR DE PRODUTO*/
            V_CDPRATO_ATUAL := CASE WHEN P_IDSEPPRATO <> 'P' THEN '          ' ELSE '_' END; /*ACUMULADOR DE PRATO*/
            V_CDFILAUXPRAT_ATUAL := CASE WHEN P_IDSEPPRATO <> 'P' THEN ' ' ELSE '_' END; /*ACUMULADOR DE FILAUXPRAT*/
            V_QTPRODUTO := 0.0; /*ACUMULADOR DE QUANTIDADE DE PRODUTO*/
            V_CDAPRERECE_ATUAL := '_';
            V_VRPECONSCPME_ATUAL := 0;

            FOR C_COMPCARD IN (
               SELECT R.CDPRODUTO,
                      R.QTPRODUTO,
                      R.CDAPRERECE,
                      CASE WHEN P_IDSEPPRATO = 'P' THEN CC.CDFILAUXPRAT ELSE ' ' END AS CDFILAUXPRAT, 
                      CASE WHEN P_IDSEPPRATO = 'P' THEN CC.CDPRATO ELSE '          ' END AS CDPRATO,
                      SUM(CASE WHEN (C_CARDAPIO.IDCARDESPEC = 'N') AND (PP.VRPERACEIT IS NOT NULL) AND (PP.VRPERACEIT <> 0) THEN 100 * (1 - (PP.VRPERACEIT/100) * -1) ELSE CC.VRPECONSCPME END) AS VRPECONSCPME,
					  R.IDTPREQPROD
               FROM COMPCARDPME CC INNER JOIN TABLE (RECEITA_UTIL(C_CARDAPIO.CDFILIAL,C_CARDAPIO.CDSERVFILI,CC.CDPRATO,CC.CDFILAUXPRAT,P_CDPRODUTOINI,P_CDPRODUTOFIN,NULL,0,0,'N',NULL,NULL,C_CARDAPIO.CDFILCENTPME, C_CARDAPIO.CDTIPOCARD)) R 
                                      ON CC.CDPRATO = R.CDPRATO AND CC.CDFILAUXPRAT = R.CDFILAUXPRAT
                                   LEFT JOIN PERACEITPRATO PP
                                      ON PP.CDFILCENTPME = C_CARDAPIO.CDFILCENTPME AND PP.CDFILIAL = C_CARDAPIO.CDFILIAL AND PP.CDPRATO = CC.CDPRATO AND PP.CDFILAUXPRAT = CC.CDFILAUXPRAT AND PP.CDTIPOCARD = C_CARDAPIO.CDTIPOCARD
               WHERE (CC.CDFILCENTPME = C_CARDAPIO.CDFILCENTPME) AND
                     (CC.NRCARDPME    = C_CARDAPIO.NRCARDPME)    AND
                     (CC.NRCARDIAPME  = V_NRCARDIAPME)
               GROUP BY R.CDPRODUTO, R.QTPRODUTO, R.CDAPRERECE, CC.CDFILAUXPRAT, CC.CDPRATO, R.IDTPREQPROD
               ORDER BY R.CDPRODUTO, CC.CDPRATO, CC.CDFILAUXPRAT)
            LOOP
               IF (C_COMPCARD.VRPECONSCPME <> 0) THEN

                  /*QUANDO E A PRIMEIRA PASSAGEM NO LOOP, ATUALIZA AS VARIAVEIS*/
                  IF V_CDPRODUTO_ATUAL = '_' THEN  
                     V_CDPRODUTO_ATUAL := C_COMPCARD.CDPRODUTO;
                     V_CDPRATO_ATUAL := C_COMPCARD.CDPRATO;
                     V_CDFILAUXPRAT_ATUAL := C_COMPCARD.CDFILAUXPRAT;
                     V_CDAPRERECE_ATUAL := C_COMPCARD.CDAPRERECE;
                     V_VRPECONSCPME_ATUAL := C_COMPCARD.VRPECONSCPME;
                     V_QTPRATO := (V_VRPECONSCPME_ATUAL * C_CARDAPIO.QTCOMESTCPME)/ 100 ; 
                  END IF;   

                  /*QUANDO TROCA O PRODUTO OU PRATO VAI FAZER A INSERCAO NA CONSPLAN, AJUSTANDO AS QUANTIDADES CASO EXISTA ARREDONDAMENTO OU ACRESCIMO*/
                  IF V_CDPRODUTO_ATUAL <> C_COMPCARD.CDPRODUTO OR V_CDPRATO_ATUAL <> C_COMPCARD.CDPRATO OR V_CDFILAUXPRAT_ATUAL <> C_COMPCARD.CDFILAUXPRAT THEN 

                     /*SE EXISTE ACRESCIMO, VERIFICA SE O PRODUTO PERMITE OU NO ACRESIMO E AJUSTA SUA QUANTIDADE*/
                     IF P_PEACRESCIMO <> 0 THEN 
                        BEGIN 
                           SELECT IDPRODNAREQPREV
                             INTO V_IDPRODNAREQPREV
                             FROM PRODFILI
                            WHERE CDFILIAL = C_CARDAPIO.CDFILIAL
                              AND CDPRODUTO = V_CDPRODUTO_ATUAL;
                        EXCEPTION
                        WHEN NO_DATA_FOUND THEN V_IDPRODNAREQPREV := '';
                        END;

                        IF (V_IDPRODNAREQPREV <> 'S') THEN 
                           V_QTPRODUTO := V_QTPRODUTO * (1 + (P_PEACRESCIMO / 100));
                        END IF;           
                     END IF;                      

                     V_QTPRODUTO_ARRED := V_QTPRODUTO;
                     /*SE ARREDONDA ENTAO ANTES DE INSERIR NA CONSPLAN REALIZA O ARREDONDAMENTO*/
                     IF (P_IDARREDOND = 'S') OR (P_IDARREDOND = 'C') THEN 
                        SELECT MAX(VRARREDREQ), MAX(VRARREDCMP)
                          INTO V_VRARREDREQ, V_VRARREDCMP
                          FROM PRODUTO
                         WHERE CDPRODUTO = V_CDPRODUTO_ATUAL;

                        V_ARRED := CASE WHEN P_IDARREDOND = 'S' THEN V_VRARREDREQ ELSE V_VRARREDCMP END;

                        IF NOT (V_ARRED IS NULL) AND (V_ARRED <> 0) THEN
                           IF (V_QTPRODUTO_ARRED > 0) AND (MOD(V_QTPRODUTO_ARRED, V_ARRED) > 0) THEN
                              V_QTPRODUTO_ARRED := (FLOOR(V_QTPRODUTO_ARRED/V_ARRED) + 1) * V_ARRED;
                           END IF;                      
                        END IF; 
                     END IF;

                     /*INSERE NA CONSPLAN OS PRODUTOS POR PRATO*/
                     INSERT INTO CONSPLAN
                        (NRCONSPLAN,
                         CDFILCENTPME,
                         CDFILICPLA,
                         CDTPCARDPME,
                         CDSERVCPLA,
                         DTCONSPLAN,
                         IDCONSPLAN,
                         CDFAPRATCPLA,
                         CDPRATCONSPL,
                         CDAPRECONSPL,
                         CDSETOCONSPL,
                         CDPRODCPLA,
                         DTLIMITECPLA,
                         HRLIMITECPLA,
                         CDTPPRATCPLA,
                         QTCONSPLAN,
                         QTCONSPLANSA,
                         VRPECONSPLAN,
                         QTCOMESTCPLA,
                         CDCLIECPLA,
                         CDDESTFICPLA,
						 IDTPREQPROD)
                     VALUES
                        (P_NRCONSPLAN,
                         P_CDFILCENTPME,
                         C_CARDAPIO.CDFILIAL,
                         C_CARDAPIO.CDTIPOCARD,
                         C_CARDAPIO.CDSERVFILI,
                         C_CARDAPIO.DTCARDIAPME,
                         'C',
                         V_CDFILAUXPRAT_ATUAL,
                         V_CDPRATO_ATUAL,
                         V_CDAPRERECE_ATUAL,
                         NULL,
                         V_CDPRODUTO_ATUAL,
                         TO_DATE(TO_CHAR(C_CARDAPIO.DTCARDIAPME, 'DD/MM/YYYY'), 'DD/MM/YYYY'),
                         TO_CHAR(C_CARDAPIO.DTCARDIAPME, 'HH24MI'),
                         '  ',
                         V_QTPRODUTO_ARRED,
                         V_QTPRODUTO,
                         V_VRPECONSCPME_ATUAL,
                         V_QTPRATO,
                         'xxx',
                         'xxx',
						 NVL(C_COMPCARD.IDTPREQPROD, 'P'));

                     /*ATUALIZA AS VARIAVEIS DE ACORDO COM O PRODUTO ATUAL*/
                     V_VRPECONSCPME_ATUAL := C_COMPCARD.VRPECONSCPME;
                     V_QTPRATO := (V_VRPECONSCPME_ATUAL * C_CARDAPIO.QTCOMESTCPME)/ 100 ; 
                     V_QTPRODUTO := (C_COMPCARD.QTPRODUTO * V_QTPRATO);
                     V_CDPRODUTO_ATUAL := C_COMPCARD.CDPRODUTO;
                     V_CDFILAUXPRAT_ATUAL := C_COMPCARD.CDFILAUXPRAT;
                     V_CDPRATO_ATUAL := C_COMPCARD.CDPRATO;      
                     V_CDAPRERECE_ATUAL := C_COMPCARD.CDAPRERECE;
                  ELSE
                     V_VRPECONSCPME_ATUAL := C_COMPCARD.VRPECONSCPME;
                     V_QTPRATO := (V_VRPECONSCPME_ATUAL * C_CARDAPIO.QTCOMESTCPME)/ 100 ;
                     V_QTPRODUTO := V_QTPRODUTO + (C_COMPCARD.QTPRODUTO * V_QTPRATO);
                  END IF;
               END IF;
            END LOOP;

            /*APOS O ULTIMO LOOP, FAZ A SUA ULTIMA INSERCAO NA CONSPLAN PARA O ULTIMO PRODUTO QUE FOI ARMAZENADO NAS VARIAVEIS*/
            IF V_VRPECONSCPME_ATUAL > 0 THEN
               /*SE EXISTE ACRESCIMO, VERIFICA SE O PRODUTO PERMITE OU NO ACRESIMO E AJUSTA SUA QUANTIDADE*/
               IF P_PEACRESCIMO <> 0 THEN 
                  BEGIN 
                     SELECT IDPRODNAREQPREV
                       INTO V_IDPRODNAREQPREV
                       FROM PRODFILI
                      WHERE CDFILIAL = C_CARDAPIO.CDFILIAL
                        AND CDPRODUTO = V_CDPRODUTO_ATUAL;
                  EXCEPTION
                  WHEN NO_DATA_FOUND THEN V_IDPRODNAREQPREV := '';
                  END;
                  IF (V_IDPRODNAREQPREV <> 'S') THEN 
                     V_QTPRODUTO := V_QTPRODUTO * (1 + (P_PEACRESCIMO / 100));
                  END IF;           
               END IF;

               V_QTPRODUTO_ARRED := V_QTPRODUTO;
               /*SE ARREDONDA ENTAO ANTES DE INSERIR NA CONSPLAN REALIZA O ARREDONDAMENTO*/
               IF (P_IDARREDOND = 'S') OR (P_IDARREDOND = 'C') THEN 
                  SELECT MAX(VRARREDREQ), MAX(VRARREDCMP)
                    INTO V_VRARREDREQ, V_VRARREDCMP
                    FROM PRODUTO
                   WHERE CDPRODUTO = V_CDPRODUTO_ATUAL;

                  V_ARRED := CASE WHEN P_IDARREDOND = 'S' THEN V_VRARREDREQ ELSE V_VRARREDCMP END;

                  IF NOT (V_ARRED IS NULL) AND (V_ARRED <> 0) THEN
                     IF (V_QTPRODUTO_ARRED > 0) AND (MOD(V_QTPRODUTO_ARRED, V_ARRED) > 0) THEN
                        V_QTPRODUTO_ARRED := (FLOOR(V_QTPRODUTO_ARRED/V_ARRED) + 1) * V_ARRED;
                     END IF;                      
                  END IF; 
               END IF;

               /*INSERE NA CONSPLAN OS PRODUTOS POR PRATO*/
               INSERT INTO CONSPLAN
                  (NRCONSPLAN,
                   CDFILCENTPME,
                   CDFILICPLA,
                   CDTPCARDPME,
                   CDSERVCPLA,
                   DTCONSPLAN,
                   IDCONSPLAN,
                   CDFAPRATCPLA,
                   CDPRATCONSPL,
                   CDAPRECONSPL,
                   CDSETOCONSPL,
                   CDPRODCPLA,
                   DTLIMITECPLA,
                   HRLIMITECPLA,
                   CDTPPRATCPLA,
                   QTCONSPLAN,
                   QTCONSPLANSA,
                   VRPECONSPLAN,
                   QTCOMESTCPLA,
                   CDCLIECPLA,
                   CDDESTFICPLA)
               VALUES
                  (P_NRCONSPLAN,
                   P_CDFILCENTPME,
                   C_CARDAPIO.CDFILIAL,
                   C_CARDAPIO.CDTIPOCARD,
                   C_CARDAPIO.CDSERVFILI,
                   C_CARDAPIO.DTCARDIAPME,
                   'C',
                   V_CDFILAUXPRAT_ATUAL,
                   V_CDPRATO_ATUAL,
                   V_CDAPRERECE_ATUAL,
                   NULL,
                   V_CDPRODUTO_ATUAL,
                   TO_DATE(TO_CHAR(C_CARDAPIO.DTCARDIAPME, 'DD/MM/YYYY'), 'DD/MM/YYYY'),
                   TO_CHAR(C_CARDAPIO.DTCARDIAPME, 'HH24MI'),
                   '  ',
                   V_QTPRODUTO_ARRED,
                   V_QTPRODUTO,
                   V_VRPECONSCPME_ATUAL,
                   V_QTPRATO,
                   'xxx',
                   'xxx');
               COMMIT;            
            END IF;            
         END IF; /* NAO CALCULA PRATOS PARA COMENSAIS IGUAL A ZERO */
      END LOOP; /* LOOP PARA CALCULO DOS CARDAPIOS */
   END IF; /* CALCULO DOS PRODUTOS DOS CARDAPIOS */

   /* INICIO CONSUMO POR SERVICO */
   IF (V_IDCONSFIXO = 'F') OR (V_IDCONSPERC = 'P') THEN
      BEGIN
         SELECT
            CASE WHEN V_IDCONSPERC = 'P' THEN CDTCACONSPER ELSE NULL END,
            CASE WHEN V_IDCONSFIXO = 'F' THEN CDTCACONSFIX ELSE NULL END
         INTO
            V_CDTCACONSPER,
            V_CDTCACONSFIX
         FROM
            PARAMPLANEJA
         WHERE
            (CDFILIAL = P_CDFILCENTPME);
      EXCEPTION
         WHEN NO_DATA_FOUND THEN
            V_CDTCACONSPER := NULL;
            V_CDTCACONSFIX := NULL;
      END;

      FOR REC_CONSPLAN IN(
         SELECT DTDATA,
                CDSERVFILI,
                HRINICATEN,
                CDFILIAL,
                MAX(NRCARDAPIO) AS NRCARDAPIO,
                SUM(QTCOMESTICAR) AS QTCOMESTICAR
         FROM(       
         SELECT CA.DTCARDIAPME AS DTDATA,
                CA.CDSERVFILI,
                RPAD(S.HRINICATEN, 4, 0) AS HRINICATEN,
                CA.NRCARDPME AS NRCARDAPIO,
                CA.QTCOMESTCPME AS QTCOMESTICAR,
                CA.CDFILIAL
           FROM CARDIAPME CA INNER JOIN SERVICO S ON S.CDFILIAL = CA.CDFILIAL AND S.CDSERVFILI = CA.CDSERVFILI
                             INNER JOIN SERVTIPOCARD ST ON ST.CDFILCENTPME = CA.CDFILCENTPME AND ST.CDSERVFILI = CA.CDSERVFILI AND ST.CDTIPOCARD = V_CDTCACONSPER
                             INNER JOIN FILITIPOCARD FT ON FT.CDFILCENTPME = ST.CDFILCENTPME AND FT.CDTIPOCARD = ST.CDTIPOCARD AND FT.CDFILIAL = S.CDFILIAL AND FT.IDTCARATFILI = 'S'
          WHERE CA.CDFILCENTPME = P_CDFILCENTPME AND 
                CA.DTCARDIAPME BETWEEN P_DTINICIAL AND P_DTFINAL AND
                (INSTR(NVL(P_CDFILIAL, CA.CDFILIAL), CA.CDFILIAL) > 0) AND 
                (INSTR(NVL(P_CDSERVFILI, CA.CDSERVFILI), CA.CDSERVFILI) <> 0 OR (P_CDSERVFILI = 'T'))

         UNION ALL

         SELECT DT.DTDATA,
                S.CDSERVFILI,
                RPAD(S.HRINICATEN, 4, 0) AS HRINICATEN,
                NULL NRCARDAPIO,
                NULL QTCOMESTICAR,
                S.CDFILIAL
           FROM SERVTIPOCARD ST INNER JOIN FILITIPOCARD FT ON FT.CDFILCENTPME = ST.CDFILCENTPME AND FT.CDTIPOCARD = ST.CDTIPOCARD AND FT.IDTCARATFILI = 'S'
                                INNER JOIN SERVICO S ON S.CDSERVFILI = ST.CDSERVFILI AND S.CDFILIAL = FT.CDFILIAL
                                CROSS JOIN DATA DT
          WHERE (ST.CDTIPOCARD = V_CDTCACONSFIX) AND 
                (ST.CDFILCENTPME = P_CDFILCENTPME) AND 
                (INSTR(NVL(P_CDFILIAL, S.CDFILIAL), S.CDFILIAL) > 0) AND 
                (INSTR(NVL(P_CDSERVFILI, S.CDSERVFILI), S.CDSERVFILI) <> 0 OR (P_CDSERVFILI = 'T')) AND 
                (DT.DTDATA BETWEEN P_DTINICIAL AND P_DTFINAL)
         )
         GROUP BY DTDATA, CDSERVFILI, HRINICATEN, CDFILIAL
         ORDER BY DTDATA, CDSERVFILI, HRINICATEN, CDFILIAL, NRCARDAPIO

      )LOOP

         SELECT
            COUNT(*)
         INTO
            V_FERIADO
         FROM
            FERIFILI
         WHERE
            (CDFILIAL   = REC_CONSPLAN.CDFILIAL) AND
            (DTFERIFILI = REC_CONSPLAN.DTDATA);

         V_IDTIPOCONPME := CASE WHEN  V_FERIADO = 0 THEN TO_CHAR(REC_CONSPLAN.DTDATA, 'D') ELSE 8 END;

         /*VERIFICA SE E UM DIA SEM CONSUMO EM AMBOS OS TIPOS FIXO/PERCAPITA*/
         SELECT COUNT(*)
           INTO QT_DIA_SEM_CONSUMO
           FROM DIASEMCONSPME
          WHERE CDFILCENTPME  = P_CDFILCENTPME AND
                CDSERVFILI    = REC_CONSPLAN.CDSERVFILI   AND
                CDFILIAL      = REC_CONSPLAN.CDFILIAL     AND
                DTSEMCONSPME  = REC_CONSPLAN.DTDATA  AND
                IDTPCONSPME   =  'A';
         IF QT_DIA_SEM_CONSUMO > 0 THEN
            CONSUMO_F := '_';
            CONSUMO_P := '_';
         ELSE
            IF V_CDTCACONSFIX IS NULL THEN
               CONSUMO_F := '_'; 
            ELSE
               SELECT COUNT(*)
                 INTO QT_DIA_SEM_CONSUMO
                 FROM DIASEMCONSPME D  
                WHERE D.CDFILCENTPME  = P_CDFILCENTPME AND
                      D.CDSERVFILI    = REC_CONSPLAN.CDSERVFILI   AND
                      D.CDFILIAL      = REC_CONSPLAN.CDFILIAL     AND
                      D.DTSEMCONSPME  = REC_CONSPLAN.DTDATA  AND
                      D.IDTPCONSPME   =  'F';

               CONSUMO_F := CASE WHEN QT_DIA_SEM_CONSUMO > 0 THEN '_' ELSE 'F' END;
               IF CONSUMO_F = 'F' THEN
                  SELECT COUNT(*)
                    INTO V_EXISTE_TIPOCARD 
                    FROM SERVTIPOCARD 
				   INNER JOIN FILITIPOCARD FT 
				      ON FT.CDFILCENTPME = SERVTIPOCARD.CDFILCENTPME 
					 AND FT.CDTIPOCARD = SERVTIPOCARD.CDTIPOCARD 
					 AND FT.CDFILIAL = REC_CONSPLAN.CDFILIAL 
					 AND FT.IDTCARATFILI = 'S'	
                   WHERE SERVTIPOCARD.CDFILCENTPME = P_CDFILCENTPME AND 
                         SERVTIPOCARD.CDSERVFILI = REC_CONSPLAN.CDSERVFILI AND 
                         SERVTIPOCARD.CDTIPOCARD = V_CDTCACONSFIX;

                  CONSUMO_F := CASE WHEN V_EXISTE_TIPOCARD > 0 THEN 'F' ELSE '_' END;      
               END IF;
            END IF;
            IF V_CDTCACONSPER IS NULL OR REC_CONSPLAN.QTCOMESTICAR IS NULL THEN
               CONSUMO_P := '_'; 
            ELSE
               SELECT COUNT(*)
                 INTO QT_DIA_SEM_CONSUMO
                 FROM DIASEMCONSPME D INNER JOIN SERVTIPOCARD ST ON ST.CDFILCENTPME = D.CDFILCENTPME AND ST.CDSERVFILI = D.CDSERVFILI AND ST.CDTIPOCARD = V_CDTCACONSPER 
                WHERE D.CDFILCENTPME  = P_CDFILCENTPME AND
                      D.CDSERVFILI    = REC_CONSPLAN.CDSERVFILI   AND
                      D.CDFILIAL      = REC_CONSPLAN.CDFILIAL     AND
                      D.DTSEMCONSPME  = REC_CONSPLAN.DTDATA  AND
                      D.IDTPCONSPME   =  'P';        

               CONSUMO_P := CASE WHEN QT_DIA_SEM_CONSUMO > 0 THEN '_' ELSE 'P' END; 
               IF CONSUMO_P = 'P' THEN
                  SELECT COUNT(*)
                    INTO V_EXISTE_TIPOCARD 
                    FROM SERVTIPOCARD 
				   INNER JOIN FILITIPOCARD FT 
				      ON FT.CDFILCENTPME = SERVTIPOCARD.CDFILCENTPME 
					 AND FT.CDTIPOCARD = SERVTIPOCARD.CDTIPOCARD 
					 AND FT.CDFILIAL = REC_CONSPLAN.CDFILIAL 
					 AND FT.IDTCARATFILI = 'S'	
                   WHERE SERVTIPOCARD.CDFILCENTPME = P_CDFILCENTPME AND 
                         SERVTIPOCARD.CDSERVFILI = REC_CONSPLAN.CDSERVFILI AND 
                         SERVTIPOCARD.CDTIPOCARD = V_CDTCACONSPER;

                  CONSUMO_P := CASE WHEN V_EXISTE_TIPOCARD > 0 THEN 'P' ELSE '_' END;      
               END IF;               
            END IF;
            FOR REC_CONSSERVPME IN (
               SELECT
                  CS.CDFILCENTPME,
                  CS.CDSERVFILI,
                  CS.CDFILIAL,
                  CS.DTCONSERVPME,
                  CS.CDPRODUTO,
                  CS.QTCONSERVPME,
                  CS.IDQTDECONPME
               FROM
                  CONSSERVPME CS, PRODUTO
               WHERE
                  (CS.CDFILCENTPME = P_CDFILCENTPME)                    AND
                  (CS.CDSERVFILI   = REC_CONSPLAN.CDSERVFILI)           AND
                  (CS.CDFILIAL     = REC_CONSPLAN.CDFILIAL)             AND
                  (CS.DTCONSERVPME = REC_CONSPLAN.DTDATA)               AND
                  (CS.IDTIPOCONPME = 9)                                 AND
                  (CS.IDQTDECONPME IN (CONSUMO_P, CONSUMO_F))           AND
                  (CS.CDPRODUTO    = PRODUTO.CDPRODUTO)                 AND
                  (CDARVPROD BETWEEN P_CDPRODUTOINI AND P_CDPRODUTOFIN)

               UNION ALL

               SELECT
                  CS.CDFILCENTPME,
                  CS.CDSERVFILI,
                  CS.CDFILIAL,
                  CS.DTCONSERVPME,
                  CS.CDPRODUTO,
                  CS.QTCONSERVPME,
                  CS.IDQTDECONPME
               FROM
                  CONSSERVPME CS, PRODUTO
               WHERE
                  (CS.CDFILCENTPME = P_CDFILCENTPME)                    AND
                  (CS.CDSERVFILI   = REC_CONSPLAN.CDSERVFILI)           AND
                  (CS.CDFILIAL     = REC_CONSPLAN.CDFILIAL)             AND
                  (CS.CDPRODUTO    = PRODUTO.CDPRODUTO)                 AND
                  (CDARVPROD BETWEEN P_CDPRODUTOINI AND P_CDPRODUTOFIN) AND
                  (CS.IDQTDECONPME   IN (CONSUMO_P, CONSUMO_F))         AND
                  (CS.IDTIPOCONPME = V_IDTIPOCONPME)                    AND
                  (CS.DTCONSERVPME = (SELECT MAX(DTCONSERVPME)
                                        FROM CONSSERVPME
                                       WHERE CDFILCENTPME = P_CDFILCENTPME  AND
                                             CDSERVFILI   = REC_CONSPLAN.CDSERVFILI    AND
                                             CDFILIAL     = REC_CONSPLAN.CDFILIAL      AND
                                             DTCONSERVPME <= REC_CONSPLAN.DTDATA AND
                                             IDTIPOCONPME <> 9))            AND
                  NOT EXISTS (SELECT CDFILIAL
                                FROM CONSSERVPME
                                WHERE CDFILCENTPME = CS.CDFILCENTPME AND
                                      CDSERVFILI   = CS.CDSERVFILI   AND
                                      CDFILIAL     = CS.CDFILIAL     AND
                                      DTCONSERVPME = CS.DTCONSERVPME AND
                                      IDTIPOCONPME = 9            AND
                                      IDQTDECONPME = CS.IDQTDECONPME)
                  ORDER BY 6, 4            
            )LOOP

               V_PERCACRES := 0;
               IF P_PEACRESCIMO <> 0 THEN
                  BEGIN
                     SELECT IDPRODNAREQPREV
                       INTO V_IDPRODNAREQPREV
                       FROM PRODFILI                               
                      WHERE CDFILIAL = REC_CONSPLAN.CDFILIAL
                        AND CDPRODUTO = REC_CONSSERVPME.CDPRODUTO;
                  EXCEPTION
                  WHEN NO_DATA_FOUND THEN V_IDPRODNAREQPREV := '';
                  END;

                  IF (V_IDPRODNAREQPREV = 'S') THEN 
                     V_PERCACRES := 0;
                  ELSE 
                     V_PERCACRES := P_PEACRESCIMO;
                  END IF;               
               END IF;

               IF REC_CONSSERVPME.IDQTDECONPME = 'F' THEN
                  V_CDTPPRATCPLA := 'FF';
                  V_QTPRODUTO := (REC_CONSSERVPME.QTCONSERVPME) * (1 + (V_PERCACRES / 100)); 
               ELSE
                  V_CDTPPRATCPLA := 'PP';
                  V_QTPRODUTO := (REC_CONSSERVPME.QTCONSERVPME * REC_CONSPLAN.QTCOMESTICAR) * (1 + (V_PERCACRES / 100)); 
               END IF;

               V_CDPRATCONSPL := '          ';
               V_CDSETOCONSPL := '  ';
               V_CDFAPRATCPLA := ' ';

               V_QTPRODUTO_ARRED := V_QTPRODUTO;
               /*SE ARREDONDA ENTAO ANTES DE INSERIR NA CONSPLAN REALIZA O ARREDONDAMENTO*/
               IF (P_IDARREDOND = 'S') OR (P_IDARREDOND = 'C') THEN 
                  SELECT MAX(VRARREDREQ), MAX(VRARREDCMP)
                    INTO V_VRARREDREQ, V_VRARREDCMP
                    FROM PRODUTO
                   WHERE CDPRODUTO = V_CDPRODUTO_ATUAL;

                  V_ARRED := CASE WHEN P_IDARREDOND = 'S' THEN V_VRARREDREQ ELSE V_VRARREDCMP END;

                  IF NOT (V_ARRED IS NULL) AND (V_ARRED <> 0) THEN
                     IF (V_QTPRODUTO_ARRED > 0) AND (MOD(V_QTPRODUTO_ARRED, V_ARRED) > 0) THEN
                        V_QTPRODUTO_ARRED := (FLOOR(V_QTPRODUTO_ARRED/V_ARRED) + 1) * V_ARRED;
                     END IF;                      
                  END IF; 
               END IF;
               /*INSERE NA CONSPLAN OS PRODUTOS POR PRATO*/
               INSERT INTO CONSPLAN
                  (NRCONSPLAN,
                   CDFILCENTPME,
                   CDFILICPLA,
                   CDTPCARDPME,
                   CDSERVCPLA,
                   DTCONSPLAN,
                   IDCONSPLAN,
                   CDFAPRATCPLA,
                   CDPRATCONSPL,
                   CDAPRECONSPL,
                   CDSETOCONSPL,
                   CDPRODCPLA,
                   DTLIMITECPLA,
                   HRLIMITECPLA,
                   CDTPPRATCPLA,
                   QTCONSPLAN,
                   QTCONSPLANSA,
                   VRPECONSPLAN,
                   QTCOMESTCPLA,
                   CDCLIECPLA,
                   CDDESTFICPLA)
               VALUES
                  (P_NRCONSPLAN,
                   P_CDFILCENTPME,
                   REC_CONSPLAN.CDFILIAL,
                   CASE WHEN REC_CONSSERVPME.IDQTDECONPME = 'F' THEN V_CDTCACONSFIX ELSE V_CDTCACONSPER END,
                   REC_CONSPLAN.CDSERVFILI,
                   REC_CONSPLAN.DTDATA,
                   REC_CONSSERVPME.IDQTDECONPME,
                   V_CDFAPRATCPLA,
                   V_CDPRATCONSPL,
                   NULL,
                   V_CDSETOCONSPL,
                   REC_CONSSERVPME.CDPRODUTO,
                   TO_DATE(TO_CHAR(REC_CONSPLAN.DTDATA, 'DD/MM/YYYY'), 'DD/MM/YYYY'),
                   REC_CONSPLAN.HRINICATEN,
                   V_CDTPPRATCPLA,
                   V_QTPRODUTO_ARRED,
                   V_QTPRODUTO,
                   100,
                   REC_CONSPLAN.QTCOMESTICAR,
                   'xxx',
                   'xxx');
               COMMIT; 
            END LOOP;
         END IF;            
      END LOOP;
   END IF;
   /* FIM DO CONSUMO POR SERVICO */
END;
/
