<?php
namespace Teknisa\Model\Gestaopessoas\Repositories;


class EsoParametro extends \Doctrine\ORM\EntityRepository {
    
    public function getEsoParametro($envioAuto = true, $simplificado = false){
        try{
            $db = \Setforms2\Shared\Registry::getEntityManagerConnection();
            
            $qryEnvioAuto = '';
            
            if($envioAuto){
                $qryEnvioAuto = " EP.IDENVAUTO = 'S' AND";
            }
            
            if($simplificado){
                $qrySimplificado = " EP.DSVERSAO NOT IN ('2.5.00','2.4.02') AND";
            }else{
                $qrySimplificado = " EP.DSVERSAO IN ('2.5.00','2.4.02') AND";
            }
            
            $sql = "SELECT EP.*, EM.NMESTRUTURAM, EH.CDCNPJESTRUT AS CDCNPJEMPREGADOR,
            CASE
            WHEN (LENGTH(REPLACE(REPLACE(REPLACE(EH.CDCNPJESTRUT,'.',''),'/',''),'-','')) = 14 AND SUBSTR(REPLACE(REPLACE(REPLACE(EH.CDCNPJESTRUT,'.',''),'/',''),'-',''),9,4) = '0001' AND EH.CDCEIESTRUT IS NULL)
                 OR (LENGTH(REPLACE(REPLACE(REPLACE(EH.CDCNPJESTRUT,'.',''),'/',''),'-','')) <> 14)
            THEN 'S'
            ELSE 'N'
           END IDMATRIZ
                    FROM ESO_PARAMETRO EP
                    JOIN ESTRUTURAM EM ON EM.NRESTRUTURAM = EP.NRESTRUTURAM AND EP.NRORG = EM.NRORG
                    JOIN ESTRUTURAH EH ON EH.NRESTRUTURAM = EM.NRESTRUTURAM AND EH.NRORG = EM.NRORG AND 
                    EH.DTMESCOMPETENC = (SELECT MAX(EHH.DTMESCOMPETENC) FROM ESTRUTURAH EHH WHERE 
                                            EHH.NRORG = EH.NRORG AND EH.NRESTRUTURAM = EHH.NRESTRUTURAM
                                            AND EHH.DTMESCOMPETENC <= SYSDATE)
                    WHERE $qryEnvioAuto $qrySimplificado (EP.DTFIMVIGENCIA IS NULL OR EP.DTFIMVIGENCIA <= SYSDATE)
                    ORDER BY EP.NRORG, EP.NRESTRUTURAM";
           
           return $resultado = $db->fetchAll($sql);
        } catch (\Exception $e) {
            throw $e;
        }
    }
    
    public function getEsoParametroNrorg($nrorg){
        try{
            $db = \Setforms2\Shared\Registry::getEntityManagerConnection();
            $sql = "SELECT EP.*, EM.NMESTRUTURAM
                    FROM ESO_PARAMETRO EP
                    JOIN ESTRUTURAM EM ON EM.NRESTRUTURAM = EP.NRESTRUTURAM AND EP.NRORG = EM.NRORG
                    WHERE 
                    EP.IDENVAUTO = 'S' AND EP.NRORG = $nrorg
                    AND EP.DTFIMVIGENCIA IS NULL OR EP.DTFIMVIGENCIA <= SYSDATE";
           
            return $resultado = $db->fetchAll($sql);
        } catch (\Exception $e) {
            throw $e;
        }
    }
    
    public function getEmailEsoParametroNrorg($nrorg){
        try{
            $db = \Setforms2\Shared\Registry::getEntityManagerConnection();
            $sql = "SELECT DISTINCT EP.DSEMAILENVIO
                    FROM ESO_PARAMETRO EP
                    WHERE 
                    EP.IDENVAUTO = 'S' AND EP.NRORG = $nrorg 
                    AND EP.DTFIMVIGENCIA IS NULL OR EP.DTFIMVIGENCIA <= SYSDATE";
           
            return $resultado = $db->fetchAll($sql);
        } catch (\Exception $e) {
            throw $e;
        }
    }
    
    public function getIdAprovacaoAdmissao($nrestruturam, $nrorg){
        try{
            $db = \Setforms2\Shared\Registry::getEntityManagerConnection();
            $sql = "SELECT NVL(IDAPROVADMISSAO, 'N') IDAPROVADMISSAO
                      FROM ESO_PARAMETRO EP
                     WHERE EP.NRESTRUTURAM = :P_NRESTRUTURAM
                       AND EP.NRORG = :P_NRORG";
            $params = array("P_NRESTRUTURAM" => $nrestruturam,
                            "P_NRORG" => $nrorg);
            $resultado = $db->fetchAssoc($sql, $params);
            
                $resultado = !empty($resultado) ? $resultado['IDAPROVADMISSAO'] : '';
            return $resultado;
        } catch (\Exception $e) {
            throw $e;
        }
    }
    
    public function retonaUltimaMatriculaEsoIncrementada($nrorg, $nrestruturam, $dtmescompetenc){
        try{
            $db = \Setforms2\Shared\Registry::getEntityManagerConnection();
            $sql = "SELECT MATRICULAESOCIAL.DSPREFIXOMATRIC || LPAD(NVL(MATRICULAESOCIAL.NUMEROMATRICULA, 0) + 1, MATRICULAESOCIAL.NRQTDEDIGMATRIC, '0') NOVO 
                      FROM (SELECT EP.DSPREFIXOMATRIC,
                                EP.NRQTDEDIGMATRIC,
                                MAX(LPAD(SUBSTR(VH.CDMATRICULAESOCIAL, NVL(LENGTH(EP.DSPREFIXOMATRIC),0)+1, 50), EP.NRQTDEDIGMATRIC, '0')) NUMEROMATRICULA
                            FROM GPE_VINCULOH VH
                            JOIN ESO_PARAMETRO EP ON VH.NRESTRUTLEGAL = EP.NRESTRUTURAM
                                                AND VH.NRORG = EP.NRORG  
                     WHERE VH.NRESTRUTLEGAL = :P_NRESTRUTURAM
                                AND VH.NRORG = :P_NRORG
                                AND VH.DTMESCOMPETENC = (SELECT MAX(DTMESCOMPETENC)
                                                            FROM GPE_VINCULOH VHH
                                                        WHERE VH.NRESTRUTLEGAL = VHH.NRESTRUTLEGAL
                                                            AND VH.NRORG = VHH.NRORG
                                                            AND VH.NRVINCULOM = VHH.NRVINCULOM
                                                            AND VH.DTMESCOMPETENC <= :P_DTMESCOMPETENC)
                                AND (SUBSTR(VH.CDMATRICULAESOCIAL, 0, NVL(LENGTH(EP.DSPREFIXOMATRIC),0)) = EP.DSPREFIXOMATRIC OR SUBSTR(VH.CDMATRICULAESOCIAL, 0, NVL(LENGTH(EP.DSPREFIXOMATRIC),0)) IS NULL)
                        GROUP BY EP.DSPREFIXOMATRIC, EP.NRQTDEDIGMATRIC) MATRICULAESOCIAL";
            $params = array("P_NRESTRUTURAM"   => $nrestruturam,
                            "P_NRORG"          => $nrorg,
                            "P_DTMESCOMPETENC" => $dtmescompetenc);
            $resultado = $db->fetchAssoc($sql, $params);
            return $resultado;
        } catch (\Exception $e) {
            throw $e;
        }
    }
    
}