<?php
namespace Teknisa\Model\Teknisa\Repositories;

use Teknisa\Model\Traits\TQuery;
use Doctrine\DBAL\Connection;

 class CpCall extends \Doctrine\ORM\EntityRepository {

    use TQuery;

    public function findFastCalls($cdoperadorCurrent, $filter,$filterSearchQuery,
                                  $orderBy, $page, $pageSize,$changeCategoryEnable = false ,$cdfaseChangeCategoryEnable = null,
                                  $specialFilters = ''){
        $cdfaseValidationTransaction = \Util\Utilities::getCdfaseValidationTransaction();
        $startPos = ($page - 1) * $pageSize;
        $finalPos = $page * $pageSize;
        $query = <<<SQL
         SELECT  COUNT(1) OVER () TOTAL_LINES_ZHNEXT, C.* FROM (
                   SELECT D.*, (CASE 
                         WHEN 'Q' = (SELECT NVL(CONTROL,'I') FROM (SELECT CTY.CONTROL
                                                FROM COMMENTS COM
                                                LEFT JOIN COMMENT_TYPE CTY ON(COM.COMMENT_TYPE_ID = CTY.ID )
                                                WHERE COM.TASK = D.CALL_RELATIONSHIP
                                                ORDER BY COM.ID DESC)
                                                WHERE ROWNUM = 1 ) THEN 'W'
                         ELSE D.CALL_STATUS_CLI 
                    END ) AS STATUS,
                          (CASE 
                         WHEN 'Q' = (SELECT NVL(CONTROL,'I') FROM (SELECT CTY.CONTROL
                                                FROM COMMENTS COM
                                                LEFT JOIN COMMENT_TYPE CTY ON(COM.COMMENT_TYPE_ID = CTY.ID )
                                                WHERE COM.TASK = D.CALL_RELATIONSHIP
                                                ORDER BY COM.ID DESC)
                                                WHERE ROWNUM = 1 ) THEN 'W'
                         ELSE D.STATUSGEST_PRE 
                    END ) AS STATUSGEST
        
                FROM (
                   SELECT
                   CALL.STATUSGEST AS STATUSGEST_PRE,
                   TO_CHAR((SELECT RTRIM(XMLAGG(XMLELEMENT(E, OPR1.NMOPERADOR, ',')
                                          .EXTRACT('//text()')
                                          ORDER BY OPR1.NMOPERADOR
                                       ).GETCLOBVAL(), ','
                                )
                                FROM CP_CALL_OPERADOR CCO1
                                JOIN OPERADOR OPR1 ON (CCO1.CDOPERADOR = OPR1.CDOPERADOR)
                                WHERE CCO1.NRCALL = CALL.NRCALL AND CCO1.TYPE = 'M'
                                ) )AS NMOPERRESP,
                   (SELECT RTRIM(XMLAGG(XMLELEMENT(E, ITR1.NMITEMTRAB, ',')
                                          .EXTRACT('//text()')
                                          ORDER BY ITR1.NMITEMTRAB
                                       ).GETCLOBVAL(), ','
                                )
                                FROM CP_CALL_WORKITEM CCW1
                                LEFT JOIN ITEMTRAB ITR1  ON (ITR1.CDITEMTRAB = CCW1.CDITEMTRAB)
                                WHERE CCW1.NRCALL = CALL.NRCALL
                                )AS TASK_WORKITEM_NAME,
                   CALL.NRCALL AS ID, CALL.NRORG, CALL.CDCLIENTE, CALL.CALL_RELATIONSHIP, (CALL.TYPE || ' - ' ||CALL.CALL_RELATIONSHIP) AS TEKNISA_ID,
                   CALL.REFERENCE, CALL.CLASSIFICATION, NVL(CLA.LABEL, ASS.NMASSUNTO) AS CLASSIFICATION_NAME,
                   CALL.REPORTED_BY,
                   (CASE
                         WHEN CALL.CDFASETRAM IN ('$cdfaseValidationTransaction')  THEN 'Y'
                         ELSE 'N'
                    END ) AS "CDFASE_VALIDATION_TRANSACTION",
                   OPO.NMOPERADOR AS REPORTER_NAME, CALL.PRODUCT,
                   NVL(PRJ.NAME, PRO.NMPRODUTO) AS PRODUCT_NAME,
                   TO_CHAR(CALL.DTINCLUSAO, 'DD/MM/YYYY') AS CREATED_AT,
                   TO_CHAR(CALL.DTINCLUSAO, 'DD/MM/YYYY') AS CREATED_AT_FILTER,
                   CALL.CALL_STATUS_CLI,
                   NVL(CALL.CDFASETRAM,CALL.TASK_STATUS) AS STATUS_ORIGIN,
                   NVL(FAT.NMFASETRAM,TST.LABEL) AS STATUS_ORIGIN_NAME,
                   CALL.CDFASETRAM,CALL.TASK_STATUS,CALL.HAS_ATTACHMENT,
                   (CASE CALL.CALL_STATUS_CLI
                         WHEN 'C' THEN 'Fechado'
                         WHEN 'O' THEN 'Em aberto'
                         ELSE 'Em progresso'
                    END ) AS STATUS_NAME_PRE,
                   TO_CHAR(CALL.UPDATED_CALL_AT, 'DD/MM/YYYY') AS UPDATED_AT,
                   TO_CHAR(CALL.UPDATED_CALL_AT, 'DD/MM/YYYY') AS UPDATED_AT_FILTER,
                   CALL.VERSION,
                   CALL.REVISION,
                   CLI.NMFANTCLIE,
                   CALL.TYPE,
                   STR.NAME AS STRUCTURE_NAME,
                   NULL AS TASK_WORKITEM,
                   NULL AS STRUCTURE_FILTER_ID,
                    (CASE
                         WHEN COW.VISUALIZED_CALL = 'Y' THEN 'Sim'
                         WHEN CALL.CDOPERINCLUSAO = '$cdoperadorCurrent' THEN 'Sim'
                         ELSE 'Não'
                    END ) AS ALREADY_READ_NAME,
                    (CASE
                         WHEN COW.VISUALIZED_CALL = 'Y' THEN 'Sim'
                         WHEN CALL.CDOPERINCLUSAO = '$cdoperadorCurrent' THEN 'Sim'
                         ELSE 'Não'
                    END ) AS ALREADY_READ,
                   CALL.HAS_ACTION,
                          '' AS STATUSGEST_FILTER,
                   CALL.PRODUCT_RELATIONSHIP AS MODULES_ID,
                   PRJ1.NAME AS MODULE_NAME,
                   CASE WHEN CALL.CALL_STATUS_CLI = 'C' OR CALL.TYPE = 'I' THEN 'N' ELSE 'S' END AS FORWARD_CALL_GRID, CALL.NRPRIOCALL, TST.CONTROL AS TASK_STATUS_CONTROL,
                   OPR.ID AS IDTELA, OPR.LABEL AS LABELTELA
              FROM CP_CALL CALL
              JOIN CP_CALL_OPERADOR CCO ON (CCO.NRCALL = CALL.NRCALL AND CCO.TYPE = 'M')
              JOIN OPERADOR OPR ON (CCO.CDOPERADOR = OPR.CDOPERADOR)
              JOIN OPERADOR OPO ON (CALL.REPORTED_BY = OPO.CDOPERADOR)
         LEFT JOIN CLIENTE CLI ON (CLI.CDCLIENTE = CALL.CDCLIENTE)
         LEFT JOIN STRUCTURE STR ON (STR.ID = CALL.STRUCTURE)
         LEFT JOIN CLASSIFICATION CLA ON (CLA.ID = CALL.CLASSIFICATION)
         LEFT JOIN ASSUNTO ASS ON (ASS.CDASSUNTO = CALL.CDASSUNTO)
         LEFT JOIN PRODUTO PRO  ON (CALL.TYPE = 'S' AND PRO.CDPRODUTO = CALL.PRODUCT)
         LEFT JOIN PROJECT PRJ  ON (CALL.TYPE = 'I' AND PRJ.ID = CALL.PRODUCT)
         LEFT JOIN PROJECT PRJ1  ON (CALL.TYPE = 'I' AND PRJ1.ID = CALL.PRODUCT_RELATIONSHIP)
         LEFT JOIN CP_CALL_WORKITEM CCW  ON (CCW.NRCALL = CALL.NRCALL)
         LEFT JOIN ITEMTRAB ITR  ON (ITR.CDITEMTRAB = CCW.CDITEMTRAB)
         LEFT JOIN CP_CALL_OPERADOR COW ON (COW.CDOPERADOR = '$cdoperadorCurrent' AND COW.NRCALL = CALL.NRCALL AND COW.TYPE = 'V')
         LEFT JOIN FASETRAM FAT ON (FAT.CDFASETRAM = CALL.CDFASETRAM)
         LEFT JOIN TASK_STATUS TST ON (TST.ID = CALL.TASK_STATUS)
         LEFT JOIN TASK TAS ON TAS.ID = CALL.CALL_RELATIONSHIP
         LEFT JOIN OM_PRODUTO_ELEMENTO OPR ON (TAS.MENU_ITEM_ID = OPR.ID AND CALL.TYPE = 'I')

         WHERE CALL.IDATIVO = 'S'
                  $filter                  
             $specialFilters
                  AND CALL.TYPE = 'I'
                  AND CALL.STATUSGEST IS NOT NULL

          GROUP BY CALL.CALL_RELATIONSHIP,CALL.CALL_STATUS_CLI,CALL.CDCLIENTE,CALL.CLASSIFICATION,CLA.LABEL, ASS.NMASSUNTO,CALL.DTINCLUSAO,
                    CALL.NRCALL,CLI.NMFANTCLIE,CALL.NRORG,CALL.PRODUCT,PRJ.NAME, PRO.NMPRODUTO,CALL.REFERENCE,CALL.REPORTED_BY,OPO.NMOPERADOR,
                    CALL.TYPE,CALL.UPDATED_CALL_AT,CALL.HAS_ACTION,STR.NAME,COW.VISUALIZED_CALL,CALL.CDOPERINCLUSAO,CALL.CDFASETRAM,CALL.HAS_ATTACHMENT,
                    CALL.TASK_STATUS,FAT.NMFASETRAM,TST.LABEL,PRJ1.NAME, CALL.PRODUCT_RELATIONSHIP , CALL.VERSION, CALL.REVISION, COW.TYPE, cow.NRCALLOPERADOR, CALL.NRPRIOCALL, TST.CONTROL,
                    OPR.ID, OPR.LABEL, CALL.STATUSGEST
          ORDER BY  CALL.UPDATED_CALL_AT desc) D
             ) C 
          $filterSearchQuery

SQL;
        $query = \Zeedhi\DevOps\Util\Utilities::getPaginatedQuery($query,$finalPos,$startPos);
        $result =  $this->getEntityManager()->getConnection()->fetchAll($query);
        foreach ($result as $key => &$item) {
            $item['ID_TEK']  = $item['ID'].'_'.$key;
            $item['ID'] = (int)$item['ID'];
            $item['NMOPERRESP'] = \Zeedhi\DevOps\Util\Utilities::getStringForArray(\Zeedhi\DevOps\Util\Utilities::setSelectMultiInQuery($item['NMOPERRESP'],false,',',true));
            $item['TASK_WORKITEM_NAME'] = \Zeedhi\DevOps\Util\Utilities::getStringForArray(\Zeedhi\DevOps\Util\Utilities::setSelectMultiInQuery($item['TASK_WORKITEM_NAME'],false,',',true));
            if($item['TYPE'] === 'S' && ($changeCategoryEnable || $cdfaseChangeCategoryEnable === $item['CDFASETRAM'])) {
                $item['CHANGE_CATEGORY_ENABLE'] = true;
            }
        }
        $total = empty($result) ? 0 : $result[0]['TOTAL_LINES_ZHNEXT'];
        $returnNext = [ 'data' => $result, 'pagination' => [ 'limit' => $pageSize, 'page' => $page, 'total' => $total]];
        return $returnNext;
    }

    public function findAllCalls($customQuery, $situationFilters,  $userId,  $startPos = 0, $finalPos = 9999, $orderBy = 'ID ASC', $groupByLabel = 'N')
    {
        $labelDescription = '';
        if($groupByLabel == 'Y'){
            $labelDescription = 'CALL.LABEL_DESCRIPTION,';
        }
        $query = <<<SQL
            SELECT CALL.NMOPERRESP, CALL.ID, CALL.NRORG, CALL.CDCLIENTE, CALL.CDFILIAL, CALL.CALL_RELATIONSHIP, CALL.TEKNISA_ID,
                   CALL.REFERENCE, CALL.CLASSIFICATION, CALL.CLASSIFICATION_NAME, CALL.REPORTED_BY, CALL.IS_ACTIVE,
                   CALL.REPORTER_NAME, CALL.PRODUCT, CALL.CAUSE, CALL.CAUSE_NAME, CALL.PRODUCT_NAME, CALL.CREATED_ORDER,
                   CALL.UPDATED, TO_CHAR(CALL.CREATED_AT, 'DD/MM/YYYY') AS CREATED_AT, CALL.CLOSED, CALL.STATUS,
                   CALL.PLANNED_DATE, CALL.UPDATED_ORDER, TO_CHAR(CALL.UPDATED_AT, 'DD/MM/YYYY') AS UPDATED_AT,
                   CALL.MAIN_TYPE_CALL, CALL.MAIN_TYPE_CALL_DESCRIPTION, CALL.TYPE, CALL.VERSION_DEV,
                   (SELECT RTRIM(XMLAGG(XMLELEMENT(E, LABEL.DESCRIPTION, ',')
                                          .EXTRACT('//text()')
                                          ORDER BY LABEL.DESCRIPTION
                                       ).GETCLOBVAL(), ','
                                ) AS LABEL_DESCRIPTION
                      FROM CP_CALL_LABEL_RELATION LABEL_REL
                      JOIN CP_CALL_LABEL LABEL ON LABEL_REL.LABEL = LABEL.NRCALLLABEL
                     WHERE LABEL_REL.CALL = CALL.ID
                       ) AS LABEL_DESCRIPTION,
                   CALL.NMRAZSOCCLIE, CALL.NMFANTCLIE, CALL.TEKNISA_INTERLOCUTOR_CODE, CALL.PLANNED_VERSION,
                   CALL.PLANNED_VALUE, CALL.RESPONSABLE_DIVISION_CODE, CALL.CUSTOMER_INTERLOCUTOR_CODE,
                   CALL.CUSTOMER_RESPONSABLE_CODE, CALL.CUSTOMER_INTERLOCUTOR, CALL.CALL_PRIORITY, CALL.RESPONSIBLE_OF_THE_PRODUCT,
                   CALL.RESPONSIBLE_OF_THE_CUSTOMER, CALL.TEKNISA_INTERLOCUTOR, CALL.RESPONSABLE_DIVISION,
                   CALL.TEXT_SMALL_1, CALL.TEXT_SMALL_2, CALL.TEXT_SMALL_3, CALL.TEXT_SMALL_4, CALL.TEXT_SMALL_5,
                   CALL.TEXT_LONG_1,CALL.TEXT_LONG_2,CALL.TEXT_LONG_3,CALL.TEXT_LONG_4,CALL.TEXT_LONG_5,
                   CALL.NUMBER_1,CALL.NUMBER_2,CALL.NUMBER_3,CALL.NUMBER_4,CALL.NUMBER_5,CALL.
                   DATE_1,CALL.DATE_2,CALL.DATE_3,CALL.DATE_4,CALL.DATE_5,CALL.PRODUCT_TYPE_NAME, CALL.VRORCAMENTO

              FROM ($customQuery) CALL
         LEFT JOIN CP_CALL_LABEL_RELATION LABEL_REL ON LABEL_REL.CALL = CALL.ID
         LEFT JOIN CP_CALL_LABEL LABEL ON LABEL_REL.LABEL = LABEL.NRCALLLABEL
         GROUP BY CALL.NMOPERRESP, CALL.ID, CALL.NRORG, CALL.CDCLIENTE, CALL.CDFILIAL, CALL.CALL_RELATIONSHIP, CALL.TEKNISA_ID,
         CALL.REFERENCE, CALL.CLASSIFICATION, CALL.CLASSIFICATION_NAME, CALL.REPORTED_BY, CALL.IS_ACTIVE,
         CALL.REPORTER_NAME, CALL.PRODUCT, CALL.CAUSE, CALL.CAUSE_NAME, CALL.PRODUCT_NAME, CALL.CREATED_ORDER,
         CALL.UPDATED, CALL.CREATED_AT, CALL.CLOSED, CALL.STATUS, CALL.PLANNED_DATE, CALL.UPDATED_ORDER,
         CALL.UPDATED_AT, CALL.MAIN_TYPE_CALL, CALL.MAIN_TYPE_CALL_DESCRIPTION, CALL.TYPE, CALL.NMRAZSOCCLIE,
         CALL.NMFANTCLIE, CALL.TEKNISA_INTERLOCUTOR_CODE, CALL.PLANNED_VERSION, CALL.PLANNED_VALUE,
         CALL.RESPONSABLE_DIVISION_CODE, CALL.CUSTOMER_INTERLOCUTOR_CODE, CALL.CUSTOMER_RESPONSABLE_CODE,
         CALL.CUSTOMER_INTERLOCUTOR, CALL.CALL_PRIORITY, CALL.RESPONSIBLE_OF_THE_PRODUCT,
         CALL.RESPONSIBLE_OF_THE_CUSTOMER, CALL.TEKNISA_INTERLOCUTOR, CALL.RESPONSABLE_DIVISION, CALL.VERSION_DEV,
         CALL.TEXT_SMALL_1, CALL.TEXT_SMALL_2, CALL.TEXT_SMALL_3, CALL.TEXT_SMALL_4, CALL.TEXT_SMALL_5,
         CALL.TEXT_LONG_1,CALL.TEXT_LONG_2,CALL.TEXT_LONG_3,CALL.TEXT_LONG_4,CALL.TEXT_LONG_5,
         CALL.NUMBER_1,CALL.NUMBER_2,CALL.NUMBER_3,CALL.NUMBER_4,CALL.NUMBER_5,CALL.DATE_1,
         CALL.DATE_2,CALL.DATE_3,CALL.DATE_4,CALL.DATE_5,CALL.PRODUCT_TYPE_NAME, CALL.VRORCAMENTO

          ORDER BY $orderBy
SQL;
        $query = \Zeedhi\DevOps\Util\Utilities::getPaginatedQuery($query,$finalPos,$startPos);
        return $this->getEntityManager()->getConnection()->fetchAll($query);

    }

    public function findDatasetDashboardCardSLA(){
        $query = <<<SQL
         SELECT COUNT(ID) AS CARD_OPEN
            FROM(
                SELECT TO_CHAR(TAS.ID) AS ID
                             FROM TASK TAS
                            JOIN ALLOCATION SAR ON (SAR.TASK = TAS.ID AND SAR.TYPE = 'R')
                            JOIN RESOURCE_T RES ON RES.ID = SAR.RESOURCE_T
                            JOIN TASK_STATUS TS ON TS.ID = TAS.TASK_STATUS
                       LEFT JOIN CP_CALL C      ON TAS.ID = C.CALL_RELATIONSHIP
                       LEFT JOIN ALLOCATION SA ON (SA.TASK = TAS.ID AND SA.TYPE = 'S')
                       LEFT JOIN RESOURCE_T SRE ON (SRE.ID = SA.RESOURCE_T)
                           WHERE SRE.EXTERNAL_CODE = :CD_CLIENTE
                                 AND TAS.IS_ISSUE = 'Y'
                                 AND TAS.STATUS = 'A'
                                 AND TAS.CREATED_AT BETWEEN TO_DATE( '01/11/2020 00:00:00' ,'DD/MM/YYYY HH24:MI:SS')
                                                AND TO_DATE( '30/11/2020 23:59:59' ,'DD/MM/YYYY HH24:MI:SS')
                         GROUP BY C.TYPE, C.NRCALL, TS.ID, TAS.CREATED_AT,TAS.ID

                UNION ALL

                 SELECT TO_CHAR(SER.NRSOLISERV) AS ID
                             FROM SOLISERV SER
                             JOIN OPERADOR OPE ON OPE.CDOPERADOR = SER.CDOPERADOR
                        LEFT JOIN CP_CALL C ON  (SER.NRSOLISERV = C.CALL_RELATIONSHIP)
                            WHERE SER.CDCLIENTE IN (:CD_CLIENTE)
                                  AND SER.DTINCLUSAO BETWEEN TO_DATE( '01/11/2020 00:00:00' ,'DD/MM/YYYY HH24:MI:SS')
                                                AND TO_DATE( '30/11/2020 23:59:59' ,'DD/MM/YYYY HH24:MI:SS')
                )
SQL;

        $params = array(
            "CDCLIENTE" => $cdCliente,
        );
        return $this->getEntityManager()->getConnection()->fetchAll($query, $params);
    }

    public function findDashboardPizza($currentCdCliente,$periodSlaStart,$periodSlaEnd){
        $query = <<<SQL
 SELECT
     LABEL,COUNT(*) AS TOTAL,ORDERBY,UPPER(LABEL) AS LABEL_UPPER,RTRIM(XMLAGG(XMLELEMENT(e,ID_CLA ,',').EXTRACT('//text()')).GetClobVal(),',') AS ID_CLA,ID_SLA_CHECK
 FROM
 (
 SELECT  DECODE(CAL.ID_SLA_CHECK, 'S',CLA.LABEL||' (SLA)',CLA.LABEL) AS LABEL, DECODE(CAL.ID_SLA_CHECK, 'S',1,2) AS ORDERBY,
        TO_CHAR(CLA.ID) AS ID_CLA,CAL.ID_SLA_CHECK
        FROM TASK TAS

        JOIN USR_CP_CALL_SLA CAL ON (TAS.ID = CAL.CALL_RELATIONSHIP AND CAL.TYPE = 'I')

        JOIN ALLOCATION SAR ON (SAR.TASK = TAS.ID AND SAR.TYPE = 'S')
        JOIN RESOURCE_T SRE ON (SRE.ID = SAR.RESOURCE_T AND SRE.EXTERNAL_CODE = :P_CDCLIENTE)
        JOIN CLIENTE CLI ON CLI.CDCLIENTE = SRE.EXTERNAL_CODE

        JOIN TASK_STATUS TST ON TST.ID = TAS.TASK_STATUS
        JOIN TASK_TYPE TTY ON TTY.ID = TST.TASK_TYPE

        JOIN PROJECT PRO ON (PRO.ID = TAS.PROJECT)

        JOIN CLASSIFICATION CLA ON TAS.CLASSIFICATION = CLA.ID

        WHERE TAS.STATUS = 'A'
        AND TAS.IS_ISSUE = 'Y'
        AND TAS.CREATED_AT BETWEEN TO_DATE( :P_DTINICIO||' 00:00:00' ,'DD/MM/YYYY HH24:MI:SS')
                                       AND TO_DATE( :P_DTFINAL||' 23:59:59' ,'DD/MM/YYYY HH24:MI:SS')
UNION ALL

 SELECT DECODE(CAL.ID_SLA_CHECK, 'S',NVL(CLA.LABEL,ASS.NMASSUNTO)||' (SLA)',NVL(CLA.LABEL,ASS.NMASSUNTO)) AS LABEL,
        DECODE(CAL.ID_SLA_CHECK, 'S',1,2) AS ORDERBY,NVL(TO_CHAR(CLA.ID),ASS.CDASSUNTO||'_S') AS ID_CLA,CAL.ID_SLA_CHECK
        FROM SOLISERV SER
        JOIN USR_CP_CALL_SLA CAL ON (SER.NRSOLISERV = CAL.CALL_RELATIONSHIP AND CAL.TYPE = 'S')

        JOIN PRODUTO PRO ON PRO.CDPRODUTO = SER.CDPRODCOMP

        JOIN CLIENTE CLI ON CLI.CDCLIENTE = SER.CDCLIENTE AND SER.CDCLIENTE = :P_CDCLIENTE

        JOIN ASSUNTO ASS ON ASS.CDASSUNTO = SER.CDASSUNTO
        LEFT JOIN CLASSIFICATION CLA ON CLA.CDASSUNTO = SER.CDASSUNTO

        WHERE SER.CDCLIENTE = :P_CDCLIENTE
        AND SER.DTINCLUSAO BETWEEN TO_DATE( :P_DTINICIO||' 00:00:00' ,'DD/MM/YYYY HH24:MI:SS')
                                       AND TO_DATE( :P_DTFINAL||' 23:59:59' ,'DD/MM/YYYY HH24:MI:SS')
)

GROUP BY LABEL,ORDERBY,ID_SLA_CHECK
ORDER BY ORDERBY
SQL;

        $params = array(
            "P_CDCLIENTE" => $currentCdCliente,
            "P_DTINICIO" => $periodSlaStart,
            "P_DTFINAL" => $periodSlaEnd,
        );
        return $this->getEntityManager()->getConnection()->fetchAll($query, $params);
    }

    public function gridSlaDashboard($currentCdCliente,$periodSlaStart,$periodSlaEnd){
        $query = <<<SQL
SELECT
     ORDER_BY,
     'Chamados' AS NAME,
     SUM(TOTAL_OPEN) AS OPENED,
     SUM(CASE WHEN TOTAL_CLOSE = 1
                     THEN 1
                     ELSE 0
         END ) AS COMPETED,
     SUM(TOTAL_BACK) AS BACKLOG,
     SUM(DECODE(ID_SLA_CHECK,'S',TOTAL_OPEN,0)) AS OPENED_SLA,
     SUM(CASE WHEN TOTAL_CLOSE = 1 AND ID_SLA_CHECK = 'S'
                     THEN 1
                     ELSE 0
         END ) AS COMPETED_SLA,
     SUM(DECODE(ID_SLA_CHECK,'S',TOTAL_BACK,0))  AS BACKLOG_SLA,
     SUM(CASE WHEN ID_SLA_STATUS = 'F' AND TOTAL_OPEN = 1 AND ID_SLA_CHECK = 'S'
                     THEN 1
                     ELSE 0
         END ) AS OPENED_SLA_OUT,
     SUM(CASE WHEN ID_SLA_STATUS = 'F' AND TOTAL_CLOSE = 1 AND   ID_SLA_CHECK = 'S'
                     THEN 1
                     ELSE 0
         END ) AS COMPETED_SLA_OUT,
      SUM(CASE WHEN ID_SLA_STATUS = 'F' AND TOTAL_BACK = 1 AND ID_SLA_CHECK = 'S'
                     THEN 1
                     ELSE 0
         END )  AS BACKLOG_SLA_OUT
FROM (

        SELECT 1 AS ORDER_BY,
                CAL.ID_SLA_CHECK,
                CAL.ID_SLA_STATUS,
                CASE WHEN CAL.DTHOMOLOGACAO IS NULL
                     THEN 1
                     ELSE 0
                END AS TOTAL_BACK,
                CASE WHEN TAS.CREATED_AT BETWEEN TO_DATE( :P_DTINICIO||' 00:00:00' ,'DD/MM/YYYY HH24:MI:SS')
                                       AND TO_DATE( :P_DTFINAL||' 23:59:59' ,'DD/MM/YYYY HH24:MI:SS')
                     THEN 1
                     ELSE 0
                END AS TOTAL_OPEN,
                CASE WHEN(NVL(SLC.CDGRUPFASE, '--') IN ('12', '13') AND TRUNC(NVL(CAL.DTENTREGAESPEC, CAL.DTHOMOLOGACAO)) BETWEEN TO_DATE(:P_DTINICIO, 'DD/MM/YYYY') AND TO_DATE(:P_DTFINAL, 'DD/MM/YYYY'))
                        OR (NVL(SLC.CDGRUPFASE, '--') NOT IN ('12', '13') AND TRUNC(CAL.DTHOMOLOGACAO) BETWEEN TO_DATE(:P_DTINICIO, 'DD/MM/YYYY') AND TO_DATE(:P_DTFINAL, 'DD/MM/YYYY'))
                     THEN 1
                     ELSE 0
                END AS TOTAL_CLOSE
        FROM TASK TAS

        JOIN ALLOCATION SAR ON (SAR.TASK = TAS.ID AND SAR.TYPE = 'S')
        JOIN RESOURCE_T SRE ON (SRE.ID = SAR.RESOURCE_T AND SRE.EXTERNAL_CODE = :P_CDCLIENTE)
        JOIN CLIENTE CLI ON CLI.CDCLIENTE = SRE.EXTERNAL_CODE

        JOIN TASK_STATUS TST ON TST.ID = TAS.TASK_STATUS
        JOIN TASK_TYPE TTY ON TTY.ID = TST.TASK_TYPE

        JOIN PROJECT PRO ON (PRO.ID = TAS.PROJECT)

        JOIN USR_CP_CALL_SLA CAL ON (TAS.ID = CAL.CALL_RELATIONSHIP AND CAL.TYPE = 'I')
        JOIN CLASSIFICATION CLA ON (TAS.CLASSIFICATION = CLA.ID)

        LEFT JOIN SLACLIENTE SLC ON (CLI.CDCLIENTE = SLC.CDCLIENTE AND SLC.CDASSUNTO = CLA.CDASSUNTO)

        WHERE TAS.STATUS = 'A'
        AND TAS.IS_ISSUE = 'Y'

     UNION ALL

        SELECT  1 AS ORDER_BY,
                CAL.ID_SLA_CHECK,
                CAL.ID_SLA_STATUS,
                CASE WHEN CAL.DTHOMOLOGACAO IS NOT NULL
                      THEN 0
                      ELSE 1
                END AS TOTAL_BACK,
                CASE WHEN SER.DTINCLUSAO BETWEEN TO_DATE( :P_DTINICIO||' 00:00:00' ,'DD/MM/YYYY HH24:MI:SS')
                                       AND TO_DATE( :P_DTFINAL||' 23:59:59' ,'DD/MM/YYYY HH24:MI:SS')
                     THEN 1
                     ELSE 0
                END AS TOTAL_OPEN,
                CASE WHEN (NVL(SLC.CDGRUPFASE, '--') IN ('12', '13') AND TRUNC(NVL(CAL.DTENTREGAESPEC, CAL.DTHOMOLOGACAO)) BETWEEN TO_DATE(:P_DTINICIO, 'DD/MM/YYYY') AND TO_DATE(:P_DTFINAL, 'DD/MM/YYYY'))
                        OR (NVL(SLC.CDGRUPFASE, '--') NOT IN ('12', '13') AND TRUNC(CAL.DTHOMOLOGACAO) BETWEEN TO_DATE(:P_DTINICIO, 'DD/MM/YYYY') AND TO_DATE(:P_DTFINAL, 'DD/MM/YYYY'))
                     THEN 1
                     ELSE 0
                END AS TOTAL_CLOSE
        FROM SOLISERV SER
        JOIN PRODUTO PRO ON PRO.CDPRODUTO = SER.CDPRODCOMP
        JOIN PARAMGERAL PAG ON (SER.NRORG = PAG.NRORG)

        JOIN CLIENTE CLI ON CLI.CDCLIENTE = SER.CDCLIENTE AND SER.CDCLIENTE = :P_CDCLIENTE

        JOIN USR_CP_CALL_SLA CAL ON (SER.NRSOLISERV = CAL.CALL_RELATIONSHIP AND CAL.TYPE = 'S')
        LEFT JOIN SLACLIENTE SLC ON (CLI.CDCLIENTE = SLC.CDCLIENTE AND SLC.CDASSUNTO = SER.CDASSUNTO)
        WHERE SER.CDCLIENTE = :P_CDCLIENTE
)
GROUP BY ORDER_BY
ORDER BY ORDER_BY ASC

SQL;

        $params = array(
            "P_CDCLIENTE" => $currentCdCliente,
            "P_DTINICIO" => $periodSlaStart,
            "P_DTFINAL" => $periodSlaEnd,
        );
        return $this->getEntityManager()->getConnection()->fetchAll($query, $params);
    }

    public function findSLAClassification(){
        $query = <<<SQL
SELECT DISTINCT
    *
FROM (
        SELECT NVL(TO_CHAR(C.ID),ASS.CDASSUNTO||'_S') AS ID, NVL(C.LABEL,ASS.NMASSUNTO) AS LABEL
              		  FROM ASSUNTO ASS
                 LEFT JOIN CLASSIFICATION C ON (C.CDASSUNTO = ASS.CDASSUNTO)
             		 WHERE NOT (INSTR(ASS.NMASSUNTO, 'INATIVO') > 0)
               		   AND ASS.CDASSUNTO IN(00010,00011,00012,00013,00021,00029,01800)
       UNION ALL

       SELECT TO_CHAR(ID) AS ID ,LABEL
       FROM CLASSIFICATION
       WHERE IS_TASK = 'Y' AND CONTROL IS NULL

)
ORDER BY LABEL
SQL;


        return $this->getEntityManager()->getConnection()->fetchAll($query);
    }

    public function findDashboardBarOpenAndBacklogByProduct($currentCdCliente,$periodSlaStart,$periodSlaEnd){
        $query = <<<SQL
SELECT
     NMPRODUTO,
     SUM(TOTAL_BACK) AS TOTAL_BACK,
     SUM(TOTAL_OPEN) AS TOTAL_OPEN,
     SUM(DECODE(ID_SLA_CHECK,'S',TOTAL_BACK,0))  AS TOTAL_BACK_SLA,
     SUM(DECODE(ID_SLA_CHECK,'S',TOTAL_OPEN,0)) AS TOTAL_OPEN_SLA,
     PRODUCT_NAME,TYPE
FROM (

        SELECT PRO.NAME||' (Mobile)' AS NMPRODUTO,PRO.NAME AS PRODUCT_NAME,'I' AS TYPE,
                CAL.ID_SLA_CHECK,
                  CASE WHEN CAL.DTHOMOLOGACAO IS NOT NULL
                      THEN 0
                      ELSE 1
                END AS TOTAL_BACK,
                CASE WHEN TAS.CREATED_AT BETWEEN TO_DATE( :P_DTINICIO||' 00:00:00' ,'DD/MM/YYYY HH24:MI:SS')
                                       AND TO_DATE( :P_DTFINAL||' 23:59:59' ,'DD/MM/YYYY HH24:MI:SS')
                     THEN 1
                     ELSE 0
                END AS TOTAL_OPEN
        FROM TASK TAS

        JOIN ALLOCATION SAR ON (SAR.TASK = TAS.ID AND SAR.TYPE = 'S')
        JOIN RESOURCE_T SRE ON (SRE.ID = SAR.RESOURCE_T AND SRE.EXTERNAL_CODE = :P_CDCLIENTE)
        JOIN CLIENTE CLI ON CLI.CDCLIENTE = SRE.EXTERNAL_CODE

        JOIN TASK_STATUS TST ON TST.ID = TAS.TASK_STATUS
        JOIN TASK_TYPE TTY ON TTY.ID = TST.TASK_TYPE

        JOIN PROJECT PRO ON (PRO.ID = TAS.PROJECT)

        JOIN USR_CP_CALL_SLA CAL ON (TAS.ID = CAL.CALL_RELATIONSHIP AND CAL.TYPE = 'I')

        WHERE TAS.STATUS = 'A'
        AND TAS.IS_ISSUE = 'Y'

     UNION ALL

        SELECT  PRO.NMPRODUTO||' (Delphi)', PRO.NMPRODUTO AS PRODUCT_NAME,'S' AS TYPE,
                CAL.ID_SLA_CHECK,
                CASE WHEN CAL.DTHOMOLOGACAO IS NOT NULL
                      THEN 0
                      ELSE 1
                END AS TOTAL_BACK,
                CASE WHEN SER.DTINCLUSAO BETWEEN TO_DATE( :P_DTINICIO||' 00:00:00' ,'DD/MM/YYYY HH24:MI:SS')
                                       AND TO_DATE( :P_DTFINAL||' 23:59:59' ,'DD/MM/YYYY HH24:MI:SS')
                     THEN 1
                     ELSE 0
                END AS TOTAL_OPEN
        FROM SOLISERV SER
        JOIN PRODUTO PRO ON PRO.CDPRODUTO = SER.CDPRODCOMP
        JOIN PARAMGERAL PAG ON (SER.NRORG = PAG.NRORG)

        JOIN CLIENTE CLI ON CLI.CDCLIENTE = SER.CDCLIENTE AND SER.CDCLIENTE = :P_CDCLIENTE

        JOIN USR_CP_CALL_SLA CAL ON (SER.NRSOLISERV = CAL.CALL_RELATIONSHIP AND CAL.TYPE = 'S')

        WHERE SER.CDCLIENTE = :P_CDCLIENTE
)
GROUP BY NMPRODUTO,PRODUCT_NAME,TYPE
ORDER BY TOTAL_BACK DESC
SQL;

        $params = array(
            "P_CDCLIENTE" => $currentCdCliente,
            "P_DTINICIO" => $periodSlaStart,
            "P_DTFINAL" => $periodSlaEnd,
        );
        return $this->getEntityManager()->getConnection()->fetchAll($query,$params);
    }

    public function findDashboardBarBecklogByProduct(){
        $query = <<<SQL
      SELECT DECODE(SLA.PROJECT_ID, NULL, SLA.NMPRODUTO||' (Delphi)', SLA.PROJECT_NAME||' (Mobile)') AS NMPRODUTO, COUNT(*) AS TOTAL
        FROM TABLE (USR_SLA_CONTROL (:P_DTINICIO, :P_DTFINAL, :P_CDCLIENTE)) SLA
        WHERE SLA.DTHOMOLOGACAO IS NULL
        GROUP BY SLA.PROJECT_ID, SLA.NMPRODUTO, SLA.PROJECT_NAME
        ORDER BY COUNT(*) DESC
SQL;

        $params = array(
            "P_CDCLIENTE" => 'J67945071001967',
            "P_DTINICIO" => '01/06/2020',
            "P_DTFINAL" => '30/11/2020',
        );
        return $this->getEntityManager()->getConnection()->fetchAll($query, $params);
    }

    public function findSLADetails($cdfilial, $callRelationship)
    {
        $query = <<<SQL
           SELECT
           CLI.NMRAZSOCCLIE,
           SOL.DSREFESOLI,
           GRF.NMGRUPFASE,
           GRF.IDRESPFASE,
           SOL.CDFILIAL,
           SOL.NRSOLISERV,
           OPE.NMOPERADOR AS NMOPERRESP,
           SLA.DTINIPREVSLA,
           SLA.DTFIMPREVSLA,
           DECODE(SCL.IDPRAZOSLA, '1', SCL.QTDIASSLA, SOL.QTDIASOLIORC) AS QTDIASSLA,
           SLA.DTFIMREALSLA,
           TRUNC(SYSDATE) AS DATA,
           NVL(SCL.QTDIASSLA2, 0) AS QTDIASSLA2,
           NVL(SCL.QTDIASSLA3, 0) AS QTDIASSLA3,
           GRF.CDGRUPFASE,
           CASE WHEN SLA.DTFIMREALSLA IS NULL THEN TRUNC(SYSDATE) ELSE SLA.DTFIMREALSLA END AS DTFINAL
        FROM
           SLACLIENTE SCL,
           SOLISERV SOL,
           LOGSOLISLA SLA,
           GRUPFASE GRF,
           OPERADOR OPE,
           CLIENTE CLI
        WHERE
           (SLA.NRSOLISERV  = :P_NRSOLISERV)   AND
           (SOL.CDCLIENTE = SLA.CDCLIENTE) AND
           (SLA.CDFILIAL    = :P_CDFILIAL)     AND
           (SOL.CDFILIAL    = SLA.CDFILIAL)    AND
           (SOL.NRSOLISERV  = SLA.NRSOLISERV)  AND
           (GRF.CDGRUPFASE  = SLA.CDGRUPFASE)  AND
           (OPE.CDOPERADOR  = SOL.CDOPERRESP)  AND
           (SCL.CDCLIENTE   = SOL.CDCLIENTE)   AND
           (SCL.CDCOMPLEXID = SLA.CDCOMPLEXID) AND
           (SCL.CDASSUNTO   = SLA.CDASSUNTO)   AND
           (SCL.CDGRUPFASE  = SLA.CDGRUPFASE
           AND SOL.CDCLIENTE = CLI.CDCLIENTE)
        ORDER BY SLA.DTINIPREVSLA ASC, SLA.DTHRENTRGRFA ASC
SQL;

         $params = array(
            "P_NRSOLISERV" => $callRelationship,
            "P_CDFILIAL" => $cdfilial
        );
        return $this->getEntityManager()->getConnection()->fetchAll($query, $params);

    }

    public function findDiasNaoUteis($cdfilial, $dataPrev, $dataAtual)
    {
        $query = <<<SQL
           SELECT COUNT(DTFERIFILI) AS DIAS
        FROM FERIFILI
        WHERE (CDFILIAL   = :P_CDFILIAL)
          AND (DTFERIFILI BETWEEN :P_DSDATA AND :P_DSDATA2)
SQL;

         $params = array(
            "P_CDFILIAL" => $cdfilial,
            "P_DSDATA" => substr($dataPrev, 0, 10),
            "P_DSDATA2" => substr($dataAtual    , 0, 10)
        );
        return $this->getEntityManager()->getConnection()->fetchAll($query, $params);

    }

    public function verifySlaVisibility($cdcliente, $callRelationship)
    {
        $query = <<<SQL
          SELECT COUNT(CDCLIENTE) CONTADOR
            FROM SLACLIENTE SLA
            WHERE SLA.CDCLIENTE = '$cdcliente'
SQL;

        return $this->getEntityManager()->getConnection()->fetchAll($query);

    }




    public function getQueryTicketCalls($situationFilters, $specialFilters, $situation, $whereFilters, $clienteWhere, $filterSLA = '')
    {
        $gepOpened  = implode(',', $situationFilters['CRM']['OPENED']);
        $gepWaiting = implode(',', $situationFilters['CRM']['WAITING']);
        $gepClosed  = implode(',', $situationFilters['CRM']['CLOSED']);

        $query = <<<SQL
            SELECT * FROM(SELECT TO_CHAR(ID) AS ID,
                    TO_CHAR(NRORG) AS NRORG,
                    TO_CHAR(NRSEQCONTATO) AS CALL_RELATIONSHIP,
                    TO_CHAR(CDCLIENTE) AS CDCLIENTE,
                    TO_CHAR(CDFILIAL) AS CDFILIAL,
                    TO_CHAR(REFERENCE) AS REFERENCE,
                    TO_CHAR(CLASSIFICATION) AS CLASSIFICATION,
                    TO_CHAR(CLASSIFICATION_NAME) AS CLASSIFICATION_NAME,
                    TO_CHAR(REPORTED_BY) AS REPORTED_BY,
                    TO_CHAR(IS_ACTIVE) AS IS_ACTIVE,
                    TO_CHAR(REPORTER_NAME) AS REPORTER_NAME,
                    TO_CHAR(PRODUCT) AS PRODUCT,
                    TO_CHAR(TYPE) AS TYPE,
                    LABEL_DESCRIPTION, NRCALLLABEL,
                    'T - ' || NRSEQCONTATO AS TEKNISA_ID,
                    TO_CHAR(CAUSE) AS CAUSE,
                    TO_CHAR(CAUSE_NAME) AS CAUSE_NAME,
                    TO_CHAR(PRODUCT_NAME) AS PRODUCT_NAME,
                    TO_CHAR(CREATED_ORDER) AS CREATED_ORDER,
                    TO_CHAR(UPDATED_AT, 'DD/MM/YYYY') AS UPDATED,
                    CREATED_AT,
                    TO_CHAR(CLOSED) AS CLOSED,
                    TO_CHAR(STATUS) AS STATUS,
                    TO_CHAR(UPDATED_AT, 'YYYYMMDD') AS UPDATED_ORDER,
                    UPDATED_AT,
                    TO_CHAR(END_DATE) AS PLANNED_DATE,
                    'S' AS MAIN_TYPE_CALL,
                    'Produto' AS MAIN_TYPE_CALL_DESCRIPTION,
                    TO_CHAR(PRODUCT_RESPONSABLE_CODE) AS PRODUCT_RESPONSABLE_CODE,
                    TO_CHAR(TEKNISA_INTERLOCUTOR_CODE) AS TEKNISA_INTERLOCUTOR_CODE,
                    TO_CHAR(PLANNED_VERSION) AS PLANNED_VERSION,
                    TO_CHAR(PLANNED_VALUE) AS PLANNED_VALUE,
                    TO_CHAR(RESPONSABLE_DIVISION_CODE) AS RESPONSABLE_DIVISION_CODE,
                    TO_CHAR(CUSTOMER_RESPONSABLE_CODE) AS CUSTOMER_RESPONSABLE_CODE,
                    TO_CHAR(CUSTOMER_INTERLOCUTOR_CODE) AS CUSTOMER_INTERLOCUTOR_CODE,
                    TO_CHAR(CUSTOMER_INTERLOCUTOR) AS CUSTOMER_INTERLOCUTOR,
                    TO_CHAR(CALL_PRIORITY) AS CALL_PRIORITY,
                    TO_CHAR(RESPONSIBLE_OF_THE_PRODUCT) AS RESPONSIBLE_OF_THE_PRODUCT,
                    TO_CHAR(RESPONSIBLE_OF_THE_CUSTOMER) AS RESPONSIBLE_OF_THE_CUSTOMER,
                    TO_CHAR(TEKNISA_INTERLOCUTOR) AS TEKNISA_INTERLOCUTOR,
                    TO_CHAR(RESPONSABLE_DIVISION) AS RESPONSABLE_DIVISION,
                    TO_CHAR(NMRAZSOCCLIE) AS NMRAZSOCCLIE,
                    TO_CHAR(NMFANTCLIE) AS NMFANTCLIE,
                    NULL AS VERSION_DEV,
                    TO_CHAR(CDOPERRESP) AS CDOPERRESP,
                    TO_CHAR(NMOPERRESP) AS NMOPERRESP,TEXT_SMALL_1, TEXT_SMALL_2, TEXT_SMALL_3, TEXT_SMALL_4, TEXT_SMALL_5,
                    TEXT_LONG_1,TEXT_LONG_2,TEXT_LONG_3,TEXT_LONG_4,TEXT_LONG_5,
                    NUMBER_1,NUMBER_2,NUMBER_3,NUMBER_4,NUMBER_5,DATE_1,DATE_2,DATE_3,DATE_4,DATE_5, 'Produto Mobile' as PRODUCT_TYPE_NAME
                  FROM (

                    SELECT C.NRCALL AS ID,CONT.NRORG,CONT.NRSEQCONTATO,CLI.CDCLIENTE, NULL AS CDFILIAL,DSREFECONT AS REFERENCE,CONT.CDMOTICONT as CLASSIFICATION,
                    MOTI.NMMOTICONT AS CLASSIFICATION_NAME, OPR.CDOPERADOR AS REPORTED_BY, IDSTATUSCONT AS IS_ACTIVE, OPR.NMOPERADOR AS REPORTER_NAME,
                    CONT.CDPRODUTO AS PRODUCT,'T' AS TYPE,LABEL.DESCRIPTION AS LABEL_DESCRIPTION,LABEL.NRCALLLABEL,C.CALL_RELATIONSHIP,C.CAUSE,
                    '' AS CAUSE_NAME,PRO.NMPRODUTO AS PRODUCT_NAME,TO_CHAR(CONT.DTINCLUSAO, 'YYYYMMDD') AS CREATED_ORDER,
                    CONT.DTULTATU AS UPDATED_AT,
                    CASE WHEN CONT.NRSEQSITUACAO IN ($gepWaiting) -- Aguardando cliente
                         THEN 'Aguardando ação do cliente'
                         WHEN CONT.NRSEQSITUACAO IN ($gepOpened) -- Solicitação aberta,Não iniciado
                         THEN 'Em aberto'
                         WHEN CONT.NRSEQSITUACAO IN ($gepClosed) -- Resolvido,Encerrado
                         THEN 'Fechado'
                         ELSE 'Em progresso'
                    END AS STATUS,
                    OP.CDOPERADOR AS CDOPERRESP,
                    OP.NMOPERADOR AS NMOPERRESP,
                    CASE WHEN CONT.NRSEQSITUACAO IN ($gepClosed)
                            THEN 'Y'
                            ELSE NULL
                    END AS CLOSED,NULL AS END_DATE,
                    CONT.DTINCLUSAO AS CREATED_AT,C.PRODUCT_RESPONSABLE_CODE, C.TEKNISA_INTERLOCUTOR_CODE,
                    C.PLANNED_VERSION,C.PLANNED_VALUE,C.RESPONSABLE_DIVISION_CODE,C.CUSTOMER_INTERLOCUTOR_CODE,C.CUSTOMER_RESPONSABLE_CODE,
                    INTE.NMINTECLIE AS CUSTOMER_INTERLOCUTOR, PRI.DSPRIORIDADE AS CALL_PRIORITY, RESPROD.NMOPERADOR AS RESPONSIBLE_OF_THE_PRODUCT,
                    RESPCLIE.NMOPERADOR AS RESPONSIBLE_OF_THE_CUSTOMER,TEKINTE.NMOPERADOR AS TEKNISA_INTERLOCUTOR,
                    CLASOPORT.NMCLASSOPORT AS RESPONSABLE_DIVISION,CLI.NMRAZSOCCLIE,CLI.NMFANTCLIE,C.TEXT_SMALL_1,
                     C.TEXT_SMALL_2, C.TEXT_SMALL_3, C.TEXT_SMALL_4, C.TEXT_SMALL_5,C.TEXT_LONG_1,C.TEXT_LONG_2,C.TEXT_LONG_3,
                      C.TEXT_LONG_4,C.TEXT_LONG_5,C.NUMBER_1,C.NUMBER_2,C.NUMBER_3,C.NUMBER_4,C.NUMBER_5,C.DATE_1,C.DATE_2,C.DATE_3,C.DATE_4,C.DATE_5

                    FROM CONTATO CONT
                    JOIN CLIENTE CLI ON CLI.NRPARCNEGOCIO  = CONT.NRPARCNEGOCIO
                    JOIN OPERADOR OPR ON(OPR.NRPARCNEGOCIO = CONT.NRPARCINTERLOCUTOR)
                    JOIN MOTICONT MOTI ON (MOTI.CDMOTICONT = CONT.CDMOTICONT)
                    JOIN PRODUTO PRO ON(PRO.CDPRODUTO = CONT.CDPRODUTO AND (PRO.PROJECT_ID IS NOT NULL OR (PRO.CDPRODCOMP IS NOT NULL AND PRO.CDPRODGRUP IS NOT NULL)))
               LEFT JOIN OPERADOR OP ON OP.CDOPERADOR = CONT.CDOPERCONT
               LEFT JOIN CP_CALL C ON (CONT.NRSEQCONTATO = C.CALL_RELATIONSHIP AND C.TYPE = 'T')
               LEFT JOIN CP_CALL_LABEL_RELATION LABEL_REL ON LABEL_REL.CALL = C.NRCALL
               LEFT JOIN CP_CALL_LABEL LABEL ON LABEL_REL.LABEL = LABEL.NRCALLLABEL
               LEFT JOIN INTECLIE INTE ON INTE.CDINTECLIE = C.CUSTOMER_INTERLOCUTOR_CODE AND INTE.CDCLIENTE = CONT.CDCLIENTE
               LEFT JOIN CRM_PRIORIDADE PRI ON PRI.NRPRIORIDADE = C.PRIORITY_CODE
               LEFT JOIN OPERADOR RESPROD ON RESPROD.CDOPERADOR = C.PRODUCT_RESPONSABLE_CODE
               LEFT JOIN PARCLIEFAS PARCLIE ON PARCLIE.CDCLIENTE = CONT.CDCLIENTE AND IDTPFATUCLIE = '5'
               LEFT JOIN OPERADOR RESPCLIE ON RESPCLIE.CDOPERADOR = PARCLIE.CDGERENTEIMPCLI
               LEFT JOIN OPERADOR TEKINTE ON TEKINTE.CDOPERADOR = C.TEKNISA_INTERLOCUTOR_CODE
               LEFT JOIN CRM_CLASSOPORTUNI CLASOPORT ON CLASOPORT.NRSEQCLASSOPORT = C.RESPONSABLE_DIVISION_CODE
               LEFT JOIN ORGANIZACAO ORG ON ORG.NRPARCNEGOCIO = CLI.NRPARCNEGOCIO

                   WHERE CONT.IDTIPOCONTATO = 'CHAMADO'
                  AND ($clienteWhere)
                         $specialFilters
                         $situation
                         $filterSLA
                         ))
               WHERE 1=1
                     $whereFilters
SQL;
        //return $query;
        return "";
    }

    public function getGroupedByLabelsSqlJoins($sqlJoins){

        $groupedByLabelsSqlJoins = "LEFT JOIN CP_CALL_LABEL_RELATION LABEL_REL ON LABEL_REL.CALL = CALL.ID
                        LEFT JOIN CP_CALL_LABEL LABEL ON LABEL_REL.LABEL = LABEL.NRCALLLABEL ";

        return $sqlJoins.$groupedByLabelsSqlJoins;

    }

    public function getUnsentEmails(){
        $query = <<<SQL
        SELECT OPR.DSEMAILOPER,
               LFT.CDFILIAL, LFT.NRSOLISERV, TO_DATE(LFT.DTALFASETRAM) AS DTALFASETRAM,  SER.DSREFESOLI, OPA.NMOPERADOR,
               OPE.NMOPERADOR AS SOLI, OPE.CDOPERADOR AS SOLICD, OPR.NMOPERADOR AS RESP, OPR.CDOPERADOR AS RESPCD,
               LFT.DSALFASETRAM, LFT.TXACAOLFTRAM
          FROM SOLISERV SER
          JOIN LOGFASETRAM LFT ON SER.NRSOLISERV = LFT.NRSOLISERV
          JOIN OPERADOR OPR ON OPR.CDOPERADOR = LFT.CDOPERRESP
          JOIN OPERADOR OPE ON OPE.CDOPERADOR = LFT.CDOPERADOR
          JOIN OPERADOR OPA ON OPA.CDOPERADOR = SER.CDOPERADOR
         WHERE OPR.DSEMAILOPER IS NOT NULL
           AND LFT.IDEMAILENV = 'N'
           AND LFT.CDOPERRESP <> LFT.CDOPERADOR
           AND ((SER.CDCLIENTE = OPR.CDCLIENTE) OR (SER.CDCLIENTE = OPE.CDCLIENTE))
SQL;
        return $this->getEntityManager()->getConnection()->fetchAll($query);
    }

    public function getQueryIntranetCalls($situationFilters, $specialFilters, $situation, $whereFilters, $clienteWhere,
                                          $filterSLA = '',$filterSLAClas = '',$filterSLAAss = '', $soliFilter = '',$filterHomo = '',$filterSprint= '')
    {
        $session = \Zeedhi\Framework\DependencyInjection\InstanceManager::getInstance()->getService('session');
        $lang = $session && $session->get('LOGIN_LANGUAGE') ? $session->get('LOGIN_LANGUAGE') : 'pt_br';
        $lang = explode('_', $lang)[0];

        $mainTypeDesc = 'Produto';
        $productTypeName = 'Produto Mobile';
        $lastVersionDesc = 'Última versão';
        $statusWaitingClient = 'Aguardando ação do cliente';
        $statusOpened = 'Em aberto';
        $statusClosed = 'Fechado';
        $statusInProgress = 'Em progresso';

        if($lang == 'en') {
            $mainTypeDesc = 'Product';
            $productTypeName = 'Mobile Product';
            $lastVersionDesc = 'Last version';
            $statusWaitingClient = 'Waiting for customer action';
            $statusOpened = 'Opened';
            $statusClosed = 'Closed';
            $statusInProgress = 'In progress';
        } else if($lang == 'es') {
            $mainTypeDesc = 'Producto';
            $productTypeName = 'Producto Mobile';
            $lastVersionDesc = 'Última versión';
            $statusWaitingClient = 'Esperando la acción del cliente';
            $statusOpened = 'Pendiente';
            $statusClosed = 'Cerrado';
            $statusInProgress = 'En progreso';
        }

        $gepOpened  = $situationFilters['GEP']['OPENED'];
        $gepWaiting = $situationFilters['GEP']['WAITING'];
        $gepClosed  = $situationFilters['GEP']['CLOSED'];

        $query = <<<SQL
            SELECT * FROM(SELECT  TO_CHAR(ID) AS ID,
                    TO_CHAR(NRORG) AS NRORG,
                    TO_CHAR(NRSOLISERV) AS CALL_RELATIONSHIP,
                    TO_CHAR(CDCLIENTE) AS CDCLIENTE,
                    TO_CHAR(CDFILIAL) AS CDFILIAL,
                    TO_CHAR(REFERENCE) AS REFERENCE,
                    TO_CHAR(CLASSIFICATION) AS CLASSIFICATION,
                    TO_CHAR(CLASSIFICATION_NAME) AS CLASSIFICATION_NAME,
                    TO_CHAR(REPORTED_BY) AS REPORTED_BY,
                    TO_CHAR(IS_ACTIVE) AS IS_ACTIVE,
                    TO_CHAR(REPORTER_NAME) AS REPORTER_NAME,
                    TO_CHAR(PRODUCT) AS PRODUCT,
                    TO_CHAR(TYPE) AS TYPE,
                    LABEL_DESCRIPTION, NRCALLLABEL,
                        CASE TYPE
                        WHEN 'I'
                            THEN 'I - ' || CALL_RELATIONSHIP
                        WHEN 'S'
                            THEN 'S - ' || CALL_RELATIONSHIP
                        ELSE
                            CALL_RELATIONSHIP
                        END AS TEKNISA_ID,
                    TO_CHAR(CAUSE) AS CAUSE,
                    TO_CHAR(CAUSE_NAME) AS CAUSE_NAME,
                    TO_CHAR(PRODUCT_NAME) AS PRODUCT_NAME,
                    TO_CHAR(CREATED_ORDER) AS CREATED_ORDER,
                    TO_CHAR(NVL(UPDATED_AT,UPDATED), 'DD/MM/YYYY') AS UPDATED,
                    CREATED_AT,
                    TO_CHAR(CLOSED) AS CLOSED,
                    TO_CHAR(STATUS) AS STATUS,
                    TO_CHAR(UPDATED_AT, 'YYYYMMDD') AS UPDATED_ORDER,
                    UPDATED_AT,
                    TO_CHAR(DTCOMPROMISS) AS PLANNED_DATE,
                    'P' AS MAIN_TYPE_CALL,
                    '$mainTypeDesc' AS MAIN_TYPE_CALL_DESCRIPTION,
                    TO_CHAR(PRODUCT_RESPONSABLE_CODE) AS PRODUCT_RESPONSABLE_CODE,
                    TO_CHAR(TEKNISA_INTERLOCUTOR_CODE) AS TEKNISA_INTERLOCUTOR_CODE,
                    TO_CHAR(PLANNED_VERSION) AS PLANNED_VERSION,
                    TO_CHAR(PLANNED_VALUE) AS PLANNED_VALUE,
                    TO_CHAR(RESPONSABLE_DIVISION_CODE) AS RESPONSABLE_DIVISION_CODE,
                    TO_CHAR(CUSTOMER_RESPONSABLE_CODE) AS CUSTOMER_RESPONSABLE_CODE,
                    TO_CHAR(CUSTOMER_INTERLOCUTOR_CODE) AS CUSTOMER_INTERLOCUTOR_CODE,
                    TO_CHAR(CUSTOMER_INTERLOCUTOR) AS CUSTOMER_INTERLOCUTOR,
                    TO_CHAR(CALL_PRIORITY) AS CALL_PRIORITY,
                    TO_CHAR(RESPONSIBLE_OF_THE_PRODUCT) AS RESPONSIBLE_OF_THE_PRODUCT,
                    TO_CHAR(RESPONSIBLE_OF_THE_CUSTOMER) AS RESPONSIBLE_OF_THE_CUSTOMER,
                    TO_CHAR(TEKNISA_INTERLOCUTOR) AS TEKNISA_INTERLOCUTOR,
                    TO_CHAR(RESPONSABLE_DIVISION) AS RESPONSABLE_DIVISION,
                    TO_CHAR(NMRAZSOCCLIE) AS NMRAZSOCCLIE,
                    TO_CHAR(NMFANTCLIE) AS NMFANTCLIE,
                    TO_CHAR(null) AS VERSION_DEV,
                    TO_CHAR(CDOPERRESP) AS CDOPERRESP,
                    TO_CHAR(NMOPERRESP) AS NMOPERRESP,TEXT_SMALL_1, TEXT_SMALL_2, TEXT_SMALL_3, TEXT_SMALL_4, TEXT_SMALL_5,
                    TEXT_LONG_1,TEXT_LONG_2,TEXT_LONG_3,TEXT_LONG_4,TEXT_LONG_5,
                    NUMBER_1,NUMBER_2,NUMBER_3,NUMBER_4,NUMBER_5,DATE_1,DATE_2,DATE_3,DATE_4,DATE_5,
                    TO_CHAR(PRODUCT_TYPE_NAME) AS PRODUCT_TYPE_NAME,
                    TO_CHAR(CDARVPROD) AS CDARVPROD,DTHOMOLOGACAO, VRORCAMENTO
                 FROM  (
                    SELECT  SER.NRSOLISERV,C.NRCALL AS ID, NVL(C.NRORG, SER.NRORG) AS NRORG, SER.CDCLIENTE, SER.CDFILIAL,
                            SER.DSREFESOLI AS REFERENCE, NVL(CLA.ID,ASS.CDASSUNTO) AS CLASSIFICATION,
                            SER.CDOPERADOR AS REPORTED_BY, '' AS CAUSE_NAME,
                            SER.IDATIVO AS IS_ACTIVE, OPE.NMOPERADOR AS REPORTER_NAME,
                            SER.CDPRODCOMP AS PRODUCT, NVL(C.TYPE, 'S') AS TYPE,
                            PRO.NMPRODUTO AS PRODUCT_NAME, NVL(CLA.LABEL,ASS.NMASSUNTO) AS CLASSIFICATION_NAME,
                            TO_CHAR(SER.NRSOLISERV) AS CALL_RELATIONSHIP, C.CAUSE, SER.DTULTATU AS UPDATED, SER.DTCOMPROMISS,
                            TO_CHAR(SER.DTINCLUSAO, 'YYYYMMDD') AS CREATED_ORDER,
                            SER.DTINCLUSAO AS CREATED_AT,
                            C.PRODUCT_RESPONSABLE_CODE,
                            C.TEKNISA_INTERLOCUTOR_CODE,
                            C.PLANNED_VERSION,
                            C.PLANNED_VALUE,
                            C.RESPONSABLE_DIVISION_CODE,
                            C.CUSTOMER_INTERLOCUTOR_CODE,
                            C.CUSTOMER_RESPONSABLE_CODE,
                            INTE.NMINTECLIE AS CUSTOMER_INTERLOCUTOR,
                            PRI.DSPRIORIDADE AS CALL_PRIORITY,
                            RESPROD.NMOPERADOR AS RESPONSIBLE_OF_THE_PRODUCT,
                            RESPCLIE.NMOPERADOR AS RESPONSIBLE_OF_THE_CUSTOMER,
                            TEKINTE.NMOPERADOR AS TEKNISA_INTERLOCUTOR,
                            CLASOPORT.NMCLASSOPORT AS RESPONSABLE_DIVISION,
                            CLI.NMRAZSOCCLIE,
                            CLI.NMFANTCLIE,
                            LABEL.DESCRIPTION AS LABEL_DESCRIPTION,
                            LABEL.NRCALLLABEL,
                            (SELECT MAX(LFT.DTINCLUSAO) FROM LOGFASETRAM LFT WHERE (LFT.NRSOLISERV = SER.NRSOLISERV AND LFT.CDFILIAL = SER.CDFILIAL) )AS UPDATED_AT,
                           CASE WHEN $gepClosed  THEN '$statusClosed'
                                WHEN $gepWaiting THEN '$statusWaitingClient'
                                WHEN $gepOpened  THEN '$statusOpened'
                                ELSE '$statusInProgress'
                            END AS STATUS,
                           CASE WHEN (SER.CDFASETRAM IN (SELECT CDFATRAMENCE
                                                           FROM PARAMGERAL PARA
                                                          WHERE PARA.NRORG = SER.NRORG))
                                  OR (SER.IDSOLIENCE = 'S')
                                THEN 'Y'
                           ELSE NULL
                            END AS CLOSED,
                            TO_CHAR(CDOPERRESP) AS CDOPERRESP,
                            TO_CHAR(OPER.NMOPERADOR) AS NMOPERRESP, C.TEXT_SMALL_1, C.TEXT_SMALL_2, C.TEXT_SMALL_3, C.TEXT_SMALL_4, C.TEXT_SMALL_5,
                            C.TEXT_LONG_1,C.TEXT_LONG_2,C.TEXT_LONG_3,C.TEXT_LONG_4,C.TEXT_LONG_5,C.NUMBER_1,C.NUMBER_2,C.NUMBER_3,C.NUMBER_4,C.NUMBER_5,
                            C.DATE_1,C.DATE_2,C.DATE_3,C.DATE_4,C.DATE_5,PRT.NMPRODUTO as PRODUCT_TYPE_NAME, PRO.CDARVPROD,C.DTHOMOLOGACAO,
                            COALESCE(
                            (SELECT SUM(VRTOTITEMCOMDESC)
                            FROM FCT_NEGOCIACAOPROPOSTA NEG
                            WHERE NEG.NRSEQORCAMENTO = ORCA.NRSEQORCAMENTO),
                            0
                            ) AS VRORCAMENTO
                      FROM  SOLISERV SER
                      JOIN  OPERADOR OPE ON OPE.CDOPERADOR = SER.CDOPERADOR
                      JOIN  PRODUTO PRO  ON PRO.CDPRODUTO = SER.CDPRODCOMP
                      JOIN  ASSUNTO ASS  ON ASS.CDASSUNTO = SER.CDASSUNTO
                 LEFT JOIN PRODUTO PRT ON  (PRT.CDPRODUTO = SER.CDPRODGRUP)
                 LEFT JOIN CLASSIFICATION CLA ON(CLA.CDASSUNTO = ASS.CDASSUNTO)
                 LEFT JOIN OPERADOR OPER ON SER.CDOPERRESP = OPER.CDOPERADOR
                 LEFT JOIN  CP_CALL C    ON C.CALL_RELATIONSHIP = SER.NRSOLISERV AND C.TYPE = 'S'
                 LEFT JOIN INTECLIE INTE ON INTE.CDINTECLIE = C.CUSTOMER_INTERLOCUTOR_CODE AND INTE.CDCLIENTE = SER.CDCLIENTE
                 LEFT JOIN CRM_PRIORIDADE PRI ON PRI.NRPRIORIDADE = C.PRIORITY_CODE
                 LEFT JOIN OPERADOR RESPROD ON RESPROD.CDOPERADOR = C.PRODUCT_RESPONSABLE_CODE
                 LEFT JOIN PARCLIEFAS PARCLIE ON PARCLIE.CDCLIENTE = SER.CDCLIENTE AND IDTPFATUCLIE = '5'
                 LEFT JOIN OPERADOR RESPCLIE ON RESPCLIE.CDOPERADOR = PARCLIE.CDGERENTEIMPCLI
                 LEFT JOIN OPERADOR TEKINTE ON TEKINTE.CDOPERADOR = C.TEKNISA_INTERLOCUTOR_CODE
                 LEFT JOIN CRM_CLASSOPORTUNI CLASOPORT ON CLASOPORT.NRSEQCLASSOPORT = C.RESPONSABLE_DIVISION_CODE
                 LEFT JOIN CLIENTE CLI ON CLI.CDCLIENTE = SER.CDCLIENTE
                 LEFT JOIN CP_CALL_LABEL_RELATION LABEL_REL ON LABEL_REL.CALL = C.NRCALL
                 LEFT JOIN CP_CALL_LABEL LABEL ON LABEL_REL.LABEL = LABEL.NRCALLLABEL
                 LEFT JOIN SLACLIENTE SLC ON (CLI.CDCLIENTE = SLC.CDCLIENTE AND SLC.CDASSUNTO = SER.CDASSUNTO)
                 LEFT JOIN USR_CP_CALL_SLA CAL2 ON (SER.NRSOLISERV = CAL2.CALL_RELATIONSHIP AND CAL2.TYPE = 'S')
                 LEFT JOIN FCT_ORCAMENTO ORCA ON SER.NRSOLISERV = ORCA.NRSOLISERV  AND ORCA.IDSITUACAOORCAMENTO NOT IN ('CANCELADO')
                 WHERE ($clienteWhere)
                            $specialFilters
                            $situation
                            $filterSLA
                            $filterSLAClas
                            $filterSLAAss
                            $filterHomo
                            $filterSprint
                            $soliFilter))
                  WHERE 1=1
                        $whereFilters
SQL;
        return $query;
    }

    public function getQueryPmCalls($situationFilters, $specialFilters, $situation, $whereFilters, $clienteWhere,$filterSLA = '',$filterSLAClas = '', $mobFilter = '',$filterHomo ='',$filterSprint = '')
    {
        $session = \Zeedhi\Framework\DependencyInjection\InstanceManager::getInstance()->getService('session');
        $lang = $session && $session->get('LOGIN_LANGUAGE') ? $session->get('LOGIN_LANGUAGE') : 'pt_br';
        $lang = explode('_', $lang)[0];

        $mainTypeDesc = 'Produto';
        $productTypeName = 'Produto Mobile';
        $lastVersionDesc = 'Última versão';
        $statusWaitingClient = 'Aguardando ação do cliente';
        $statusOpened = 'Em aberto';
        $statusClosed = 'Fechado';
        $statusInProgress = 'Em progresso';

        if($lang == 'en') {
            $mainTypeDesc = 'Product';
            $productTypeName = 'Mobile Product';
            $lastVersionDesc = 'Last version';
            $statusWaitingClient = 'Waiting for customer action';
            $statusOpened = 'Opened';
            $statusClosed = 'Closed';
            $statusInProgress = 'In progress';
        } else if($lang == 'es') {
            $mainTypeDesc = 'Producto';
            $productTypeName = 'Producto Mobile';
            $lastVersionDesc = 'Última versión';
            $statusWaitingClient = 'Esperando la acción del cliente';
            $statusOpened = 'Pendiente';
            $statusClosed = 'Cerrado';
            $statusInProgress = 'En progreso';
        }

        $pmOpened   = implode(',', $situationFilters['PM']['OPENED']);
        $pmWaiting  = implode(',', $situationFilters['PM']['WAITING']);
        $pmClosed   = implode(',', $situationFilters['PM']['CLOSED']);

        $query = <<<SQL
                    SELECT * FROM(SELECT TO_CHAR(ID) AS ID,
                    TO_CHAR(NRORG) AS NRORG,
                    TO_CHAR(ISSUE_ID) AS CALL_RELATIONSHIP,
                    TO_CHAR(CDCLIENTE) AS CDCLIENTE,
                    TO_CHAR(CDFILIAL) AS CDFILIAL,
                    TO_CHAR(REFERENCE) AS REFERENCE,
                    TO_CHAR(CLASSIFICATION) AS CLASSIFICATION,
                    TO_CHAR(CLASSIFICATION_NAME) AS CLASSIFICATION_NAME,
                    TO_CHAR(REPORTED_BY) AS REPORTED_BY,
                    TO_CHAR(IS_ACTIVE) AS IS_ACTIVE,
                    TO_CHAR(REPORTER_NAME) AS REPORTER_NAME,
                    TO_CHAR(PRODUCT) AS PRODUCT,
                    TO_CHAR(TYPE) AS TYPE,
                    LABEL_DESCRIPTION, NRCALLLABEL,
                    CASE TYPE
                     WHEN 'I'
                         THEN 'I - ' || CALL_RELATIONSHIP
                     WHEN 'S'
                         THEN 'S - ' || CALL_RELATIONSHIP
                     ELSE
                         CALL_RELATIONSHIP
                     END AS TEKNISA_ID,
                    TO_CHAR(CAUSE) AS CAUSE,
                    TO_CHAR(CAUSE_NAME) AS CAUSE_NAME,
                    TO_CHAR(PRODUCT_NAME) AS PRODUCT_NAME,
                    TO_CHAR(CREATED_ORDER) AS CREATED_ORDER,
                    TO_CHAR(NVL(UPDATED_AT, UPDATED), 'DD/MM/YYYY') AS UPDATED,
                    CREATED_AT,
                    TO_CHAR(CLOSED) AS CLOSED,
                    TO_CHAR(STATUS) AS STATUS,
                    TO_CHAR(NVL(UPDATED_AT, UPDATED), 'YYYYMMDD') AS UPDATED_ORDER,
                    UPDATED_AT,
                    TO_CHAR(END_DATE) AS PLANNED_DATE,
                    'P' AS MAIN_TYPE_CALL,
                    '$mainTypeDesc' AS MAIN_TYPE_CALL_DESCRIPTION,
                    TO_CHAR(PRODUCT_RESPONSABLE_CODE) AS PRODUCT_RESPONSABLE_CODE,
                    TO_CHAR(TEKNISA_INTERLOCUTOR_CODE) AS TEKNISA_INTERLOCUTOR_CODE,
                    TO_CHAR(PLANNED_VERSION) AS PLANNED_VERSION,
                    TO_CHAR(PLANNED_VALUE) AS PLANNED_VALUE,
                    TO_CHAR(RESPONSABLE_DIVISION_CODE) AS RESPONSABLE_DIVISION_CODE,
                    TO_CHAR(CUSTOMER_RESPONSABLE_CODE) AS CUSTOMER_RESPONSABLE_CODE,
                    TO_CHAR(CUSTOMER_INTERLOCUTOR_CODE) AS CUSTOMER_INTERLOCUTOR_CODE,
                    TO_CHAR(CUSTOMER_INTERLOCUTOR) AS CUSTOMER_INTERLOCUTOR,
                    TO_CHAR(CALL_PRIORITY) AS CALL_PRIORITY,
                    TO_CHAR(RESPONSIBLE_OF_THE_PRODUCT) AS RESPONSIBLE_OF_THE_PRODUCT,
                    TO_CHAR(RESPONSIBLE_OF_THE_CUSTOMER) AS RESPONSIBLE_OF_THE_CUSTOMER,
                    TO_CHAR(TEKNISA_INTERLOCUTOR) AS TEKNISA_INTERLOCUTOR,
                    TO_CHAR(RESPONSABLE_DIVISION) AS RESPONSABLE_DIVISION,
                    TO_CHAR(NMRAZSOCCLIE) AS NMRAZSOCCLIE,
                    TO_CHAR(NMFANTCLIE) AS NMFANTCLIE,
                    TO_CHAR(VERSION_DEV) AS VERSION_DEV,
                    TO_CHAR(CDOPERRESP) AS CDOPERRESP,
                    TO_CHAR((SELECT RTRIM(XMLAGG(XMLELEMENT(e,RT.NAME ,',').EXTRACT('//text()')).GetClobVal(),',')
                              FROM RESOURCE_PROJECT RP
                              JOIN RESOURCE_T RT ON RT.ID = RP.RESOURCE_C
                             WHERE RP.PROJECT = PRODUCT_ID
                             AND RP.TYPE = 'M')) AS NMOPERRESP,TEXT_SMALL_1, TEXT_SMALL_2, TEXT_SMALL_3, TEXT_SMALL_4, TEXT_SMALL_5,
                             TEXT_LONG_1,TEXT_LONG_2,TEXT_LONG_3,TEXT_LONG_4,TEXT_LONG_5,
                             NUMBER_1,NUMBER_2,NUMBER_3,NUMBER_4,NUMBER_5,DATE_1,DATE_2,DATE_3,DATE_4,DATE_5,
                         '$productTypeName' AS PRODUCT_TYPE_NAME, null as CDARVPROD,DTHOMOLOGACAO, VRORCAMENTO
                  FROM (
                  SELECT TAS.ID AS ISSUE_ID, C.NRCALL AS ID, TAS.ORGANIZATION AS NRORG, SRE.EXTERNAL_CODE AS CDCLIENTE, NULL AS CDFILIAL, TAS.NAME AS REFERENCE,
                         TAS.CLASSIFICATION, OPE.CDOPERADOR AS REPORTED_BY,
                         TAS.STATUS AS IS_ACTIVE, OPE.NMOPERADOR AS REPORTER_NAME,
                         NVL(C.PRODUCT, TAS.PROJECT) AS PRODUCT, TO_CHAR(TAS.ID) AS CALL_RELATIONSHIP, 'I' AS TYPE,
                         C.CAUSE, TAS.UPDATED_AT AS UPDATED, TAS.END_DATE,
                         TO_CHAR(TAS.CREATED_AT, 'YYYYMMDD') AS CREATED_ORDER,
                         TAS.CREATED_AT, PRO.NAME AS PRODUCT_NAME,
                         CLA.LABEL AS CLASSIFICATION_NAME, '' AS CAUSE_NAME,
                         C.PRODUCT_RESPONSABLE_CODE,
                         C.TEKNISA_INTERLOCUTOR_CODE,
                         C.PLANNED_VERSION,
                         C.PLANNED_VALUE,
                         C.RESPONSABLE_DIVISION_CODE,
                         C.CUSTOMER_INTERLOCUTOR_CODE,
                         C.CUSTOMER_RESPONSABLE_CODE,
                         INTE.NMINTECLIE AS CUSTOMER_INTERLOCUTOR,
                         PRI.DSPRIORIDADE AS CALL_PRIORITY,
                         RESPROD.NMOPERADOR AS RESPONSIBLE_OF_THE_PRODUCT,
                         RESPCLIE.NMOPERADOR AS RESPONSIBLE_OF_THE_CUSTOMER,
                         TEKINTE.NMOPERADOR AS TEKNISA_INTERLOCUTOR,
                         CLASOPORT.NMCLASSOPORT AS RESPONSABLE_DIVISION,
                         CLI.NMRAZSOCCLIE,
                         CLI.NMFANTCLIE,
                         LABEL.DESCRIPTION AS LABEL_DESCRIPTION,
                         LABEL.NRCALLLABEL,
                         DECODE(PVD.ID, NULL, '$lastVersionDesc', PVD.VERSION || '.' || PVD.REVISION) AS VERSION_DEV,
                         PVD.VERSION AS VERSION_TESTE,
                         (SELECT MAX(COM.UPDATED_AT) FROM COMMENTS COM WHERE (TAS.ID = COM.TASK) ) AS UPDATED_AT,
                         CASE WHEN EXISTS( SELECT ID FROM TASK_PROPERTIES TPR WHERE TPR.FINAL_TASK_STATUS = TS.ID)
                              THEN 'Y'
                              ELSE null
                         END AS CLOSED,
                         CASE WHEN TS.ID IN($pmWaiting) OR (SELECT NVL(CONTROL,'I') FROM (SELECT CTY.CONTROL
                                                    FROM COMMENTS COM
                                                    left JOIN COMMENT_TYPE CTY ON(COM.COMMENT_TYPE_ID = CTY.ID )
                                                    WHERE COM.TASK = TAS.ID
                                                    ORDER BY COM.ID DESC)
                                                    WHERE ROWNUM = 1 ) = 'Q'
                            THEN '$statusWaitingClient'
                         WHEN TS.ID IN($pmOpened)
                              THEN '$statusOpened'
                         WHEN TS.ID IN($pmClosed)
                             THEN '$statusClosed'
                             ELSE '$statusInProgress'
                         END AS STATUS,
                         RT.EXTERNAL_CODE AS CDOPERRESP,
                         OPE.NMOPERADOR AS NMOPERRESP,
                         PRC.ID AS PRODUCT_ID, C.TEXT_SMALL_1, C.TEXT_SMALL_2, C.TEXT_SMALL_3, C.TEXT_SMALL_4, C.TEXT_SMALL_5,
                          C.TEXT_LONG_1,C.TEXT_LONG_2,C.TEXT_LONG_3,C.TEXT_LONG_4,C.TEXT_LONG_5,C.NUMBER_1,C.NUMBER_2,C.NUMBER_3,C.NUMBER_4,C.NUMBER_5,
                           C.DATE_1,C.DATE_2,C.DATE_3,C.DATE_4,C.DATE_5, '$productTypeName' as PRODUCT_TYPE_NAME, null as CDARVPROD,C.DTHOMOLOGACAO,
                        COALESCE(
                            (SELECT SUM(VRTOTITEMCOMDESC)
                            FROM FCT_NEGOCIACAOPROPOSTA NEG
                            WHERE NEG.NRSEQORCAMENTO = ORCA.NRSEQORCAMENTO),
                            0
                        ) AS VRORCAMENTO
                    FROM TASK TAS
                    JOIN ALLOCATION SAR ON (SAR.TASK = TAS.ID AND SAR.TYPE = 'R')
                    JOIN RESOURCE_T RES ON RES.ID = SAR.RESOURCE_T
                    JOIN TASK_STATUS TS ON TS.ID = TAS.TASK_STATUS
               LEFT JOIN CP_CALL C      ON TAS.ID = C.CALL_RELATIONSHIP AND C.TYPE = 'I'
               LEFT JOIN OPERADOR OPE   ON OPE.CDOPERADOR = RES.EXTERNAL_CODE
               LEFT JOIN PROJECT PRO    ON (PRO.ID = NVL(C.PRODUCT, TAS.PROJECT))
               LEFT JOIN CLASSIFICATION CLA ON(CLA.ID = TAS.CLASSIFICATION)
               LEFT JOIN ALLOCATION SA ON (SA.TASK = TAS.ID AND SA.TYPE = 'S')
               LEFT JOIN RESOURCE_T SRE ON (SRE.ID = SA.RESOURCE_T)
               LEFT JOIN PROJECT PRC ON(PRC.ID = TAS.PROJECT)
               LEFT JOIN RESOURCE_PROJECT RP ON RP.PROJECT = PRC.ID
               LEFT JOIN RESOURCE_T RT ON RT.ID = RP.RESOURCE_C
               LEFT JOIN INTECLIE INTE ON INTE.CDINTECLIE = C.CUSTOMER_INTERLOCUTOR_CODE AND INTE.CDCLIENTE = SRE.EXTERNAL_CODE
               LEFT JOIN CRM_PRIORIDADE PRI ON PRI.NRPRIORIDADE = C.PRIORITY_CODE
               LEFT JOIN OPERADOR RESPROD ON RESPROD.CDOPERADOR = C.PRODUCT_RESPONSABLE_CODE
               LEFT JOIN PARCLIEFAS PARCLIE ON PARCLIE.CDCLIENTE = SRE.EXTERNAL_CODE AND IDTPFATUCLIE = '5'
               LEFT JOIN OPERADOR RESPCLIE ON RESPCLIE.CDOPERADOR = PARCLIE.CDGERENTEIMPCLI
               LEFT JOIN OPERADOR TEKINTE ON TEKINTE.CDOPERADOR = C.TEKNISA_INTERLOCUTOR_CODE
               LEFT JOIN CRM_CLASSOPORTUNI CLASOPORT ON CLASOPORT.NRSEQCLASSOPORT = C.RESPONSABLE_DIVISION_CODE
               LEFT JOIN CLIENTE CLI ON CLI.CDCLIENTE = SRE.EXTERNAL_CODE
               LEFT JOIN CP_CALL_LABEL_RELATION LABEL_REL ON LABEL_REL.CALL = C.NRCALL
               LEFT JOIN CP_CALL_LABEL LABEL ON LABEL_REL.LABEL = LABEL.NRCALLLABEL
               LEFT JOIN PRODUCT_VERSION PVD ON PVD.ID = TAS.PRODUCT_VERSION_ID_DEV
               LEFT JOIN SLACLIENTE SLC ON (CLI.CDCLIENTE = SLC.CDCLIENTE AND SLC.CDASSUNTO = CLA.CDASSUNTO)
               LEFT JOIN USR_CP_CALL_SLA CAL2 ON (TAS.ID = CAL2.CALL_RELATIONSHIP AND CAL2.TYPE = 'I')
               LEFT JOIN FCT_ORCAMENTO ORCA ON (TAS.ID = ORCA.ISSUEID AND ORCA.IDSITUACAOORCAMENTO NOT IN ('CANCELADO'))
                   WHERE TAS.IS_ISSUE = 'Y'
                     AND (C.STATUSGEST IS NULL OR C.STATUSGEST NOT IN ('D', 'R'))
                     AND TAS.STATUS NOT IN ('D')
                     AND ($clienteWhere)
                         $specialFilters
                         $situation
                         $filterSLA
                         $filterSLAClas
                         $mobFilter
                         $filterHomo
                         $filterSprint
                         ))
               WHERE 1=1
                     $whereFilters
SQL;
        return $query;
    }

    public function findMyIssueTypeProductCalls($cdCliente, $whereFilters='', $specialFilters='', $situation='', $userId, $situationFilters, $startPos = 1, $finalPos = 9999)
    {
        $pmOpened   = implode(',', $situationFilters['PM']['OPENED']);
        $pmWaiting  = implode(',', $situationFilters['PM']['WAITING']);
        $pmClosed   = implode(',', $situationFilters['PM']['CLOSED']);

        $queryPmCalls = $this->getQueryPmCalls($situationFilters, $specialFilters, $situation, $whereFilters);

        $query = <<<SQL
         SELECT *
         FROM (
            SELECT ID, CALL_RELATIONSHIP, NRORG, REFERENCE, CLASSIFICATION, REPORTED_BY,
                   IS_ACTIVE, REPORTER_NAME, PRODUCT, TYPE, CAUSE, PRODUCT_NAME, CREATED_ORDER,
                   UPDATED, CREATED_AT, CLASSIFICATION_NAME, CLOSED, STATUS,
                   UPDATED_ORDER, MAIN_TYPE_CALL_DESCRIPTION, UPDATED_AT,
                   RowNum rn, MAIN_TYPE_CALL
            FROM (
                $queryPmCalls
            )
        WHERE 1=1
              AND RowNum <= :finalPos)
        WHERE rn >= :startPos
        ORDER BY CREATED_AT DESC
SQL;

        $params = array(
            "CDCLIENTE" => $cdCliente,
            "startPos" => $startPos,
            "finalPos" => $finalPos,
            "USER_ID" => $userId
        );

        $result = $this->getEntityManager()->getConnection()->fetchAll($query, $params);

        return $result;
    }

    public function findMyRichClientTypeProductCalls($cdCliente, $whereFilters = '1=1', $specialFilters='', $situation = '', $userId, $situationFilters, $startPos = 1, $finalPos = 9999)
    {
        $gepOpened  = $situationFilters['GEP']['OPENED'];
        $gepWaiting = $situationFilters['GEP']['WAITING'];
        $gepClosed  = $situationFilters['GEP']['CLOSED'];

        $queryIntranetCalls = $this->getQueryIntranetCalls($situationFilters, $specialFilters, $situation, $whereFilters);

        $query = <<<SQL
        SELECT  *
        FROM (
            SELECT  ID, NRORG, REFERENCE, CLASSIFICATION, REPORTED_BY, MAIN_TYPE_CALL_DESCRIPTION,
                    IS_ACTIVE, REPORTER_NAME, PRODUCT, TYPE, CALL_RELATIONSHIP,
                    CAUSE, UPDATED, CREATED_ORDER, CREATED_AT, PRODUCT_NAME, CLASSIFICATION_NAME,
                    CLOSED, STATUS, UPDATED_ORDER, UPDATED_AT, MAIN_TYPE_CALL, RowNum rn
             FROM  (
                $queryIntranetCalls
             )
             WHERE 1=1
                   AND RowNum <= :finalPos
        )
         WHERE rn >= :startPos
SQL;

        $params = array(
            "CDCLIENTE" => $cdCliente,
            "startPos" => $startPos,
            "finalPos" => $finalPos,
            "USER_ID" => $userId
        );

        return $this->getEntityManager()->getConnection()->fetchAll($query, $params);
    }

    public function findCall($id){
        $query = <<<SQL
                  SELECT  C.NRCALL AS ID, C.NRORG, C.REFERENCE, C.CLASSIFICATION, C.REPORTED_BY, C.DESCRIPTION,C.REPORTED_BY AS REPORTER_BY,
                          TO_CHAR(C.DTULTATU, 'DD/MM/YYYY') AS UPDATED_AT, C.PRODUCT, C.TYPE, OPE.NMOPERADOR AS REPORTER_NAME,
                          C.CALL_RELATIONSHIP, C.CAUSE, C.CDOPERULTATU, C.IDATIVO,C.IDATIVO AS STATUS,
                          (
                             SELECT LISTAGG(CLR.LABEL, ',') WITHIN GROUP (ORDER BY CLR.NRCALLLABELRELATION)
                             FROM   CP_CALL_LABEL_RELATION CLR
                             WHERE  CLR.CALL = C.NRCALL
                             AND    CLR.NRORG = C.NRORG
                          ) AS CALL_LABELS
                FROM CP_CALL C
                JOIN OPERADOR OPE ON (OPE.CDOPERADOR = C.REPORTED_BY )
               WHERE C.NRCALL = :CALL_ID
SQL;

        $params = array(
            "CALL_ID" => $id
        );

        $result =  $this->getEntityManager()->getConnection()->fetchAll($query, $params);
        return count($result)>0 ? $result[0] : array();
    }

    public function findResultevol(){
        $query = <<<SQL
                   SELECT *
                     FROM CRM_RESULTEVOL
                    WHERE IDRESULTCASO = 'SIM'
                      AND IDATIVO = 'S'
SQL;


        return $this->getEntityManager()->getConnection()->fetchAll($query);
    }

    public function findContatoById($contatoId)
    {

        $query = <<<SQL
            SELECT  ID, NRORG, REFERENCE, CLASSIFICATION, REPORTED_BY, DESCRIPTION,
                    PRODUCT, CAUSE, IS_ACTIVE, CALL_RELATIONSHIP, TYPE, PRODUCT_NAME,
                    CAUSE_NAME, CREATED_AT, REPORTER_NAME, CLOSED, CREATED_ORDER,
                    TO_CHAR(UPDATED, 'YYYYMMDD') AS UPDATED_ORDER,
                    TO_CHAR(UPDATED, 'DD/MM/YYYY') AS UPDATED,
                    TO_CHAR(UPDATED, 'DD/MM/YYYY') AS UPDATED_AT, STATUS
              FROM (
                SELECT  C.NRCALL AS ID, NVL(C.NRORG, CONT.NRORG) AS NRORG,
                        NVL(C.REFERENCE, CONT.DSREFECONT) AS REFERENCE, C.CLASSIFICATION,
                        NVL(C.REPORTED_BY, CONT.CDOPERCONT) AS REPORTED_BY, NVL(C.DESCRIPTION, CONT.DSABERTURACASO) AS DESCRIPTION,
                        NVL(C.PRODUCT, CONT.CDSISTEMA) AS PRODUCT,
                        NVL(C.CAUSE, CONT.CDMOTICONT) AS CAUSE, C.IDATIVO AS IS_ACTIVE,
                        CONT.NRSEQCONTATO AS CALL_RELATIONSHIP, NVL(C.TYPE, 'S') AS TYPE,
                        S.NMSISTEMA AS PRODUCT_NAME, MOTI.NMMOTICONT AS CAUSE_NAME,
                        TO_CHAR(NVL(C.DTINCLUSAO, CONT.DTHRCONTATO), 'DD/MM/YYYY') AS CREATED_AT,
                        TO_CHAR(NVL(C.DTINCLUSAO, CONT.DTHRCONTATO), 'YYYYMMDD') AS CREATED_ORDER,
                        OPE.NMOPERADOR AS REPORTER_NAME,
                        CASE WHEN CONT.NRSEQSITUACAO = 13
                            THEN 'Aguardando ação do cliente'
                            WHEN CONT.NRSEQSITUACAO = 1
                            THEN 'Em aberto'
                            WHEN CONT.NRSEQSITUACAO = 3
                            THEN 'Fechado'
                            ELSE 'Em progresso'
                        END AS STATUS,
                        (SELECT MAX(EVCONT.DTHREVOLCONT) FROM EVOLCONT EVCONT WHERE EVCONT.NRCONTATO = CONT.NRCONTATO ) AS UPDATED,
                        CASE WHEN CONT.NRSEQSITUACAO = 3
                            THEN 'Y'
                            ELSE null
                        END AS CLOSED
                 FROM   CONTATO CONT
                 JOIN   SISTEMA S       ON S.CDSISTEMA = CONT.CDSISTEMA
                 JOIN   CLIENTE CLI     ON CLI.NRPARCNEGOCIO  = CONT.NRPARCNEGOCIO
                 JOIN   OPERADOR OPE    ON OPE.CDOPERADOR = CONT.CDOPERINCLUSAO
            LEFT JOIN   CP_CALL C       ON CONT.NRSEQCONTATO = C.CALL_RELATIONSHIP
            LEFT JOIN   MOTICONT MOTI   ON MOTI.CDMOTICONT = C.CAUSE
                WHERE   CONT.NRSEQCONTATO  = :CONTATO_ID)
SQL;

        $params = array(
            "CONTATO_ID" => $contatoId
        );

        $contato = $this->getEntityManager()->getConnection()->fetchAll($query, $params);

        return empty($contato) ? array() : $contato[0];
    }

    public function findSoliservById($soliservId, $situationFilters, $userId)
    {
        $gepOpened  = $situationFilters['GEP']['OPENED'];
        $gepWaiting = $situationFilters['GEP']['WAITING'];
        $gepClosed  = $situationFilters['GEP']['CLOSED'];
        $validate = \Util\Utilities::getValidateBudgetFaseGep();
        $refuse = \Util\Utilities::getRefuseBudgetFaseGep();
        $query = <<<SQL
        SELECT  SER.NRSOLISERV AS ID, SER.NRORG, SER.DSREFESOLI AS REFERENCE,
                SER.CDOPERINCLUSAO AS CREATED_BY, SER.NRLICENCAUSO AS USE_LICENSE,
                DES.DSSOLISERV AS DESCRIPTION, SER.CDOPERINCLUSAO AS REPORTER_BY,CLI.CDCLIENTE ,
                TO_CHAR((SELECT MAX(LFT.DTINCLUSAO) FROM LOGFASETRAM LFT WHERE (LFT.NRSOLISERV = :SOLISERV_ID AND LFT.CDFILIAL = SER.CDFILIAL) ), 'DD/MM/YYYY') AS UPDATED_AT,
                SER.CDPRODCOMP AS PRODUCT, 'S' AS TYPE, OPE.NMOPERADOR AS REPORTER_NAME,
                '' AS CAUSE, SER.CDOPERULTATU AS UPDATED, PRO.CDPRODUTO AS BOARD,
                SER.CDPRODGRUP AS PRODUCT_TYPE, PRT.NMPRODUTO AS PRODUCT_TYPE_NAME, CLI.NMRAZSOCCLIE,
                ASS.NMASSUNTO AS CLASSIFICATION_NAME, ASS.IDORIGOBRSOL AS CLASSIFICATION_IDORIGOBRSOL,
                PRO.NMPRODUTO AS PRODUCT_NAME, ASS.CDASSUNTO AS CLASSIFICATION,
                 CASE WHEN SER.CDFASETRAM IN ('$validate')
                       THEN 'Y'
                       ELSE 'N'
                     END AS ENABLE_APPROVAL,
                 CASE WHEN EXISTS (   SELECT NRSEQORCAMENTO AS EXTERNAL_ID
                                        FROM FCT_ORCAMENTO
                                       WHERE NRSOLISERV = SER.NRSOLISERV
                                         AND IDATIVO = 'S'
                                         AND IDSITUACAOORCAMENTO <> 'CANCELADO')
                       THEN 'Y'
                       ELSE 'N'
                 END AS IS_INTEGRATION_SM,
                CASE WHEN $gepWaiting AND SER.CDFASETRAM NOT IN (SELECT CDFATRAMENCE FROM PARAMGERAL PARA WHERE PARA.NRORG = SER.NRORG)
                     THEN 'Y'
                     ELSE 'N'
                 END AS ENABLE_CLOSED,
                CASE WHEN $gepClosed
                     THEN 'Fechado'
                     WHEN $gepWaiting
                     THEN 'Aguardando ação do cliente'
                     WHEN $gepOpened
                     THEN 'Em aberto'
                     ELSE 'Em progresso'
                END AS STATUS,
                CASE WHEN $gepWaiting
                     THEN 'Y'
                     ELSE 'N'
                 END AS WAITING,
                (SELECT S.NRSOLISERV
                   FROM SOLISERV S
                   JOIN ORCASOLICITA O ON (O.CDFILIAL = S.CDFILIAL AND O.NRSOLISERV = S.NRSOLISERV)
                  WHERE S.NRSOLISERV = :SOLISERV_ID
                    AND ROWNUM = 1
                    AND  (SELECT CDFASETRAM
                                   FROM ( SELECT CDFASETRAM
                                            FROM LOGFASETRAM LFT
                                           WHERE LFT.NRSOLISERV = :SOLISERV_ID
                                             AND CDFASETRAM IN ('$refuse','$validate')
                                        ORDER BY DTALFASETRAM DESC)
                                  WHERE ROWNUM = 1) IN ('$validate')) AS WITH_BUDGET,
                SER.CDVERPROORIG AS PRODUCT_VERSION, SER.CDVERPROORIG AS PRODUCT_VERSION_LABEL,
                SER.CDRELVERORIG AS PRODUCT_RELEASE, SER.CDRELVERORIG AS PRODUCT_RELEASE_LABEL,
                SER.CDPATRELORIG AS PRODUCT_PATCH, SER.CDPATRELORIG AS PRODUCT_PATCH_LABEL
         FROM  SOLISERV SER
         JOIN  DESCSOLI DES ON DES.NRSOLISERV = SER.NRSOLISERV
         JOIN  OPERADOR OPE ON OPE.CDOPERADOR = SER.CDOPERADOR
         JOIN  PRODUTO PRO  ON PRO.CDPRODUTO = SER.CDPRODCOMP
    LEFT JOIN  PRODUTO PRT  ON PRT.CDPRODUTO = SER.CDPRODGRUP
         JOIN  ASSUNTO ASS  ON ASS.CDASSUNTO = SER.CDASSUNTO
    LEFT JOIN CLIENTE CLI ON CLI.CDCLIENTE = SER.CDCLIENTE
        WHERE  SER.NRSOLISERV = :SOLISERV_ID
SQL;

        $params = array(
            "SOLISERV_ID" => $soliservId,
            "USER_ID" => $userId
        );
        $result = $this->getEntityManager()->getConnection()->fetchAll($query, $params);

        return count($result) > 0 ? $result[0] : array();
    }

    public function findIssueById($issueId, $situationFilters = null)
    {
        $gepWaiting = '0';
        if($situationFilters){
            $gepWaiting = implode(',', $situationFilters['PM']['WAITING']);
        }
        $query = <<<SQL
              SELECT  TAS.ID, TAS.ORGANIZATION AS NRORG, TAS.NAME AS REFERENCE,CLI.CDCLIENTE ,
                      TAS.CREATED_BY, TAS.DESCRIPTION, TAS.CREATED_BY AS REPORTER_BY,
                      TO_CHAR(TAS.UPDATED_AT, 'DD/MM/YYYY') AS UPDATED_AT,
                      TAS.PROJECT, TAS.PROJECT AS PRODUCT, RT.NAME AS REPORTER_NAME,
                      TAS.ID AS CALL_RELATIONSHIP, '' AS CAUSE, TAS.UPDATED_BY AS CDOPERULTATU, CLI.NMRAZSOCCLIE,
                      TAS.STATUS,TAS.STATUS AS STATUS,PRO.ID AS BOARD,
                      PRO.NAME AS PRODUCT_NAME, CLA.ID AS CLASSIFICATION, CLA.LABEL AS CLASSIFICATION_NAME,
                      DECODE(PVD.ID, NULL, 'Última versão', PVD.VERSION || '.' || PVD.REVISION) AS VERSION_DEV,
                      CASE WHEN TS.CONTROL = 'H'
                          THEN 'Y'
                          ELSE 'N'
                      END AS ENABLE_CLOSED,
                        CASE WHEN TS.ID IN ($gepWaiting)
                             THEN 'Y'
                             ELSE 'N'
                         END AS WAITING,
                      CASE WHEN TS.CONTROL = 'A'
                             THEN 'Y'
                             ELSE 'N'
                      END AS ENABLE_APPROVAL,
                      CASE WHEN EXISTS (SELECT EXTERNAL_ID FROM BUDGET WHERE TASK = :ISSUE_ID AND EXTERNAL_ID IS NOT NULL)
                           THEN 'Y'
                           ELSE 'N'
                      END AS IS_INTEGRATION_SM,
                      (SELECT CONTROL
                         FROM (SELECT CTY.CONTROL
                                 FROM COMMENTS COM
                                 JOIN COMMENT_TYPE CTY ON(COM.COMMENT_TYPE_ID = CTY.ID )
                                WHERE COM.TASK = TAS.ID
                             ORDER BY COM.ID DESC)
                        WHERE ROWNUM = 1 ) AS LAST_COMMENT_TYPE,
                      CASE WHEN EXISTS( SELECT ID FROM TASK_PROPERTIES TPR WHERE TPR.FINAL_TASK_STATUS = TS.ID)
                              THEN 'Y'
                              ELSE null
                      END AS CLOSED
                FROM TASK TAS
                JOIN TASK_STATUS TS ON (TS.ID = TAS.TASK_STATUS)
                JOIN PROJECT PRO ON (PRO.ID = TAS.PROJECT)
                JOIN CLASSIFICATION CLA ON (CLA.ID = TAS.CLASSIFICATION)
                JOIN RESOURCE_T RT ON RT.ID = TAS.CREATED_BY
           LEFT JOIN PRODUCT_VERSION PVD ON PVD.ID = TAS.PRODUCT_VERSION_ID_DEV
           LEFT JOIN ALLOCATION SA ON (SA.TASK = TAS.ID AND SA.TYPE = 'S')
           LEFT JOIN RESOURCE_T SRE ON (SRE.ID = SA.RESOURCE_T)
           LEFT JOIN CLIENTE CLI ON CLI.CDCLIENTE = SRE.EXTERNAL_CODE
               WHERE TAS.ID = :ISSUE_ID
SQL;

        $params = array(
            "ISSUE_ID" => $issueId
        );

        $result =  $this->getEntityManager()->getConnection()->fetchAll($query, $params);
        return count($result)>0 ? $result[0] : array();
    }

    public function findCallTypeIssue($id, $situationFilters){


        $pmWaiting = implode(',', $situationFilters['PM']['WAITING']);
        $query = <<<SQL
              SELECT  C.NRCALL AS ID, C.NRORG, C.REFERENCE, C.REPORTED_BY, C.DESCRIPTION,C.REPORTED_BY AS REPORTER_BY,
                          TO_CHAR(C.DTULTATU, 'DD/MM/YYYY') AS UPDATED_AT, C.PRODUCT, C.TYPE,OPE.NMOPERADOR AS REPORTER_NAME,
                          C.CALL_RELATIONSHIP, C.CAUSE, C.CDOPERULTATU, C.IDATIVO,C.IDATIVO AS STATUS,NVL(C.PRODUCT, PRO.ID) AS BOARD, CLI.NMRAZSOCCLIE,
                          PRO.NAME AS PRODUCT_NAME,CLI.CDCLIENTE,
                          CLA.ID AS CLASSIFICATION,CLA.LABEL AS CLASSIFICATION_NAME,
                            CASE WHEN TS.CONTROL = 'H'
                                 THEN 'Y'
                                 ELSE 'N'
                             END AS ENABLE_CLOSED,
                            CASE WHEN TS.CONTROL = 'A'
                                 THEN 'Y'
                                 ELSE 'N'
                             END AS ENABLE_APPROVAL,
                            CASE WHEN EXISTS (SELECT EXTERNAL_ID FROM BUDGET WHERE TASK = TAS.ID AND EXTERNAL_ID IS NOT NULL)
                                 THEN 'Y'
                                 ELSE 'N'
                            END AS IS_INTEGRATION_SM,
                            CASE WHEN TS.ID IN ($pmWaiting) OR (  SELECT CONTROL FROM (SELECT CTY.CONTROL
                                                                    FROM COMMENTS COM
                                                                    JOIN COMMENT_TYPE CTY ON(COM.COMMENT_TYPE_ID = CTY.ID )
                                                                    WHERE COM.TASK = TAS.ID
                                                                    ORDER BY COM.ID DESC)
                                                                    WHERE ROWNUM = 1 ) = 'Q'
                                 THEN 'Y'
                                 ELSE null
                             END AS WAITING,
                          (
                             SELECT rtrim(xmlagg(xmlelement(e,CLR.LABEL ,',').extract('//text()') order by CLR.LABEL ).GetClobVal(),',')
                             FROM   CP_CALL_LABEL_RELATION CLR
                             WHERE  CLR.CALL = C.NRCALL
                             AND    CLR.NRORG = C.NRORG
                          ) AS CALL_LABELS,
                         (SELECT CONTROL FROM (SELECT CTY.CONTROL
                                                FROM COMMENTS COM
                                                JOIN COMMENT_TYPE CTY ON(COM.COMMENT_TYPE_ID = CTY.ID )
                                                WHERE COM.TASK = TAS.ID
                                                ORDER BY COM.ID DESC)
                                                WHERE ROWNUM = 1 ) AS LAST_COMMENT_TYPE,
                         PRV.ID AS MENU_VERSION_ID,
                         DECODE(PRV.ID,NULL,NULL,(PRV.VERSION || '.' || PRV.REVISION  || '.' || PRV.BUILD)) AS MENU_VERSION,
                         DECODE(PVD.ID, NULL, 'Última versão', PVD.VERSION || '.' || PVD.REVISION) AS VERSION_DEV,
                         OPR.LABEL AS MENU_ITEM ,OPR.ID AS MENU_ITEM_ID,
                         OPR.NREXTERNAL_PRODUCT_ID AS DEVOPS_ID,
                         NVL(PRD.ID,PDP.ID) AS DEVOPS_ID_PRODUCT,C.TEXT_SMALL_1, C.TEXT_SMALL_2, C.TEXT_SMALL_3, C.TEXT_SMALL_4, C.TEXT_SMALL_5,
                         C.TEXT_LONG_1,C.TEXT_LONG_2,C.TEXT_LONG_3,C.TEXT_LONG_4,C.TEXT_LONG_5,C.NUMBER_1,C.NUMBER_2,C.NUMBER_3,C.NUMBER_4,C.NUMBER_5,
                         TO_CHAR(DATE_1, 'DD/MM/YYYY') AS DATE_1,TO_CHAR(DATE_2, 'DD/MM/YYYY') AS DATE_2,TO_CHAR(DATE_3, 'DD/MM/YYYY') AS DATE_3,TO_CHAR(DATE_4, 'DD/MM/YYYY') AS DATE_4,TO_CHAR(DATE_5, 'DD/MM/YYYY') AS DATE_5
                FROM CP_CALL C
                JOIN OPERADOR OPE ON (OPE.CDOPERADOR = C.REPORTED_BY )
                JOIN TASK TAS ON(TAS.ID = C.CALL_RELATIONSHIP)
                JOIN TASK_STATUS TS ON (TS.ID = TAS.TASK_STATUS)
                JOIN PROJECT PRO ON(PRO.ID = NVL(C.PRODUCT, TAS.PROJECT))
           LEFT JOIN PROJECT PRC ON(PRC.ID = C.PRODUCT)
           LEFT JOIN PRODUCT PRD ON(PRD.PROJECT_ID = PRC.ID)
           LEFT JOIN PRODUCT PDP ON(PDP.PROJECT_ID = PRO.ID)
           LEFT JOIN PRODUCT_VERSION PRV ON (TAS.PRODUCT_VERSION_ID = PRV.ID)
           LEFT JOIN OM_PRODUTO_ELEMENTO OPR On (TAS.MENU_ITEM_ID = OPR.ID)
           LEFT JOIN PRODUCT_VERSION PVD ON PVD.ID = TAS.PRODUCT_VERSION_ID_DEV
                JOIN CLASSIFICATION CLA ON (CLA.ID = TAS.CLASSIFICATION)
           LEFT JOIN ALLOCATION SA ON (SA.TASK = TAS.ID AND SA.TYPE = 'S')
           LEFT JOIN RESOURCE_T SRE ON (SRE.ID = SA.RESOURCE_T)
           LEFT JOIN CLIENTE CLI ON CLI.CDCLIENTE = SRE.EXTERNAL_CODE
               WHERE C.NRCALL = :CALL_ID
SQL;

        $params = array(
            "CALL_ID" => $id
        );

        $result =  $this->getEntityManager()->getConnection()->fetchAll($query, $params);
        return count($result)>0 ? $result[0] : array();
    }

    public function findCallTypeCaso($id,$situationFilters){

        $gepOpened  = implode(',', $situationFilters['CRM']['OPENED']);
        $gepWaiting = implode(',', $situationFilters['CRM']['WAITING']);
        $gepClosed  = implode(',', $situationFilters['CRM']['CLOSED']);

        $query = <<<SQL

                    SELECT (
                             SELECT rtrim(xmlagg(xmlelement(e,CLR.LABEL ,',').extract('//text()') order by CLR.LABEL ).GetClobVal(),',')
                             FROM   CP_CALL_LABEL_RELATION CLR
                             WHERE  CLR.CALL = C.NRCALL
                             AND    CLR.NRORG = C.NRORG
                          ) AS CALL_LABELS,
                         CONT.NRSEQCONTATO AS CALL_RELATIONSHIP, C.CAUSE,CONT.CDOPERULTATU,
                         CONT.DSABERTURACASO AS DESCRIPTION, CONT.NRORG, CONT.CDPRODUTO AS PRODUCT,PRO.NMPRODUTO AS PRODUCT_NAME,
                         DSREFECONT AS REFERENCE,OPR.CDOPERADOR AS REPORTED_BY,OPR.NMOPERADOR AS REPORTER_NAME, CONT.IDSTATUSCONT AS IS_ACTIVE,
                          'T' AS TYPE, CONT.DTULTATU AS UPDATED_AT, C.NRCALL AS ID,
                         CASE WHEN CONT.NRSEQSITUACAO NOT IN ($gepClosed)
                              THEN 'Y'
                              ELSE NULL
                         END AS ENABLE_CLOSED,
                          CASE WHEN CONT.NRSEQSITUACAO IN ($gepWaiting)
                                 THEN 'Y'
                                 ELSE 'N'
                          END AS ENABLE_APPROVAL,
                          MOTI.CDMOTICONT AS CLASSIFICATION, MOTI.NMMOTICONT AS CLASSIFICATION_NAME
                    FROM CONTATO CONT
                    JOIN CLIENTE CLI ON CLI.NRPARCNEGOCIO  = CONT.NRPARCNEGOCIO
                    JOIN OPERADOR OPR ON(OPR.NRPARCNEGOCIO = CONT.NRPARCINTERLOCUTOR)
                    JOIN MOTICONT MOTI ON (MOTI.CDMOTICONT = CONT.CDMOTICONT)
                    JOIN PRODUTO PRO ON(PRO.CDPRODUTO = CONT.CDPRODUTO AND (PROJECT_ID IS NOT NULL OR (CDPRODCOMP IS NOT NULL AND CDPRODGRUP IS NOT NULL)))
               LEFT JOIN CP_CALL C ON (CONT.NRSEQCONTATO = C.CALL_RELATIONSHIP AND C.TYPE = 'T')


                   WHERE CONT.IDTIPOCONTATO = 'CHAMADO'
                   AND CONT.NRSEQCONTATO = :CALL_RELATIONSHIP
SQL;

        $params = array(
            "CALL_RELATIONSHIP" => $id
        );

        $result =  $this->getEntityManager()->getConnection()->fetchAll($query, $params);
        return count($result)>0 ? $result[0] : array();
    }


    public function findNrseqcontratoIdWithIssueId($id){

        $query = <<<SQL

        SELECT NRSEQCONTRATO
            FROM FCT_REFEORCACONT
            WHERE NRSEQORCAMENTO = (SELECT BUD.EXTERNAL_ID
            FROM TASK ISS
       LEFT JOIN PRODUCT PRO ON (PRO.PROJECT_ID = ISS.PROJECT)
       LEFT JOIN OM_PRODUTO POM ON (POM.NREXTERNAL_PRODUCT_ID = PRO.ID)
       LEFT JOIN ALLOCATION AR ON AR.TYPE = 'R' AND AR.TASK = ISS.ID
       LEFT JOIN ALLOCATION AL ON AL.TYPE = 'S' AND AL.TASK = ISS.ID
       LEFT JOIN RESOURCE_T RR ON AR.RESOURCE_T =  RR.ID
       LEFT JOIN RESOURCE_T SP ON AL.RESOURCE_T = SP.ID
       LEFT JOIN BUDGET BUD ON ISS.ID = BUD.TASK
           WHERE ISS.ID = :ISSUE_ID)

SQL;

        $params = array(
            "ISSUE_ID" => $id
        );
        $contato = $this->getEntityManager()->getConnection()->fetchAll($query, $params);

        return empty($contato) ? null : $contato[0];
    }

    public function findCallTypeRichClient($id,$userId,$situationFilters)
    {

        $gepWaiting = $situationFilters['GEP']['WAITING'];
        $validate = \Util\Utilities::getValidateBudgetFaseGep();
        $refuse = \Util\Utilities::getRefuseBudgetFaseGep();

        $query = <<<SQL
          SELECT  C.NRCALL AS ID, C.NRORG, SER.DSREFESOLI AS REFERENCE,  ASS.CDASSUNTO AS CLASSIFICATION, SER.CDOPERINCLUSAO AS REPORTER_BY,
                  DES.DSSOLISERV AS DESCRIPTION,SER.CDOPERINCLUSAO AS REPORTER_BY,CLI.CDCLIENTE,
                  TO_CHAR(C.DTULTATU, 'DD/MM/YYYY') AS UPDATED_AT, SER.CDPRODCOMP AS PRODUCT, C.TYPE,OPE.NMOPERADOR AS REPORTER_NAME, CLI.NMRAZSOCCLIE,
                  C.CALL_RELATIONSHIP, C.CAUSE, C.CDOPERULTATU, C.IDATIVO,C.IDATIVO AS STATUS,
                  SER.CDPRODGRUP AS PRODUCT_TYPE, PRO.NMPRODUTO AS PRODUCT_NAME,PRT.NMPRODUTO as PRODUCT_TYPE_NAME,
                  NVL(CLA.LABEL,ASS.NMASSUNTO) AS CLASSIFICATION_NAME, ASS.IDORIGOBRSOL AS CLASSIFICATION_IDORIGOBRSOL,
                  SER.CDVERPROORIG AS PRODUCT_VERSION,SER.CDVERPROORIG AS PRODUCT_VERSION_LABEL,
                  SER.CDRELVERORIG AS PRODUCT_RELEASE,SER.CDRELVERORIG AS PRODUCT_RELEASE_LABEL,
                  SER.CDPATRELORIG AS PRODUCT_PATCH,SER.CDPATRELORIG AS PRODUCT_PATCH_LABEL,
                  CASE WHEN $gepWaiting
                         THEN 'Y'
                         ELSE 'N'
                     END AS WAITING,
                   CASE WHEN SER.CDFASETRAM IN ('$validate')
                       THEN 'Y'
                       ELSE 'N'
                     END AS ENABLE_APPROVAL,
                   CASE WHEN $gepWaiting AND SER.CDFASETRAM NOT IN (SELECT CDFATRAMENCE FROM PARAMGERAL PARA WHERE PARA.NRORG = C.NRORG)
                         THEN 'Y'
                         ELSE 'N'
                     END AS ENABLE_CLOSED,
                      CASE WHEN EXISTS (  SELECT NRSEQORCAMENTO AS EXTERNAL_ID
                                            FROM FCT_ORCAMENTO
                                           WHERE NRSOLISERV = SER.NRSOLISERV
                                             AND IDATIVO = 'S'
                                             AND IDSITUACAOORCAMENTO <> 'CANCELADO')
                           THEN 'Y'
                           ELSE 'N'
                      END AS IS_INTEGRATION_SM,
                  (
                     SELECT rtrim(xmlagg(xmlelement(e,CLR.LABEL ,',').extract('//text()') order by CLR.LABEL ).GetClobVal(),',')
                     FROM   CP_CALL_LABEL_RELATION CLR
                     JOIN   CP_CALL_LABEL LAB ON(LAB.NRCALLLABEL = CLR.LABEL )
                     WHERE  CLR.CALL = C.NRCALL
                     AND    CLR.NRORG = C.NRORG
                  ) AS CALL_LABELS,
                   (SELECT S.NRSOLISERV
                   FROM SOLISERV S
                   JOIN ORCASOLICITA O ON (O.CDFILIAL = S.CDFILIAL AND O.NRSOLISERV = S.NRSOLISERV)
                  WHERE S.NRSOLISERV = SER.NRSOLISERV
                    AND ROWNUM = 1
                     AND (SELECT CDFASETRAM
                                   FROM ( SELECT CDFASETRAM
                                            FROM LOGFASETRAM LFT
                                           WHERE LFT.NRSOLISERV = SER.NRSOLISERV
                                             AND CDFASETRAM IN ('$refuse','$validate')
                                        ORDER BY DTALFASETRAM DESC)
                                  WHERE ROWNUM = 1) IN ( '$validate' )) AS WITH_BUDGET,C.TEXT_SMALL_1, C.TEXT_SMALL_2, C.TEXT_SMALL_3, C.TEXT_SMALL_4, C.TEXT_SMALL_5,
                                  C.TEXT_LONG_1,C.TEXT_LONG_2,C.TEXT_LONG_3,C.TEXT_LONG_4,C.TEXT_LONG_5,C.NUMBER_1,C.NUMBER_2,C.NUMBER_3,C.NUMBER_4,C.NUMBER_5,
                                  TO_CHAR(DATE_1, 'DD/MM/YYYY') AS DATE_1,TO_CHAR(DATE_2, 'DD/MM/YYYY') AS DATE_2,TO_CHAR(DATE_3, 'DD/MM/YYYY') AS DATE_3,TO_CHAR(DATE_4, 'DD/MM/YYYY') AS DATE_4,TO_CHAR(DATE_5, 'DD/MM/YYYY') AS DATE_5
                FROM CP_CALL C
                JOIN SOLISERV SER ON  (SER.NRSOLISERV = C.CALL_RELATIONSHIP)
                JOIN DESCSOLI DES ON DES.NRSOLISERV = SER.NRSOLISERV
                JOIN OPERADOR OPE ON (OPE.CDOPERADOR = SER.CDOPERADOR )
                JOIN PRODUTO PRO  ON PRO.CDPRODUTO = SER.CDPRODCOMP
                JOIN PRODUTO PRT ON  (PRT.CDPRODUTO = SER.CDPRODGRUP)
           LEFT JOIN ASSUNTO ASS ON ASS.CDASSUNTO = SER.CDASSUNTO
           LEFT JOIN CLIENTE CLI ON CLI.CDCLIENTE = SER.CDCLIENTE
           LEFT JOIN CLASSIFICATION CLA ON (CLA.CDASSUNTO = ASS.CDASSUNTO)
               WHERE C.NRCALL = :CALL_ID
SQL;

        $params = array(
            "CALL_ID" => $id,
            "USER_ID" => $userId,
        );
        $result =  $this->getEntityManager()->getConnection()->fetchAll($query, $params);
        return count($result)>0 ? $result[0] : array();
    }

    public function getAttachmentTicket($nrseqcontato,$fileServerFilesUrl,$commentIdQuery = '') {
        $query =
            <<<SQL
            SELECT CAN.NRANEXOCONTATO AS ID, CAN.DTINCLUSAO AS CREATED_AT, OP.NMOPERADOR AS CREATED_BY,
                   '$fileServerFilesUrl'||CAN.DSCAMINHO AS FILENAME, NUll AS FILE_TYPE, NMARQUIVO||'.'||DSTIPO AS LABEL,
                   1 AS "__fromTicket"
              FROM CRM_ANEXOCONTATO CAN
         LEFT JOIN EVOLCONT EV ON (EV.NRSEQEVOLCONT = CAN.NRORIGEM)
         LEFT JOIN OPERADOR OP ON OP.CDOPERADOR = CAN.CDOPERINCLUSAO
             WHERE CAN.NRSEQCONTATO = :nrseqcontato
             $commentIdQuery
             ORDER BY CAN.DTINCLUSAO DESC ,CAN.NRANEXOCONTATO DESC
SQL;

        $params = array(
            "nrseqcontato" => $nrseqcontato
        );
        $result = $this->getEntityManager()->getConnection()->fetchAll($query, $params);
        return $result;
    }

    public function getDsarvoreprod($cdnatucont,$classificationCrm,$nrtparvprod,$cdproduct)
    {

        $query = <<<SQL
         SELECT rtrim(xmlagg(xmlelement(e,NAME ,' -- ').extract('//text()') order by ORDERBY DESC ).GetClobVal(), ' -- ') AS REFERECE FROM (SELECT DISTINCT NAME,ROWNUM AS ORDERBY
                FROM
                  (SELECT *
                  FROM
                    (SELECT 'A'               AS TIPO,
                      NULL                    AS PARENT,
                      TO_CHAR(TA.NRTPARVPROD) AS ID,
                      TA.DSTPARVPROD          AS NAME,
                      TA.NRTPARVPROD,
                      CC.CHILDCOUNT,
                      CASE
                        WHEN CHILDCOUNT > 0 THEN 'S'
                        ELSE 'N'
                      END AS HASCHILD,
                      TA.NRORG,
                      '' AS CDPRODUTO
                    FROM TIPOARVOREPROD TA,
                      (SELECT TA.NRTPARVPROD,
                        COUNT(EA.NRTPARVPROD) AS CHILDCOUNT
                      FROM ESTRUARVOREPROD EA,
                        TIPOARVOREPROD TA
                      WHERE TA.NRTPARVPROD = EA.NRTPARVPROD
                      GROUP BY TA.NRTPARVPROD
                      ) CC
                    WHERE CC.NRTPARVPROD = TA.NRTPARVPROD
                    AND (INSTR(',' ||:NRTPARVPROD ||',', ',' ||TA.NRTPARVPROD ||',')         > 0
                    OR :NRTPARVPROD IS NULL)
                    UNION ALL
                    SELECT 'E' AS TIPO,
                      TO_CHAR(EA.NRTPARVPROD) || TO_CHAR(NVL(EA.NRARVOREPRODPAI, '')) AS PARENT,
                      TO_CHAR(EA.NRTPARVPROD) || TO_CHAR(EA.NRARVOREPROD) AS ID,
                      EA.NMARVOREPROD             AS NAME,
                      EA.NRTPARVPROD,
                      CC.CHILDCOUNT,
                      CASE
                        WHEN CHILDCOUNT > 0 THEN 'S'
                        ELSE 'N'
                      END AS HASCHILD,
                      EA.NRORG,
                      '' AS CDPRODUTO
                    FROM ESTRUARVOREPROD EA,
                      (SELECT EA.NRARVOREPROD,
                        COUNT(PA.NRARVOREPROD) AS CHILDCOUNT
                      FROM PRODARVOREPROD PA,
                        ESTRUARVOREPROD EA
                      WHERE EA.NRARVOREPROD = PA.NRARVOREPROD(+)
                      GROUP BY EA.NRARVOREPROD
                      ) CC
                    WHERE EA.NRARVOREPROD = CC.NRARVOREPROD
                    AND (INSTR(',' ||:NRTPARVPROD ||',', ',' ||EA.NRTPARVPROD ||',')         > 0
                    OR :NRTPARVPROD IS NULL)
                    UNION ALL
                    SELECT 'P' AS TIPO,
                      TO_CHAR(PA.NRTPARVPROD) || TO_CHAR(PA.NRARVOREPROD) AS PARENT,
                      PA.CDPRODUTO                AS ID,
                      PD.NMPRODUTO                AS NAME,
                      PA.NRTPARVPROD,
                      0   AS CHILDCOUNT,
                      'N' AS HASCHILD,
                      PA.NRORG,
                      PA.CDPRODUTO
                    FROM PRODARVOREPROD PA,
                      PRODUTO PD
                    WHERE PA.CDPRODUTO = PD.CDPRODUTO
                    AND PD.CDPRODUTO = :CDPRODUTO
                    AND (INSTR(',' ||:NRTPARVPROD ||',', ',' ||PA.NRTPARVPROD ||',')         > 0
                    OR :NRTPARVPROD IS NULL)
                    )
                  WHERE NVL(PARENT, -1) != ID
                  ) RES
                  CONNECT BY PRIOR RES.PARENT = RES.ID
                  START WITH RES.CDPRODUTO   IN
                  (SELECT CDPRODUTO
                  FROM CRM_CLASSIFICACASOPROD
                  WHERE NRORG              = RES.NRORG
                  AND CDNATUCONT          IN (:CDNATUCONT)
                  AND NRCLASSIFICACAOCASO IN (:NRCLASSIFICACAOCASO)
                  )
                OR (RES.CDPRODUTO       IS NOT NULL
                AND (:CDNATUCONT        IS NULL
                OR :NRCLASSIFICACAOCASO IS NULL)))
SQL;

        $params = array(
            "NRCLASSIFICACAOCASO" => $classificationCrm,
            "CDNATUCONT" => $cdnatucont,
            "NRTPARVPROD" => $nrtparvprod,
            "CDPRODUTO" => $cdproduct,
        );
        $result =  $this->getEntityManager()->getConnection()->fetchAll($query, $params);
        return count($result)>0 ? $result[0]['REFERECE'] : array();
    }

    public function getClassificationCrm($product)
    {

        $query = <<<SQL
         SELECT CLA.NRCLASSIFICACAOCASO AS ID,CLA.CDNATUCONT,FIL.NRFILAATENDIMENTO AS FILA
           FROM CRM_CLASSIFICACASOPROD CLA
          LEFT JOIN CRM_FILATENDIMENTO FIL ON (FIL.NRCLASSIFICACAOCASO = CLA.NRCLASSIFICACAOCASO)
          WHERE CDPRODUTO = :CDPRODUTO
SQL;

        $params = array(
            "CDPRODUTO" => $product
        );

        $result =  $this->getEntityManager()->getConnection()->fetchAll($query, $params);
        return count($result)>0 ? array($result[0]['ID'],$result[0]['CDNATUCONT'],$result[0]['FILA']) : array();
    }


    public function findSupportCallCause($cdOperador, $referenceProduct){
        $query = <<<SQL
            SELECT DISTINCT * FROM (
                SELECT MO.CDMOTICONT AS ID,
                        MO.NMMOTICONT AS NAME,
                        MO.NRORG      AS NRORG
                FROM MOTICONT MO
                INNER JOIN CRM_PERFIMOTICONT PE ON MO.CDMOTICONT = PE.CDMOTICONT AND MO.NRORG = PE.NRORG
                INNER JOIN CRM_PERFIOPER PO ON PO.NRSEQPERFATIV = PE.NRSEQPERFATIV  AND PO.NRORG = PE.NRORG
                                            AND PO.CDOPERADOR = :CDOPERADOR
                WHERE MO.IDATIVO = 'S'
                AND EXISTS (
                  SELECT *
                  FROM CRM_RELACIONAMOTIVOSISTEMA C
                  WHERE MO.CDMOTICONT = C.CDMOTICONT AND C.CDSISTEMA = :CDSISTEMA
                )
                UNION ALL
                    SELECT MO.CDMOTICONT AS ID,
                           MO.NMMOTICONT AS NAME,
                           MO.NRORG      AS NRORG
                    FROM MOTICONT MO
                    INNER JOIN CRM_PERFIMOTICONT PE ON MO.CDMOTICONT = PE.CDMOTICONT AND MO.NRORG = PE.NRORG
                    INNER JOIN CRM_PERFIOPER PO ON PO.NRSEQPERFATIV = PE.NRSEQPERFATIV AND PO.NRORG = PE.NRORG
                                                AND PO.CDOPERADOR = :CDOPERADOR
                    WHERE MO.IDATIVO = 'S'
                    AND NOT EXISTS (
                      SELECT *
                      FROM CRM_RELACIONAMOTIVOSISTEMA C
                      WHERE C.CDSISTEMA = :CDSISTEMA
                    )
                UNION ALL
                    SELECT MO.CDMOTICONT AS ID,
                           MO.NMMOTICONT AS NAME,
                           MO.NRORG      AS NRORG
                    FROM MOTICONT MO
                    INNER JOIN CONTATO CO ON MO.CDMOTICONT = CO.CDMOTICONT AND MO.NRORG = CO.NRORG
                    WHERE CO.CDCASO = ''
            )
SQL;

        $params = array(
            "CDOPERADOR" => $cdOperador,
            "CDSISTEMA" => $referenceProduct
        );

        return $this->getEntityManager()->getConnection()->fetchAll($query, $params);
    }

    public function findSupportCallReferenceProducts($cdOperador, $nrOrg)
    {
        $query =
            <<<SQL
            SELECT DISTINCT * FROM (
                 SELECT SI.CDSISTEMA AS ID,
                        SI.NMSISTEMA AS NAME,
                        SI.NRORG AS NRORG
                   FROM SISTEMA SI, CRM_PERFISISTEMA PE, CRM_PERFIOPER PO
                  WHERE SI.CDSISTEMA = PE.CDSISTEMA
                    AND SI.NRORG = PE.NRORG
                    AND PO.NRSEQPERFATIV = PE.NRSEQPERFATIV
                    AND PO.NRORG = PE.NRORG
                    AND PO.CDOPERADOR = :CDOPERADOR
                    AND SI.NRORG = :NRORG
                    AND SI.IDATIVO = 'S'
                    AND SI.IDTECNOSIST = 'WEB'
                    AND SI.IDTIPLINPSIST = 'PROD'
                UNION ALL
                    SELECT SI.CDSISTEMA AS ID,
                           SI.NMSISTEMA AS NAME,
                           SI.NRORG     AS NRORG
                    FROM SISTEMA SI
                    INNER JOIN CONTATO CO ON SI.CDSISTEMA = CO.CDSISTEMA AND SI.NRORG = CO.NRORG
                    WHERE CO.CDCASO = ''
            )
            ORDER BY NAME
SQL;

        $params = array(
            'CDOPERADOR'    => $cdOperador,
            'NRORG'         => $nrOrg
        );

        return $this->getEntityManager()->getConnection()->fetchAll($query, $params);
    }

    public function getBeginAndEndCdfasetram($nrorg) {
        $query =
            <<<SQL
          SELECT CDFATRAMIWEB,CDFATRAMENCE
            FROM PARAMGERAL
           WHERE NRORG = :NRORG
SQL;

        $params = array(
            "NRORG" => $nrorg,
        );
        return $this->getEntityManager()->getConnection()->fetchAll($query, $params)[0];
    }

    public function findProductCallProductsFromTicket($filterString){
        $query =
            <<<SQL
          SELECT ID , NAME FROM (
             SELECT PRO.CDPRODUTO AS ID, PRO.NMPRODUTO AS NAME
               FROM PRODARVOREPROD PA
                JOIN PRODUTO PRO ON(PRO.CDPRODUTO = PA.CDPRODUTO AND (PROJECT_ID IS NOT NULL OR (CDPRODCOMP IS NOT NULL AND CDPRODGRUP IS NOT NULL)))
                JOIN CRM_RELACMOTIPROD MOTIPROD ON (PRO.CDPRODUTO = MOTIPROD.CDPRODUTO)
                JOIN MOTICONT MOTI ON (MOTI.CDMOTICONT = MOTIPROD.CDMOTICONT AND (MOTI.CLASSIFICATION_ID IS NOT NULL OR MOTI.CLASSIFICATION_ID IS NOT NULL))
                GROUP BY PRO.CDPRODUTO, PRO.NMPRODUTO
                   )
           WHERE 1 = 1
                 $filterString

SQL;

        $params = array(
            'PRODUCT_TYPE_COMERCIAL' => 'C'
        );

        return $this->getEntityManager()->getConnection()->fetchAll($query, $params);
    }

    public function getInfoForSendCall($cdfasetram,$lang,$nrorg) {
        $query =
            <<<SQL
            SELECT DECODE(:P_IDIDIOMA, 'BRA', FAS.TXPERGFATRAM, NVL(PFT.TXPERGFATRAM, FAS.TXPERGFATRAM)) AS TXPERGFATRAM,
                   DECODE(:P_IDIDIOMA, 'BRA', FTD.TXRESPFATRAM, NVL(RFT.TXRESPFATRAM, FTD.TXRESPFATRAM)) AS TXRESPFATRAM,
                   DECODE(:P_IDIDIOMA, 'BRA', FAS.NMFASETRAM, NVL(NFT.NMFASETRAM, FAS.NMFASETRAM)) AS NMFASETRAM,
                   FTD.NRFASTRAMDES,
                   FAS.IDOBSOBRTRAM,
                   FTD.CDFASTRAMDES,
                    CASE WHEN FTD.CDFASTRAMDES IN (SELECT CDFATRAMENCE FROM PARAMGERAL PARA WHERE PARA.NRORG = :NRORG)
                         THEN 'Y'
                         ELSE 'N'
                     END AS IS_FINALIZATION,
                   FTD.TXACAOFATRAM
              FROM FASETRAMDEST FTD, FASETRAM FAS,
                   (SELECT SUBSTR(NMCOMPONENTE,1,3) AS CDFASETRAM, STVALORPROP AS TXPERGFATRAM
                      FROM PROPRIED
                     WHERE CDPROGTRAD = 'FASETRAM'
                       AND SUBSTR(NMCOMPONENTE,1,3) = :P_CDFASE
                       AND IDIDIOMA = :P_IDIDIOMA
                       AND NMPROPRIED = 'TXPERGFATRAM') PFT,
                    (SELECT SUBSTR(NMCOMPONENTE,1,3) AS CDFASETRAM, SUBSTR(NMCOMPONENTE,4,2) AS NRFASTRAMDES, STVALORPROP AS TXRESPFATRAM
                       FROM PROPRIED
                      WHERE CDPROGTRAD = 'FASETRAMDEST'
                        AND SUBSTR(NMCOMPONENTE,1,3) = :P_CDFASE
                        AND IDIDIOMA = :P_IDIDIOMA
                        AND NMPROPRIED = 'TXRESPFATRAM') RFT,
                    (SELECT SUBSTR(NMCOMPONENTE,1,3) AS CDFASETRAM, STVALORPROP AS NMFASETRAM
                       FROM PROPRIED
                      WHERE CDPROGTRAD = 'FASETRAM'
                        AND SUBSTR(NMCOMPONENTE,1,3) = :P_CDFASE
                        AND IDIDIOMA = :P_IDIDIOMA
                        AND NMPROPRIED = 'NMFASETRAM') NFT
             WHERE (FAS.CDFASETRAM = FTD.CDFASETRAM )
               AND (FAS.CDFASETRAM = :P_CDFASE)
               AND (PFT.CDFASETRAM(+) = FAS.CDFASETRAM)
               AND (NFT.CDFASETRAM(+) = FAS.CDFASETRAM)
               AND (RFT.CDFASETRAM(+) = FTD.CDFASETRAM)
               AND (RFT.NRFASTRAMDES(+) = FTD.NRFASTRAMDES)
               ORDER BY FTD.NRFASTRAMDES
SQL;

        $params = array(
            "P_IDIDIOMA" => $lang,
            "P_CDFASE" => $cdfasetram,
            "NRORG" => $nrorg,
        );

        return $this->getEntityManager()->getConnection()->fetchAll($query, $params);
    }
    public function operadorGrupoByResponse($cdfasetram,$cdfastramdes, $nrfastramdes) {
        $query =
            <<<SQL
          SELECT
               FD.NRFASTRAMDES,
               FD.CDFASTRAMDES,
               FA.CDGROPERRESP,
               CASE WHEN FA.IDDEPACAOOPE = 'G'
                             THEN 'A'
                             ELSE FA.IDDEPACAOOPE
                         END AS IDDEPACAOOPE
            FROM
               FASETRAMDEST FD,
               FASETRAM FA
            WHERE
               FD.CDFASETRAM   = :P_CDFASETRAM   AND
               FD.CDFASTRAMDES = :P_CDFASTRAMDES AND
               FD.NRFASTRAMDES = :P_NRFASTRAMDES AND
               FD.CDFASTRAMDES = FA.CDFASETRAM
SQL;

        $params = array(
            "P_CDFASTRAMDES" => $cdfastramdes,
            "P_NRFASTRAMDES" => $nrfastramdes,
            "P_CDFASETRAM" => $cdfasetram,
        );
        $result = $this->getEntityManager()->getConnection()->fetchAll($query, $params);
        return count($result) > 0 ? array($result[0]['IDDEPACAOOPE'],$result[0]['CDGROPERRESP']) : array();
    }

    public function operadorByResponseIssue($IssueId)
    {
        $query =
            <<<SQL
            SELECT RTRIM(XMLAGG(XMLELEMENT(e,RT.NAME ,',').EXTRACT('//text()')).GetClobVal(),',') AS NMOPERADOR,
                   '1' AS CDOPERADOR, null AS DSEMAILOPER, '010' AS NRPRIOPERCLI,
                   RTRIM(XMLAGG(XMLELEMENT(e,RT.ID ,',').EXTRACT('//text()')).GetClobVal(),',') AS RESOURCE_ID
              FROM RESOURCE_PROJECT RP
              JOIN TASK TAS ON (TAS.ID = :ISSUE_ID AND TAS.PROJECT = RP.PROJECT)
              JOIN RESOURCE_T RT ON (RT.ID = RP.RESOURCE_C AND RP.TYPE = 'M')
SQL;

        $params = array(
            "ISSUE_ID" => $IssueId
        );
        return $this->getEntityManager()->getConnection()->fetchAll($query, $params);
    }

    public function operadorByResponse($iddepacaoope,$cdgroperresp,$cdCliente) {
        if($iddepacaoope == 'A'){
            $query =
                <<<SQL
               SELECT
               OP.CDOPERADOR,
               OP.NMOPERADOR
            FROM
               OPERGRUPOP OG,
               OPERADOR OP
            WHERE
               OG.CDGRUPOPER = :P_CDGRUPOPER AND
               OG.CDOPERADOR = OP.CDOPERADOR AND
               OP.IDOPERATIVO = :P_IDDEPACAOOPE
            ORDER BY OP.NMOPERADOR
SQL;

        }else{
            $query =
                <<<SQL
               SELECT DISTINCT
                   OC.CDOPERADOR,
                   OC.NRPRIOPERCLI,
                   O.NMOPERADOR,
                   O.DSEMAILOPER
                FROM
                   OPERCLIE OC,
                   OPERADOR O
                WHERE
                   OC.CDCLIENTE = :P_CDCLIENTE  AND
                   O.CDOPERADOR = OC.CDOPERADOR AND
                   IDTPOPERCLIE = :P_IDDEPACAOOPE
                ORDER BY O.NMOPERADOR
SQL;
        }


        $params = array(
            "P_IDDEPACAOOPE" => $iddepacaoope,
            "P_CDGRUPOPER" => $cdgroperresp,
            "P_CDCLIENTE" => $cdCliente,
        );
        return $this->getEntityManager()->getConnection()->fetchAll($query, $params);
    }

    public function operadorByResponseAtivo($iddepacaoope, $cdgroperresp, $cdCliente) {
        if($iddepacaoope == 'A'){
            $query =
                <<<SQL
               SELECT
               OP.CDOPERADOR,
               OP.NMOPERADOR,
               OP.IDOPERATIVO
            FROM
               OPERGRUPOP OG,
               OPERADOR OP
            WHERE
               OG.CDGRUPOPER = :P_CDGRUPOPER AND
               OG.CDOPERADOR = OP.CDOPERADOR AND
               OP.IDOPERATIVO = :P_IDDEPACAOOPE AND
               OP.IDOPERATIVO = 'A'
            ORDER BY OP.NMOPERADOR
SQL;

        }else{
            $query =
                <<<SQL
               SELECT DISTINCT
                   OC.CDOPERADOR,
                   OC.NRPRIOPERCLI,
                   O.NMOPERADOR,
                   O.DSEMAILOPER,
                   O.IDOPERATIVO
                FROM
                   OPERCLIE OC,
                   OPERADOR O
                WHERE
                   OC.CDCLIENTE = :P_CDCLIENTE  AND
                   O.CDOPERADOR = OC.CDOPERADOR AND
                   IDTPOPERCLIE = :P_IDDEPACAOOPE AND
                   O.IDOPERATIVO = 'A'
                ORDER BY O.NMOPERADOR
SQL;
        }


        $params = array(
            "P_IDDEPACAOOPE" => $iddepacaoope,
            "P_CDGRUPOPER" => $cdgroperresp,
            "P_CDCLIENTE" => $cdCliente,
        );
        return $this->getEntityManager()->getConnection()->fetchAll($query, $params);
    }

    public function getAllSituation($nrorg,$waitingTicket) {
        $query =
            <<<SQL
       SELECT TO_CHAR(TST.ID) AS ID, 'PM' AS PRODUCT,
         CASE WHEN TPR.ID IS NOT NULL THEN 'CLOSED'
              WHEN TST.CONTROL = 'B' THEN 'OPENED'
              WHEN TST.CONTROL IN ('H','A') THEN 'WAITING'
              ELSE 'IN_PROGRESS'
          END AS SITUATION
        FROM TASK_STATUS TST
        LEFT JOIN TASK_PROPERTIES TPR ON(TPR.FINAL_TASK_STATUS = TST.ID)
        WHERE IS_PROJECT = 'N'
        AND TST.ORGANIZATION = :NRORG

        UNION

        SELECT TO_CHAR(NRSEQSITUACAO) AS ID ,'CRM' AS PRODUCT,
        CASE WHEN NRSEQSITUACAO IN (4) THEN 'CLOSED'
              WHEN NRSEQSITUACAO IN (1) THEN 'OPENED'
              WHEN NRSEQSITUACAO IN ($waitingTicket) THEN 'WAITING'
              ELSE 'IN_PROGRESS'
          END AS SITUATION
        FROM CRM_SITUACAO
        WHERE NRORG IN ( $nrorg ,0)
SQL;

        $params = array(
            "NRORG" => $nrorg,
        );

        return $this->getEntityManager()->getConnection()->fetchAll($query, $params);
    }

    public function getIntegrationValidationSoliserv($nrsoliserv){

        $validate = \Util\Utilities::getValidateBudgetFaseGep();
        $query =
            <<<SQL
       SELECT
            CASE WHEN SER.CDFASETRAM IN ('$validate')
                       THEN 'Y'
                       ELSE 'N'
                     END AS ENABLE_APPROVAL,
            FCO.NRSEQORCAMENTO AS EXTERNAL_ID
        FROM SOLISERV SER
        JOIN FCT_ORCAMENTO FCO ON(FCO.NRSOLISERV = :NRSOLISERV AND  FCO.NRSOLISERV = SER.NRSOLISERV AND  FCO.IDSITUACAOORCAMENTO <> 'CANCELADO' AND  FCO.IDATIVO = 'S')
        WHERE
           SER.NRSOLISERV = :NRSOLISERV
SQL;

        $params = array(
            "NRSOLISERV" => $nrsoliserv,
        );

        return $this->getEntityManager()->getConnection()->fetchAll($query, $params);
    }

    public function getallParamGeral($nrorg) {
        $query =
            <<<SQL
       SELECT
           PAR.CDFATRAMIWEB,
           PAR.CDFATRAMENCE,
           FA.IDDEPACAOOPE,
           FA.CDGROPERRESP,
           PAR.CDCOMPLEXINI,
           PAR.CDFILIAL
        FROM
           FASETRAM FA,
           GRUPOPER GR,
           PARAMGERAL PAR
        WHERE
           (FA.CDGROPERRESP  = GR.CDGRUPOPER (+)) AND
           (PAR.CDFATRAMIWEB = FA.CDFASETRAM    )
           AND PAR.NRORG = :NRORG
SQL;

        $params = array(
            "NRORG" => $nrorg,
        );

        return $this->getEntityManager()->getConnection()->fetchAll($query, $params)[0];
    }

    public function countCallsByType($cdCliente, $userId, $closedFilter)
    {
        $contatoFilter  = $closedFilter['CONTATO'];
        $issueFilter    = $closedFilter['ISSUE'];
        $soliservFilter = $closedFilter['SOLISERV'];
        $now        = new \Datetime();
        $endDate    = $now->format(\Zeedhi\DevOps\Util\Utilities::FORMAT_DATE_DEFAULT_ONLY_DATE);
        $now->modify('-4 month');
        $beginDate  = $now->format(\Zeedhi\DevOps\Util\Utilities::FORMAT_DATE_DEFAULT_ONLY_DATE);

        /*
        // funcionalidade comentada para futuramente ser implementada

           SELECT TO_CHAR(CONT.NRSEQCONTATO) AS NRCALL, 'C' AS TYPE
             FROM CONTATO CONT
             JOIN SISTEMA S    ON S.CDSISTEMA = CONT.CDSISTEMA
             JOIN CLIENTE CLI  ON CLI.NRPARCNEGOCIO  = CONT.NRPARCNEGOCIO
             JOIN OPERADOR OPE ON OPE.CDOPERADOR = CONT.CDOPERINCLUSAO
        LEFT JOIN CP_CALL C    ON CONT.NRSEQCONTATO = C.CALL_RELATIONSHIP
            WHERE CLI.CDCLIENTE = :CD_CLIENTE
                  AND OPE.CDOPERADOR = :USER_ID
                  $contatoFilter
         GROUP BY CONT.NRSEQCONTATO
     UNION ALL
        */


        $query = <<<SQL
  SELECT TYPE, COUNT(NRCALL) AS QUANTITY
         FROM (

        SELECT TO_CHAR(SER.NRSOLISERV) AS NRCALL,'S' AS TYPE
          FROM SOLISERV SER
          JOIN PRODUTO PRO  ON PRO.CDPRODUTO = SER.CDPRODCOMP
          JOIN ASSUNTO ASS  ON ASS.CDASSUNTO = SER.CDASSUNTO
          JOIN OPERADOR OPE ON OPE.CDOPERADOR = SER.CDOPERADOR
     LEFT JOIN CP_CALL C ON  (SER.NRSOLISERV = C.CALL_RELATIONSHIP)
         WHERE SER.CDCLIENTE = :CD_CLIENTE
               AND SER.DTINCLUSAO BETWEEN TO_DATE( '$beginDate 00:00:00' ,'DD/MM/YYYY HH24:MI:SS')
                                                AND TO_DATE( '$endDate 23:59:59' ,'DD/MM/YYYY HH24:MI:SS')
               $soliservFilter
     GROUP BY SER.NRSOLISERV


     UNION ALL
        SELECT TO_CHAR(TAS.ID) AS NRCALL, 'I' AS TYPE
         FROM TASK TAS
         JOIN TASK_STATUS TS ON (TS.ID = TAS.TASK_STATUS)
         JOIN ALLOCATION SAR ON (SAR.TASK = TAS.ID AND SAR.TYPE = 'R')
         JOIN RESOURCE_T RES ON RES.ID = SAR.RESOURCE_T
    LEFT JOIN CP_CALL C      ON (TAS.ID = C.CALL_RELATIONSHIP)
    LEFT JOIN ALLOCATION SA ON (SA.TASK = TAS.ID AND SA.TYPE = 'S')
    LEFT JOIN RESOURCE_T SRE ON (SRE.ID = SA.RESOURCE_T)
        WHERE SRE.EXTERNAL_CODE = :CD_CLIENTE
          AND TAS.IS_ISSUE = 'Y'
          AND TAS.STATUS NOT IN ('D')
          AND TAS.CREATED_AT BETWEEN TO_DATE( '$beginDate 00:00:00' ,'DD/MM/YYYY HH24:MI:SS')
                                                AND TO_DATE( '$endDate 23:59:59' ,'DD/MM/YYYY HH24:MI:SS')
              $issueFilter
     GROUP BY TAS.ID

     )
  GROUP BY TYPE
  ORDER BY TYPE
SQL;

        $params = array(
            "CD_CLIENTE" => $cdCliente,
            "USER_ID" => $userId,
        );
        return $this->getEntityManager()->getConnection()->fetchAll($query, $params);
    }

    public function getLastQuestion($taskId)
    {

        $query = <<<SQL
            SELECT * FROM (SELECT COM.DESCRIPTION
              FROM COMMENTS COM
              JOIN COMMENT_TYPE CTY ON(COM.COMMENT_TYPE_ID = CTY.ID AND CTY.CONTROL = 'Q')
             WHERE TASK = :TASK_ID
          ORDER BY COM.ID DESC)
             WHERE ROWNUM = 1
SQL;

        $params = array(
            "TASK_ID" => $taskId,
        );

        return $this->getEntityManager()->getConnection()->fetchAll($query, $params);
    }

    public function countCallsByLabel($cdCliente, $userId, $closedFilter)
    {
        $issueFilter    = $closedFilter['ISSUE'];
        $contatoFilter  = $closedFilter['CONTATO'];
        $soliservFilter = $closedFilter['SOLISERV'];
        $now        = new \Datetime();
        $endDate    = $now->format(\Zeedhi\DevOps\Util\Utilities::FORMAT_DATE_DEFAULT_ONLY_DATE);
        $now->modify('-4 month');
        $beginDate  = $now->format(\Zeedhi\DevOps\Util\Utilities::FORMAT_DATE_DEFAULT_ONLY_DATE);

        /*
       // funcionalidade comentada para futuramente ser implementada

             SELECT TO_CHAR(CONT.NRSEQCONTATO) AS CALL_RELATIONSHIP, C.NRCALL, 'C' AS TYPE
             FROM CONTATO CONT
             JOIN CLIENTE CLI  ON CLI.NRPARCNEGOCIO  = CONT.NRPARCNEGOCIO
             JOIN SISTEMA S    ON S.CDSISTEMA = CONT.CDSISTEMA
             JOIN OPERADOR OPE ON OPE.CDOPERADOR = CONT.CDOPERINCLUSAO
        LEFT JOIN CP_CALL C    ON CONT.NRSEQCONTATO = C.CALL_RELATIONSHIP
            WHERE CLI.CDCLIENTE = :CD_CLIENTE
                  AND OPE.CDOPERADOR = :USER_ID
                  $contatoFilter
         GROUP BY CONT.NRSEQCONTATO, C.NRCALL
     UNION
       */

        $query = <<<SQL
SELECT NVL(CL.DESCRIPTION, 'Sem Rótulo') AS LABEL, COUNT(CAL.CALL_RELATIONSHIP) AS QUANTITY
         FROM


          (


       SELECT TO_CHAR(SER.NRSOLISERV) AS CALL_RELATIONSHIP, C.NRCALL, 'S' AS TYPE
          FROM SOLISERV SER
          JOIN PRODUTO PRO  ON PRO.CDPRODUTO = SER.CDPRODCOMP
          JOIN ASSUNTO ASS  ON ASS.CDASSUNTO = SER.CDASSUNTO
          JOIN OPERADOR OPE ON OPE.CDOPERADOR = SER.CDOPERADOR
     LEFT JOIN CP_CALL C ON  (SER.NRSOLISERV = C.CALL_RELATIONSHIP)
         WHERE SER.CDCLIENTE = :CD_CLIENTE
               AND SER.DTINCLUSAO BETWEEN TO_DATE( '$beginDate 00:00:00' ,'DD/MM/YYYY HH24:MI:SS')
                                                AND TO_DATE( '$endDate 23:59:59' ,'DD/MM/YYYY HH24:MI:SS')
               $soliservFilter
     GROUP BY SER.NRSOLISERV, C.NRCALL


     UNION
        SELECT TO_CHAR(TAS.ID) AS CALL_RELATIONSHIP, C.NRCALL, 'I' AS TYPE
         FROM TASK TAS
         JOIN TASK_STATUS TS ON (TS.ID = TAS.TASK_STATUS)
         JOIN ALLOCATION SAR ON (SAR.TASK = TAS.ID AND SAR.TYPE = 'R')
         JOIN RESOURCE_T RES ON RES.ID = SAR.RESOURCE_T
    LEFT JOIN CP_CALL C      ON (TAS.ID = C.CALL_RELATIONSHIP)
    LEFT JOIN ALLOCATION SA ON (SA.TASK = TAS.ID AND SA.TYPE = 'S')
    LEFT JOIN RESOURCE_T SRE ON (SRE.ID = SA.RESOURCE_T)
        WHERE SRE.EXTERNAL_CODE = :CD_CLIENTE
          AND TAS.IS_ISSUE = 'Y'
          AND TAS.STATUS NOT IN ('D')
          AND TAS.CREATED_AT BETWEEN TO_DATE( '$beginDate 00:00:00' ,'DD/MM/YYYY HH24:MI:SS')
                                                AND TO_DATE( '$endDate 23:59:59' ,'DD/MM/YYYY HH24:MI:SS')
              $issueFilter
     GROUP BY TAS.ID, C.NRCALL

     ) CAL
     JOIN CP_CALL_LABEL_RELATION CLR ON CLR.CALL = CAL.NRCALL
     JOIN CP_CALL_LABEL CL ON CLR.LABEL = CL.NRCALLLABEL
  GROUP BY CL.DESCRIPTION
            ORDER BY QUANTITY DESC
SQL;

        $params = array(
            "CD_CLIENTE" => $cdCliente,
            "USER_ID" => $userId,
        );
        return $this->getEntityManager()->getConnection()->fetchAll($query, $params);
    }

    public function getReleases($productTypeId, $version) {
        $query =
            <<<SQL
            SELECT CDRELVERPROD AS ID, CDRELVERPROD AS LABEL
            FROM RELEVERPROD
            WHERE
            (CDPRODGRUP = :P_CDGRUPSIST) AND
            (CDVERPRODUTO = :P_CDVERSGSIS)
            ORDER BY CDRELVERPROD DESC
SQL;

        $params = array(
            "P_CDGRUPSIST" => $productTypeId,
            "P_CDVERSGSIS" => $version,
        );


        return $this->getEntityManager()->getConnection()->fetchAll($query, $params);
    }
    public function getPatch($productType, $version, $release) {
        $query =
            <<<SQL
            SELECT CDPATCHVERPR AS ID,CDPATCHVERPR AS LABEL
              FROM PATCHVERPROD
             WHERE CDPRODGRUP = :P_CDGRUPSIST
               AND CDVERPRODUTO = :P_CDVERSGSIS
               AND CDRELVERPROD = :P_CDRELEASEVER
          ORDER BY CDPATCHVERPR DESC
SQL;

        $params = array(
            "P_CDGRUPSIST" => $productType,
            "P_CDVERSGSIS" => $version,
            "P_CDRELEASEVER" => $release,
        );

        return $this->getEntityManager()->getConnection()->fetchAll($query, $params);
    }

    public function getCallGraphicForFourMonth($cdCliente,$filter,$userId)
    {
        $now        = new \Datetime();
        $endDate    = $now->format(\Zeedhi\DevOps\Util\Utilities::FORMAT_DATE_DEFAULT_ONLY_DATE);
        $now->modify('-4 month');
        $beginDate  = $now->format(\Zeedhi\DevOps\Util\Utilities::FORMAT_DATE_DEFAULT_ONLY_DATE);

        $gepOpened  = $filter['GEP']['OPENED'];
        $gepWaiting = $filter['GEP']['WAITING'];
        $gepClosed  = $filter['GEP']['CLOSED'];

        $pmOpened       = implode(',', $filter['PM']['OPENED']);
        $pmInProgress   = implode(',', $filter['PM']['IN_PROGRESS']);
        $pmWaiting      = implode(',', $filter['PM']['WAITING']);
        $pmClosed       = implode(',', $filter['PM']['CLOSED']);

        $query = <<<SQL
            SELECT MES, count(OPENED) AS OPENED, count(INPROGRESS) AS INPROGRESS, count(WAITING) AS WAITING, count(CLOSED) AS CLOSED, MONTH_ORDER
            FROM(

                SELECT  TRIM(TO_CHAR(ISS.DTINCLUSAO,'Month','NLS_DATE_LANGUAGE=PORTUGUESE')) AS MES,
                        TO_CHAR(ISS.DTINCLUSAO, 'YYYYMM') AS MONTH_ORDER,
                            CASE WHEN ISS.ID IN ($pmOpened) AND LAST_COMMENT_TYPE IS NULL
                                 THEN 'Y'
                                 ELSE null
                             END AS OPENED,
                            CASE WHEN ISS.ID IN ($pmInProgress) AND LAST_COMMENT_TYPE IS NULL
                                 THEN 'Y'
                                 ELSE null
                             END AS INPROGRESS,
                            CASE WHEN ISS.ID IN ($pmWaiting) OR LAST_COMMENT_TYPE = 'Y'
                                 THEN 'Y'
                                 ELSE null
                             END AS WAITING,
                            CASE WHEN ISS.ID IN ($pmClosed) AND LAST_COMMENT_TYPE IS NULL
                                 THEN 'Y'
                                 ELSE null
                             END AS CLOSED
                FROM (
                SELECT NRCALL,TYPE,ID, DTINCLUSAO,
                        (CASE WHEN (SELECT CONTROL FROM (SELECT CTY.CONTROL
                                                FROM COMMENTS COM
                                                JOIN COMMENT_TYPE CTY ON(COM.COMMENT_TYPE_ID = CTY.ID )
                                                WHERE COM.TASK = TAS.TASK_ID
                                                ORDER BY COM.ID DESC)
                                                WHERE ROWNUM = 1 ) = 'Q'  THEN 'Y'  ELSE NULL END) AS LAST_COMMENT_TYPE

                 FROM (SELECT C.NRCALL,C.TYPE,TS.ID, TAS.CREATED_AT AS DTINCLUSAO,TAS.ID AS TASK_ID
                             FROM TASK TAS
                            JOIN ALLOCATION SAR ON (SAR.TASK = TAS.ID AND SAR.TYPE = 'R')
                            JOIN RESOURCE_T RES ON RES.ID = SAR.RESOURCE_T
                            JOIN TASK_STATUS TS ON TS.ID = TAS.TASK_STATUS
                       LEFT JOIN CP_CALL C      ON TAS.ID = C.CALL_RELATIONSHIP
                       LEFT JOIN ALLOCATION SA ON (SA.TASK = TAS.ID AND SA.TYPE = 'S')
                       LEFT JOIN RESOURCE_T SRE ON (SRE.ID = SA.RESOURCE_T)
                           WHERE SRE.EXTERNAL_CODE = :CD_CLIENTE
                                 AND TAS.IS_ISSUE = 'Y'
                                 AND TAS.STATUS NOT IN ('D')
                                 AND TAS.CREATED_AT BETWEEN TO_DATE( '$beginDate 00:00:00' ,'DD/MM/YYYY HH24:MI:SS')
                                                AND TO_DATE( '$endDate 23:59:59' ,'DD/MM/YYYY HH24:MI:SS')
                         GROUP BY C.TYPE, C.NRCALL, TS.ID, TAS.CREATED_AT,TAS.ID
                         )TAS ) ISS


                UNION ALL

                SELECT TRIM(TO_CHAR(RIC.DTINCLUSAO,'Month','NLS_DATE_LANGUAGE=PORTUGUESE')) AS MES,
                        TO_CHAR(RIC.DTINCLUSAO, 'YYYYMM') AS MONTH_ORDER,
                            CASE WHEN RIC.STATUS = 'O'
                                 THEN 'Y'
                                 ELSE null
                             END AS OPENED,
                            CASE WHEN RIC.STATUS = 'I'

                                 THEN 'Y'
                                 ELSE null
                             END AS INPROGRESS,
                            CASE WHEN RIC.STATUS = 'W'
                                 THEN 'Y'
                                 ELSE null
                             END AS WAITING,
                            CASE WHEN RIC.STATUS = 'C'
                                 THEN 'Y'
                                 ELSE null
                             END AS CLOSED
                FROM (
                 SELECT C.NRCALL,C.TYPE,SER.CDFASETRAM, SER.DTINCLUSAO,
                            CASE WHEN $gepWaiting
                                 THEN 'W'
                                 WHEN $gepOpened
                                 THEN 'O'
                                 WHEN $gepClosed
                                 THEN 'C'
                                 ELSE 'I'
                             END AS STATUS
                             FROM SOLISERV SER
                             JOIN OPERADOR OPE ON OPE.CDOPERADOR = SER.CDOPERADOR
                        LEFT JOIN CP_CALL C ON  (SER.NRSOLISERV = C.CALL_RELATIONSHIP)
                            WHERE SER.CDCLIENTE IN (:CD_CLIENTE)
                                  AND SER.DTINCLUSAO BETWEEN TO_DATE( '$beginDate 00:00:00' ,'DD/MM/YYYY HH24:MI:SS')
                                                AND TO_DATE( '$endDate 23:59:59' ,'DD/MM/YYYY HH24:MI:SS')
                ) RIC
                )
                GROUP BY MES, MONTH_ORDER
                ORDER BY MONTH_ORDER ASC

SQL;

        $params = array(
            "CD_CLIENTE" => $cdCliente,
            "USER_ID" => $userId,
        );
        return $this->getEntityManager()->getConnection()->fetchAll($query, $params);

    }


    public function getProductDevOpsIdByProjectId($projectId) {
        $query =
            <<<SQL
            SELECT PRO.ID
              FROM PRODUCT PRO
             WHERE PRO.PROJECT_ID = :projectId
SQL;

        $params = array(
            "projectId" => $projectId
        );

        $result = $this->getEntityManager()->getConnection()->fetchAll($query, $params);

        return count($result)>0 ? $result[0]['ID'] : null;
    }

    public function getProjectIdByProductDevOpsId($productId) {
        $query =
            <<<SQL
            SELECT PROJ.ID
              FROM PRODUCT PROD
              JOIN PROJECT PROJ ON PROJ.ID = PROD.PROJECT_ID
             WHERE PROD.ID = :productId
SQL;

        $params = array(
            "productId" => $productId
        );

        $result = $this->getEntityManager()->getConnection()->fetchAll($query, $params);

        return count($result)>0 ? $result[0]['ID'] : null;
    }

    public function getCallTypeTicket($typeTicket) {
        $query =
            <<<SQL
     SELECT  '$typeTicket-'||MOTI.CDMOTICONT AS ID, MOTI.NMMOTICONT AS LABEL,'$typeTicket' AS ID_FILTER, MOTI.CDMOTICONT
       FROM MOTICONT MOTI
       JOIN CRM_RELACMOTIPROD MOTIPROD ON MOTIPROD.NRORG = MOTI.NRORG
                                          AND MOTI.CDMOTICONT = MOTIPROD.CDMOTICONT
       JOIN PRODUTO PROD ON PROD.NRORG = MOTI.NRORG
                            AND PROD.CDPRODUTO = MOTIPROD.CDPRODUTO
      WHERE (PROD.PROJECT_ID IS NOT NULL OR (PROD.CDPRODCOMP IS NOT NULL AND PROD.CDPRODGRUP IS NOT NULL))
        AND (MOTI.CLASSIFICATION_ID IS NOT NULL AND MOTI.CDASSUNTO IS NOT NULL)
   GROUP BY MOTI.CDMOTICONT, MOTI.NMMOTICONT
SQL;

        $result = $this->getEntityManager()->getConnection()->fetchAll($query);

        return $result;
    }

    /**
     * @param $cdCliente
     * @param $callType
     * @param $callRelationship
     * @param $cdprodcomp
     * @return array
     */
    public function findProductCallProductsFilter($cdCliente,  $callType, $callRelationship, $cdprodcomp,$productFilterId) {
        $callTypeString = "";
        if($callType){
            $callTypeString = " AND CALL_TYPE = :CALL_TYPE";
        }
        if($productFilterId){
            $callTypeString .= " AND PRODUCT_FILTER_ID = :PRODUCT_FILTER_ID";
        }
        $query =
            <<<SQL
            SELECT * FROM (
                SELECT 'Mobile - '||PRD.NAME AS NMPRODUTO, 'I' AS CALL_TYPE, 'MOBILE' AS PLATAFORMA, 'Zeedhi: App, Browser, Mobile' AS PLATAFORMA_NAME,
                       PRD.ID AS PROJECT_ID, NULL AS SGSISTEMA, TO_CHAR(PRD.ID) AS PRODUCT_FILTER_ID

                 FROM PROJECT PRD
                 JOIN PROJECT_TYPE PTP ON (PRD.PROJECT_TYPE = PTP.ID)
                 JOIN PROJECT ISS ON  ISS.PARENT = PRD.ID
                 JOIN PROJECT_TYPE PTI ON ISS.PROJECT_TYPE = PTI.ID
                 JOIN TASK_STATUS TS ON TS.ID = PRD.PROJECT_STATUS
                 WHERE  TS.CONTROL NOT IN(:concluded, :canceled)
                   AND PRD.PRODUCT_TYPE NOT IN (:managerType)
                   AND PTP.EXTERNALTYPE = :product
                   AND PTI.EXTERNALTYPE = :typeIssue
                   AND ISS.STATUS <> :deleted
                   AND PRD.ORGANIZATION = :organizationId
                   AND PRD.STATUS = :active
         UNION ALL
           SELECT DISTINCT 'Delphi - '||SIS.NMSISTEMA, 'S' AS CALL_TYPE, 'DELPHI' AS PLATAFORMA,
                                     'Delphi: Windows' AS PLATAFORMA_NAME, NULL AS PROJECT_ID,
                                      SIS.SGSISTEMA, SIS.SGSISTEMA AS PRODUCT_FILTER_ID
                                 FROM PARFILIALGEP PG, PRSUBGRPROD NV, PRODUTO PR, PRODUTO GRUP, SISTEMA SIS
                                WHERE (PG.CDFILIAL = '9999')
                                  AND (NV.CDFILISUBGR = '9999' OR NV.CDFILISUBGR = 'P')
                                  AND (PG.CDGRUPPROD = NV.CDGRUPPROD)
                                  AND (NV.CDPRODUTO = PR.CDPRODUTO)
                                  AND (PR.CDARVPROD LIKE GRUP.CDARVPROD||'%')
                                  AND (SIS.SGSISTEMA = SUBSTR(GRUP.CDARVPROD, -3))
                                  AND (GRUP.CDNVPRODUTO = '4')
                                ORDER BY 1)
        WHERE 1=1
        $callTypeString

SQL;

        $params = array(
            "CDCLIENTE" => $cdCliente,
            "NRSOLISERV" => $callRelationship,
            "CALL_TYPE" => $callType,
            "PRODUCT_FILTER_ID" => $productFilterId,
            "CDPRODCOMP" => $cdprodcomp,
            'organizationId' => 20,
            'concluded' => \Zeedhi\DevOps\Model\Projectmanagement\Entities\TaskStatus::TASK_STATUS_CONTROL_CONCLUDED,
            'canceled' =>  \Zeedhi\DevOps\Model\Projectmanagement\Entities\TaskStatus::TASK_STATUS_CONTROL_CANCELED,
            'product' =>  \Zeedhi\DevOps\Model\Projectmanagement\Entities\ProjectType::TYPE_PROJECT_CONTROL_PRODUCT,
            'typeIssue' =>  \Zeedhi\DevOps\Model\Projectmanagement\Entities\ProjectType::TYPE_PROJECT_CONTROL_ISSUE,
            'deleted' =>  \Zeedhi\DevOps\Model\Projectmanagement\Entities\Project::STATUS_LOGICAL_DELETED,
            'active' =>  \Zeedhi\DevOps\Model\Projectmanagement\Entities\Project::IS_ACTIVE,
            'managerType' =>  \Zeedhi\DevOps\Model\Projectmanagement\Entities\ProjectType::TYPE_PRODUCT_CONTROL_MANAGEMENT
        );
        return $this->createAndExecuteQueryAndBuildResponseData($this->getEntityManager(), $query, $params);
    }

     public function findProductCallProductsNew($cdCliente,$filter = '') {
         $query =
             <<<SQL
SELECT * FROM (
         SELECT PRD.NMPRODUTO, 'MOBILE' AS PLATAFORMA, 'Zeedhi: App, Browser, Mobile' AS PLATAFORMA_NAME, PDO.PROJECT_ID, NULL AS SGSISTEMA, TO_CHAR(PDO.PROJECT_ID) AS PRODUCT_FILTER_ID
        FROM OM_PRODUTO_ORG PRO
        JOIN OM_PRODUTO PRD
        ON PRD.ID = PRO.NRPRODUTO_ID
        JOIN PRODUCT PDO
        ON PDO.ID = PRD.NREXTERNAL_PRODUCT_ID
        JOIN ORGANIZACAO ORG
        ON ORG.NRORG = PRO.NRORG_ID
        JOIN CLIENTE CLI
        ON CLI.NRPARCNEGOCIO = ORG.NRPARCNEGOCIO
        WHERE CLI.CDCLIENTE = :CDCLIENTE
        AND NOT EXISTS (SELECT ID
                         FROM OM_PRODUTO_ELEMENTO PEL
                        WHERE PEL.NRPRODUTO_ID = PRD.ID
                          AND PEL.CDSISTEMA IS NOT NULL)
        UNION ALL
        SELECT DISTINCT SIS.NMSISTEMA, 'DELPHI' AS PLATAFORMA, 'Delphi: Windows' AS PLATAFORMA_NAME, NULL AS PROJECT_ID, SIS.SGSISTEMA, TO_CHAR(SIS.SGSISTEMA) AS PRODUCT_FILTER_ID
        FROM ORGANIZACAO ORG
        JOIN CLIENTE CLI
        ON CLI.NRPARCNEGOCIO = ORG.NRPARCNEGOCIO
        JOIN CONTRATOLINP CLP
        ON CLP.CDCLIENTE = CLI.CDCLIENTE
        AND CLP.DTCONTLINPRESC IS NULL
        JOIN SISTCONTLINP SCL
        ON SCL.CDCLIENTE = CLP.CDCLIENTE
        AND SCL.CDLINPCLIE = CLP.CDLINPCLIE
        JOIN SISTEMA SIS
        ON SIS.CDSISTEMA = SCL.CDSISTEMA
        WHERE CLI.CDCLIENTE = :CDCLIENTE
        ORDER BY 2 DESC, 1)
        WHERE 1=1
        $filter

SQL;

         $params = array(
             "CDCLIENTE" => $cdCliente
         );

         $result = $this->getEntityManager()->getConnection()->fetchAll($query, $params);
         return $result;
     }

    /**
     * @param $cdCliente
     * @param $callType
     * @param $callRelationship
     * @param $cdprodcomp
     * @return array
     */
    public function findProductCallProductsNewNext($cdCliente,  $callType, $callRelationship, $cdprodcomp,$productFilterId) {
        $callTypeString = "";
        $partQueryNromal = <<<SQL
                   AND TS.CONTROL NOT IN(:concluded, :canceled)
                   AND PRD.PRODUCT_TYPE NOT IN (:managerType)
                   AND PTP.EXTERNALTYPE = :product
                   AND PTI.EXTERNALTYPE = :typeIssue
                   AND PRD.ORGANIZATION = :organizationId
                   AND PRD.STATUS = :active
SQL;

        if($callType){
            $callTypeString = " AND CALL_TYPE = :CALL_TYPE";
        }

        if($productFilterId){
            $callTypeString .= " AND PRODUCT_FILTER_ID = :PRODUCT_FILTER_ID";
            $partQueryNromal = " AND PRD.ID = :PRODUCT_FILTER_ID";
        }
        $query =
            <<<SQL
            SELECT * FROM (
            SELECT 'Mobile - '||PRD.NAME AS NMPRODUTO, 'I' AS CALL_TYPE, 'MOBILE' AS PLATAFORMA, 'Zeedhi: App, Browser, Mobile' AS PLATAFORMA_NAME,
                   PRD.ID, NULL AS SGSISTEMA, TO_CHAR(PRD.ID) AS PRODUCT_FILTER_ID
               FROM PROJECT PRD
                 JOIN PROJECT_TYPE PTP ON (PRD.PROJECT_TYPE = PTP.ID)
                 JOIN PROJECT ISS ON  ISS.PARENT = PRD.ID
                 JOIN PROJECT_TYPE PTI ON ISS.PROJECT_TYPE = PTI.ID
                 JOIN TASK_STATUS TS ON TS.ID = PRD.PROJECT_STATUS
                 WHERE  ISS.STATUS <> :deleted
                  $partQueryNromal
         UNION ALL
           SELECT DISTINCT 'Delphi - '||SIS.NMSISTEMA, 'S' AS CALL_TYPE, 'DELPHI' AS PLATAFORMA,
                                     'Delphi: Windows' AS PLATAFORMA_NAME, NULL AS PROJECT_ID,
                                      SIS.SGSISTEMA, SIS.SGSISTEMA AS PRODUCT_FILTER_ID
                                 FROM PARFILIALGEP PG, PRSUBGRPROD NV, PRODUTO PR, PRODUTO GRUP, SISTEMA SIS
                                WHERE (PG.CDFILIAL = '9999')
                                  AND (NV.CDFILISUBGR = '9999' OR NV.CDFILISUBGR = 'P')
                                  AND (PG.CDGRUPPROD = NV.CDGRUPPROD)
                                  AND (NV.CDPRODUTO = PR.CDPRODUTO)
                                  AND (PR.CDARVPROD LIKE GRUP.CDARVPROD||'%')
                                  AND (SIS.SGSISTEMA = SUBSTR(GRUP.CDARVPROD, -3))
                                  AND (GRUP.CDNVPRODUTO = '4')
                                ORDER BY 1)
        WHERE 1=1
        $callTypeString

SQL;

        $params = array(
            "NRSOLISERV" => $callRelationship,
            "CALL_TYPE" => $callType,
            "CDPRODCOMP" => $cdprodcomp,
            "PRODUCT_FILTER_ID" => $productFilterId,
            'organizationId' => 20,
            'concluded' => \Zeedhi\DevOps\Model\Projectmanagement\Entities\TaskStatus::TASK_STATUS_CONTROL_CONCLUDED,
            'canceled' =>  \Zeedhi\DevOps\Model\Projectmanagement\Entities\TaskStatus::TASK_STATUS_CONTROL_CANCELED,
            'product' =>  \Zeedhi\DevOps\Model\Projectmanagement\Entities\ProjectType::TYPE_PROJECT_CONTROL_PRODUCT,
            'typeIssue' =>  \Zeedhi\DevOps\Model\Projectmanagement\Entities\ProjectType::TYPE_PROJECT_CONTROL_ISSUE,
            'deleted' =>  \Zeedhi\DevOps\Model\Projectmanagement\Entities\Project::STATUS_LOGICAL_DELETED,
            'active' =>  \Zeedhi\DevOps\Model\Projectmanagement\Entities\Project::IS_ACTIVE,
            'managerType' =>  \Zeedhi\DevOps\Model\Projectmanagement\Entities\ProjectType::TYPE_PRODUCT_CONTROL_MANAGEMENT
        );
        return $this->createAndExecuteQueryAndBuildResponseData($this->getEntityManager(), $query, $params);
    }

    public function findCallBudget($nrsoliserv, $proposalTitle = 'Proposta' ,$discountTitle = 'Desconto',$lang = 'pt', $isTeknisa) {
        if($isTeknisa){
            $query =
                <<<SQL
            SELECT  '  '||'$proposalTitle' AS NRSOLISERV,
                   DECODE('$lang',
                          'en', I.NMITORCAINGL,
                          'es', I.NMITORCAESPA,
                          I.NMITORCAPROD) AS ITEM_NAME,
                   NVL(O.QTITORCSOCAL, 0)*3600 AS PROPOSAL_HOUR,
                   NVL(O.VRORCSOLICAL, 0) AS PROPOSAL_VALUE,
                   TO_CHAR(NVL(O.VRITORCACLIS, 0),'999G999G999G990D00', 'NLS_NUMERIC_CHARACTERS = '',.''') AS ITEM_VALUE,
                   I.CDITORCAPROD
            FROM SOLISERV S
            JOIN ORCASOLICITA O ON (O.CDFILIAL   = S.CDFILIAL AND O.NRSOLISERV = S.NRSOLISERV)
       LEFT JOIN ITEMORCAPROD I ON (I.CDITORCAPROD  = O.CDITORCAPROD)
       LEFT JOIN PRODITEMORCA P ON (P.CDPRODGRUP    = S.CDPRODGRUP AND P.CDITORCAPROD  = I.CDITORCAPROD)
            WHERE S.NRSOLISERV = :nrsoliserv

            UNION

            SELECT   ' '||'$discountTitle' AS NRSOLISERV,
              'Percentual : '||TO_CHAR(NVL(SOL.VRPEDESORCAM, '0'),'990D00', 'NLS_NUMERIC_CHARACTERS = '',.''')||'%' AS ITEM_NAME,
              0 AS PROPOSAL_HOUR,
               NVL(-SOL.VRDESCORCAM, 0) AS PROPOSAL_VALUE,
               ' ' AS ITEM_VALUE,
               '999999999999' AS CDITORCAPROD
            FROM
               SOLISERV SOL, CLIENTE CLI
            WHERE
               (SOL.NRSOLISERV = :nrsoliserv) AND
               (SOL.CDCLIENTE  = CLI.CDCLIENTE) AND
               TO_CHAR(NVL(SOL.VRPEDESORCAM, '0'),'990D00') <> 0
            ORDER BY CDITORCAPROD
SQL;
        } else {
            $query =
                <<<SQL
           SELECT   '  $proposalTitle' AS NRSOLISERV,
                    'Valor' AS ITEM_NAME,
                    SUM(NVL(O.VRORCSOLICAL, 0)) AS PROPOSAL_VALUE
            FROM SOLISERV S
            JOIN ORCASOLICITA O ON (O.CDFILIAL   = S.CDFILIAL AND O.NRSOLISERV = S.NRSOLISERV)
            WHERE S.NRSOLISERV = :nrsoliserv

            UNION

            SELECT  ' $discountTitle' AS NRSOLISERV,
                    'Percentual ('||TO_CHAR(NVL(SOL.VRPEDESORCAM, '0'),'990D00', 'NLS_NUMERIC_CHARACTERS = '',.''')||'%):' AS ITEM_NAME,
                    NVL(-SOL.VRDESCORCAM, 0) AS PROPOSAL_VALUE
            FROM
               SOLISERV SOL
            WHERE
               (SOL.NRSOLISERV = :nrsoliserv) AND
               TO_CHAR(NVL(SOL.VRPEDESORCAM, '0'),'990D00') <> 0
SQL;
        }

        $params = array(
            "nrsoliserv" => $nrsoliserv
        );

        $result = $this->getEntityManager()->getConnection()->fetchAll($query, $params);
        return $result;
    }

    public function updateSolicitationEndDate($updateParams){

        $connection = $this->getEntityManager()->getConnection();

        $update = "UPDATE SOLISERV
                    SET DTCOMPROMISS = :DTCOMPROMISS
                   WHERE NRSOLISERV = :NRSOLISERV
                   AND CDFILIAL = :CDFILIAL";

        try{
            $std = $this->getEntityManager()->getConnection()->prepare($update);
            $std->execute($updateParams);
        }
        catch(\Exception $e){
            throw $e;
        };

    }

    public function findSprintPeriodo($filter, $startPos = 0, $finalPos = 9999){
        $query = <<<SQL
SELECT * FROM (
        SELECT DISTINCT PRO.NAME, TO_CHAR(PRO.BEGIN_DATE, 'DD/MM/YYYY')||' - '||TO_CHAR(PRO.END_DATE, 'DD/MM/YYYY') AS PERIOD,
        PST.LABEL AS STATUS, PRO.ID, PRO.BEGIN_DATE
                    FROM PROJECT PRO
                    JOIN PROJECT_TYPE PTY ON(PTY.ID = PRO.PROJECT_TYPE AND PTY.EXTERNALTYPE in('Q','F'))
                    JOIN TASK_STATUS PST ON (PST.ID = PRO.PROJECT_STATUS AND PST.CONTROL NOT IN ('X'))
                    JOIN PROJECT_RELATIONSHIP PRR ON (PRR.PROJECT_RELATIONSHIP = PRO.ID AND PRR.TYPE = 'G')
                    JOIN PROJECT PRO2 ON (PRR.PROJECT = PRO2.ID)
                    JOIN PROJECT_TYPE PTY ON(PTY.ID = PRO2.PROJECT_TYPE AND PTY.EXTERNALTYPE = 'B')
                    WHERE PRO.ORGANIZATION = 20
                    AND PRO.STATUS = 'A'
                    AND PRO2.STATUS = 'A'
                    ORDER BY PRO.BEGIN_DATE DESC)
            WHERE 1 = 1
            $filter
SQL;

        $query = \Zeedhi\DevOps\Util\Utilities::getPaginatedQuery($query,$finalPos,$startPos);
        return $this->getEntityManager()->getConnection()->fetchAll($query);
    }

    public function validateTeknisaClienteSoli($cdoper, $cdoperesp, $cdclientebase) {
        $query = <<<SQL
        SELECT
        CASE
            WHEN OPR1.CDCLIENTE != :CDCLIENTE_BASE
                OR OPR2.CDCLIENTE != :CDCLIENTE_BASE THEN 'DIFERENTE'
            ELSE 'IGUAL'
        END AS RESULTADO
    FROM
        OPERADOR OPR1
        JOIN OPERADOR OPR2 ON OPR1.CDOPERADOR = :OPERADOR_RESPONSAVEL
                        AND OPR2.CDOPERADOR = :OPERADOR_CURRENT
SQL;

        $params = array(
            'OPERADOR_RESPONSAVEL' => $cdoperesp,
            'OPERADOR_CURRENT'     => $cdoper,
            'CDCLIENTE_BASE'       => $cdclientebase,
        );

        return $this->getEntityManager()->getConnection()->fetchAll($query, $params);
    }
}
