<?php
namespace Teknisa\Model\Teknisa\Repositories;
use OrganizationsManagement\Util\Utilities;


class OmIntegracoes extends \Doctrine\ORM\EntityRepository {
    
    public function getSMIntegrationUrl($nrorg)
    {
        $query = <<<SQL
		  SELECT ID, DSURLSM
		    FROM OM_INTEGRACOES
		   WHERE NRORG = :nrorg
SQL;
         $param = array(
            'nrorg' => $nrorg
        );
        return $this->getEntityManager()->getConnection()->fetchAll($query, $param);
    } 

    public function findSMParameters($nrorg, $filterString = '')
    {
        $query = <<<SQL
    SELECT *
      FROM (SELECT
                PARAM.NRPARAMETROGERAL,
                PARAM.IDINTEGRACAOOM,
                PARAM.URLINTEGRACAOOM,
                PARAM.IDCONVERSAOPROSPECT,
                PARAM.IDCONVCLIENTE,
                PARAM.IDINTEGRACAOCRM,
                PARAM.URLINTEGRACAOCRM,
                PARAM.NRORCAMODELOCUST,
                MODPRO.NMORCAMENTOMODELO AS NMORCAMODELOCUST,
                PARAM.CDPRECBASESERVCUST,
                PRECO.DSPRECBASESERV AS DSPRECBASESERVCUST,
                PARAM.VRPERCMANUCUST ,
                PARAM.CDSERVMANUCUST,
                PARAM.NRTIPOORCAMENTOCUST,
                TPORC.NRTIPOORCAMENTO,
                TPORC.NMTIPOORCAMENTO,
                SRORC.NMSERVORCA,
                (SELECT rtrim(xmlagg(xmlelement(e, CLICUST.CDCLIENTE ,',').extract('//text()') order by CLICUST.CDCLIENTE).GetClobVal(),',') AS CDCLIENTE
                            FROM OM_CLIENTE_CUSTOMIZACAO CLICUST
                            WHERE CLICUST.NRORG = :NRORG) AS CDCLIENTE
            FROM FCT_PARAMETROGERAL PARAM
            LEFT JOIN FCT_ORCAMENTOMODELO MODPRO ON PARAM.NRORCAMODELOCUST = MODPRO.NRORCAMENTOMODELO
                                                AND PARAM.NRORG = MODPRO.NRORG
            LEFT JOIN FCT_PRECBASESERV PRECO ON PARAM.CDPRECBASESERVCUST = PRECO.CDPRECBASESERV
                                            AND PARAM.NRORG = PRECO.NRORG 
            LEFT JOIN FCT_TIPOORCAMENTO TPORC ON PARAM.NRTIPOORCAMENTOCUST = TPORC.NRTIPOORCAMENTO
                                            AND PARAM.NRORG = TPORC.NRORG 
            LEFT JOIN FCT_SERVICOORCA SRORC ON PARAM.CDSERVMANUCUST = SRORC.CDSERVORCA
                                            AND PARAM.NRORG = SRORC.NRORG
            WHERE PARAM.NRORG = :NRORG
         )
      WHERE 1=1
         $filterString
SQL;
        $params = array(
            "NRORG" => $nrorg
        );

        $dados = $this->getEntityManager()->getConnection()->fetchAll($query, $params);

        foreach($dados as &$dado){

            $dado['CDCLIENTE'] =  explode(",",$dado['CDCLIENTE']);
        }
        return $dados;
    }

    public function findBudgetModel($filterString = '')
    {
        $query = <<<SQL
       SELECT *
         FROM FCT_ORCAMENTOMODELO
         WHERE 1=1 $filterString
SQL;
        return $this->getEntityManager()->getConnection()->fetchAll($query);

    }
    public function priceCustomization($filterString = '')
    {
        $query = <<<SQL
       SELECT *
         FROM FCT_PRECBASESERV
         WHERE 1=1 $filterString
SQL;
        return $this->getEntityManager()->getConnection()->fetchAll($query);

    }

    public function findServicoOrca($params, $filterString = '', $limit, $offset)
    {
        $query = <<<SQL
        SELECT *
          FROM (SELECT CDSERVORCA, NMSERVORCA, DSSERVORCA, IDLICENUSOMANUT, IDATIVO
                  FROM FCT_SERVICOORCA
                 WHERE NRORG = :nrorg)
         WHERE 1 = 1
            $filterString
SQL;

        $query = Utilities::getPaginatedQuery($query, $limit, $offset);
        return $this->getEntityManager()->getConnection()->fetchAll($query, $params);
    }

    public function findProductLineServOrca($params)
    {
        $query = <<<SQL
        SELECT 
               (SELECT DISTINCT LISTAGG(NRTIPOORCAMENTO, ',') WITHIN GROUP (ORDER BY NRTIPOORCAMENTO) AS NRTIPOORCAMENTO
                  FROM FCT_ESCFATUREXCOM
                 WHERE NRORG = :nrorg) AS BILLING_SCOPE_TERMINATION,

                 (SELECT DISTINCT LISTAGG(NRTIPOORCAMENTO, ',') WITHIN GROUP (ORDER BY NRTIPOORCAMENTO) AS NRTIPOORCAMENTO
                  FROM FCT_ESCFATUEDITELEM
                 WHERE NRORG = :nrorg) AS BILLING_SCOPE_EDIT_ELEMENT,

                 (SELECT DISTINCT LISTAGG(CDSERVORCA, ',') WITHIN GROUP (ORDER BY CDSERVORCA) AS CDSERVORCA
                  FROM FCT_SERVICOORCA
                 WHERE FCT_SERVICOORCA.IDLICENUSOMANUT = 'M'
                   AND FCT_SERVICOORCA.IDATIVO = 'S'
                   AND NRORG = :nrorg) AS MAINTENANCE,

                   (SELECT DISTINCT LISTAGG(CDSERVORCA, ',') WITHIN GROUP (ORDER BY CDSERVORCA) AS CDSERVORCA
                  FROM FCT_SERVICOORCA
                 WHERE FCT_SERVICOORCA.IDLICENUSOMANUT = 'L'
                   AND FCT_SERVICOORCA.IDATIVO = 'S'
                   AND NRORG = :nrorg) AS USE_LICENSE

          FROM dual
SQL;

        return $this->getEntityManager()->getConnection()->fetchAll($query, $params);
    }

    public function findTipoOrcamento($params, $filterString = '', $limit, $offset)
    {
        $query = <<<SQL
        SELECT *
          FROM (SELECT NRTIPOORCAMENTO, NMTIPOORCAMENTO, IDATIVO
                  FROM FCT_TIPOORCAMENTO
                 WHERE NRORG = :nrorg)
         WHERE 1 = 1
            $filterString
SQL;

        $query = Utilities::getPaginatedQuery($query, $limit, $offset);
        return $this->getEntityManager()->getConnection()->fetchAll($query, $params);
    }
    
    public function findEscoposRescisao($params, $filterString = '', $limit, $offset)
    {
        $query = <<<SQL
        
 
        SELECT *
          FROM (SELECT FCT_ESCFATUREXCOM.NRESCFATUREXCOM, FCT_ESCFATUREXCOM.NRTIPOORCAMENTO, FCT_TIPOORCAMENTO.NMTIPOORCAMENTO
                  FROM FCT_ESCFATUREXCOM
                  JOIN FCT_TIPOORCAMENTO 
                    ON FCT_TIPOORCAMENTO.NRTIPOORCAMENTO = FCT_ESCFATUREXCOM.NRTIPOORCAMENTO
                 WHERE FCT_ESCFATUREXCOM.NRORG = :nrorg)
         WHERE 1 = 1
         $filterString
SQL;

        $query = Utilities::getPaginatedQuery($query, $limit, $offset);
        return $this->getEntityManager()->getConnection()->fetchAll($query, $params);
    }
    
    public function findCliente($params, $filterString = '', $limit, $offset)
    {
        $query = <<<SQL
        SELECT *
          FROM (SELECT CDCLIENTE, NMRAZSOCCLIE
                  FROM CLIENTE
                 WHERE IDCLIEATIV = 'S'
                  AND NRORG = :nrorg)
         WHERE 1 = 1
            $filterString
SQL;

        $query = Utilities::getPaginatedQuery($query, $limit, $offset);
        return $this->getEntityManager()->getConnection()->fetchAll($query, $params);
    }


    public function findCdaParameters()
    {
        $query = <<<SQL
        SELECT  (SELECT DISTINCT LISTAGG(NRTIPOMOTIVOAGEND, ',') WITHIN GROUP (ORDER BY NRTIPOMOTIVOAGEND) AS NRTIPOMOTIVOAGEND
                  FROM OM_TPMOTIVOAGENDCOMISS) AS NRTIPOMOTIVOAGEND
          FROM dual
SQL;
        return $this->getEntityManager()->getConnection()->fetchAll($query);
    }

    public function removeCdaParameters()
    {
        $query = <<<SQL
        DELETE FROM OM_TPMOTIVOAGENDCOMISS
SQL;

        return $this->getEntityManager()->getConnection()->executeQuery($query);
    }

    public function saveCdaParameters($params)
    {
        $query = <<<SQL
            INSERT INTO OM_TPMOTIVOAGENDCOMISS (NRTPMOTIVOAGENDCOMISS, NRTIPOMOTIVOAGEND)
                 VALUES (:NRTPMOTIVOAGENDCOMISS, :NRTIPOMOTIVOAGEND)
SQL;
        return $this->getEntityManager()->getConnection()->executeQuery($query, $params);
    }

    public function findTipoMotivoCDA($filterString = '', $limit, $offset)
    {
        $query = <<<SQL
        SELECT *
          FROM (SELECT NRTIPOMOTIVOAGEND, NMTIPOMOTIVOAGEND
                  FROM FCT_TIPOMOTIVOAGEND)
         WHERE 1 = 1
            $filterString
SQL;

        $query = Utilities::getPaginatedQuery($query, $limit, $offset);
        return $this->getEntityManager()->getConnection()->fetchAll($query);
    }

}